//
// Copyright (c) 2013, Red Hat Inc.
// Copyright (c) 2003, 2012, Oracle and/or its affiliates.
// All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_aarch64.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "memory/allocation.inline.hpp"
#include "asm/macroAssembler.inline.hpp"
#include "code/compiledIC.hpp"
#include "code/vmreg.hpp"
#include "gc_interface/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/markOop.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "oops/oop.inline2.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "assembler_aarch64.inline.hpp"
#include "nativeInst_aarch64.hpp"
#include "vmreg_aarch64.inline.hpp"

//SourceForm

#line 967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"


#define __ _masm.

// advance declaratuons for helper functions to convert register
// indices to register objects

// the ad file has to provide implementations of certain methods
// expected by the generic code
//
// REQUIRED FUNCTIONALITY

//=============================================================================

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

int MachCallStaticJavaNode::ret_addr_offset()
{
  // call should be a simple bl
  // unless this is a method handle invoke in which case it is
  // mov(rfp, sp), bl, mov(sp, rfp)
  int off = 4;
  if (_method_handle_invoke) {
    off += 4;
  }
  return off;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  return 16; // movz, movk, movk, bl
}

int MachCallRuntimeNode::ret_addr_offset() {
  // for generated stubs the call will be
  //   bl(addr)
  // for real runtime callouts it will be six instructions
  // see aarch64_enc_java_to_runtime
  //   adr(rscratch2, retaddr)
  //   lea(rscratch1, RuntimeAddress(addr)
  //   stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)))
  //   blrt rscratch1
  CodeBlob *cb = CodeCache::find_blob(_entry_point);
  if (cb) {
    return 4;
  } else {
    return 6 * NativeInstruction::instruction_size;
  }
}

// Indicate if the safepoint node needs the polling page as an input

// the shared code plants the oop data at the start of the generated
// code for the safepoint node and that needs ot be at the load
// instruction itself. so we cannot plant a mov of the safepoint poll
// address followed by a load. setting this to true means the mov is
// scheduled as a prior instruction. that's better for scheduling
// anyway.

bool SafePointNode::needs_polling_address_input()
{
  return true;
}

//=============================================================================

#ifndef PRODUCT
void MachBreakpointNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  st->print("BREAKPOINT");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);
  __ brk(0);
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    MacroAssembler _masm(&cbuf);
    for (int i = 0; i < _count; i++) { 
      __ nop();
    }
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count * NativeInstruction::instruction_size;
  }

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int Compile::ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("-- \t// MachConstantBaseNode (empty encoding)");
}
#endif

#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;

  int framesize = C->frame_slots() << LogBytesPerInt;

  if (C->need_stack_bang(framesize))
    st->print("# stack bang size=%d\n\t", framesize);

  if (framesize == 0) {
    // Is this even possible?
    st->print("stp  lr, rfp, [sp, #%d]!", -(2 * wordSize)); 
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("sub  sp, sp, #%d\n\t", framesize);
    st->print("stp  rfp, lr, [sp, #%d]", framesize - 2 * wordSize);
  } else {
    st->print("stp  lr, rfp, [sp, #%d]!\n\t", -(2 * wordSize)); 
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("sub  sp, sp, rscratch1");
  }
}
#endif

void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);

  // n.b. frame size includes space for return pc and rfp
  long framesize = ((long)C->frame_slots()) << LogBytesPerInt;
  assert(framesize%(2*wordSize) == 0, "must preserve 2*wordSize alignment");

  // insert a nop at the start of the prolog so we can patch in a
  // branch if we need to invalidate the method later
  __ nop();

  if (C->need_stack_bang(framesize))
    __ generate_stack_overflow_check(framesize);

  __ build_frame(framesize);

  if (NotifySimulator) {
    __ notify(Assembler::method_entry);
  }

  if (VerifyStackAtCalls) {
    Unimplemented();
  }

  C->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    Compile::ConstantTable& constant_table = C->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0;
}

//=============================================================================

#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;
  int framesize = C->frame_slots() << LogBytesPerInt;

  st->print("# pop frame %d\n\t",framesize);

  if (framesize == 0) {
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("ldp  lr, rfp, [sp,#%d]\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, #%d\n\t", framesize);
  } else {
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, rscratch1\n\t");
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  }

  if (do_polling() && C->is_method_compilation()) {
    st->print("# touch polling page\n\t");
    st->print("mov  rscratch1, #" INTPTR_FORMAT "\n\t", p2i(os::get_polling_page()));
    st->print("ldr zr, [rscratch1]");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);
  int framesize = C->frame_slots() << LogBytesPerInt;

  __ remove_frame(framesize);

  if (NotifySimulator) {
    __ notify(Assembler::method_reentry);
  }

  if (do_polling() && C->is_method_compilation()) {
    __ read_polling_page(rscratch1, os::get_polling_page(), relocInfo::poll_return_type);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // 1 for polling page.
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

// This method seems to be obsolete. It is declared in machnode.hpp
// and defined in all *.ad files, but it is never called. Should we
// get rid of it?
int MachEpilogNode::safepoint_offset() const {
  assert(do_polling(), "no return for this epilog node");
  return 4;
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float or
// rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // we have 30 int registers * 2 halves
  // (rscratch1 and rscratch2 are omitted)

  if (reg < 60) {
    return rc_int;
  }

  // we have 32 float register * 2 halves
  if (reg < 60 + 128) {
    return rc_float;
  }

  // Between float regs & stack is the flags regs.
  assert(OptoReg::is_stack(reg), "blow up if spilling flags");

  return rc_stack;
}

uint MachSpillCopyNode::implementation(CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream *st) const {
  Compile* C = ra_->C;

  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");

  if (src_hi != OptoReg::Bad) {
    assert((src_lo&1)==0 && src_lo+1==src_hi &&
           (dst_lo&1)==0 && dst_lo+1==dst_hi,
           "expected aligned-adjacent pairs");
  }

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  bool is64 = (src_lo & 1) == 0 && src_lo + 1 == src_hi &&
              (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi;
  int src_offset = ra_->reg2offset(src_lo);
  int dst_offset = ra_->reg2offset(dst_lo);

  if (bottom_type()->isa_vect() != NULL) {
    uint ireg = ideal_reg();
    assert(ireg == Op_VecD || ireg == Op_VecX, "must be 64 bit or 128 bit vector");
    if (cbuf) {
      MacroAssembler _masm(cbuf);
      assert((src_lo_rc != rc_int && dst_lo_rc != rc_int), "sanity");
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack->stack
        assert((src_offset & 7) && (dst_offset & 7), "unaligned stack offset");
        if (ireg == Op_VecD) {
          __ unspill(rscratch1, true, src_offset);
          __ spill(rscratch1, true, dst_offset);
        } else {
          __ spill_copy128(src_offset, dst_offset);
        }
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_float) {
        __ mov(as_FloatRegister(Matcher::_regEncode[dst_lo]),
               ireg == Op_VecD ? __ T8B : __ T16B,
               as_FloatRegister(Matcher::_regEncode[src_lo]));
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_stack) {
        __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                       ireg == Op_VecD ? __ D : __ Q,
                       ra_->reg2offset(dst_lo));
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_float) {
        __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                       ireg == Op_VecD ? __ D : __ Q,
                       ra_->reg2offset(src_lo));
      } else {
        ShouldNotReachHere();
      }
    }
  } else if (cbuf) {
    MacroAssembler _masm(cbuf);
    switch (src_lo_rc) {
    case rc_int:
      if (dst_lo_rc == rc_int) {  // gpr --> gpr copy
        if (is64) {
            __ mov(as_Register(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else {
            MacroAssembler _masm(cbuf);
            __ movw(as_Register(Matcher::_regEncode[dst_lo]),
                    as_Register(Matcher::_regEncode[src_lo]));
        }
      } else if (dst_lo_rc == rc_float) { // gpr --> fpr copy
        if (is64) {
            __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_Register(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_Register(Matcher::_regEncode[src_lo]));
        }
      } else {                    // gpr --> stack spill
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ spill(as_Register(Matcher::_regEncode[src_lo]), is64, dst_offset);
      }
      break;
    case rc_float:
      if (dst_lo_rc == rc_int) {  // fpr --> gpr copy
        if (is64) {
            __ fmovd(as_Register(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_Register(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        }
      } else if (dst_lo_rc == rc_float) { // fpr --> fpr copy
          if (cbuf) {
            __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        }
      } else {                    // fpr --> stack spill
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                 is64 ? __ D : __ S, dst_offset);
      }
      break;
    case rc_stack:
      if (dst_lo_rc == rc_int) {  // stack --> gpr load
        __ unspill(as_Register(Matcher::_regEncode[dst_lo]), is64, src_offset);
      } else if (dst_lo_rc == rc_float) { // stack --> fpr load
        __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   is64 ? __ D : __ S, src_offset);
      } else {                    // stack --> stack copy
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ unspill(rscratch1, is64, src_offset);
        __ spill(rscratch1, is64, dst_offset);
      }
      break;
    default:
      assert(false, "bad rc_class for spill");
      ShouldNotReachHere();
    }
  }

  if (st) {
    st->print("spill ");
    if (src_lo_rc == rc_stack) {
      st->print("[sp, #%d] -> ", ra_->reg2offset(src_lo));
    } else {
      st->print("%s -> ", Matcher::regName[src_lo]);
    }
    if (dst_lo_rc == rc_stack) {
      st->print("[sp, #%d]", ra_->reg2offset(dst_lo));
    } else {
      st->print("%s", Matcher::regName[dst_lo]);
    }
    if (bottom_type()->isa_vect() != NULL) {
      st->print("\t# vector spill size = %d", ideal_reg()==Op_VecD ? 64:128);
    } else {
      st->print("\t# spill size = %d", is64 ? 64:32);
    }
  }

  return 0;

}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  if (!ra_)
    st->print("N%d = SpillCopy(N%d)", _idx, in(1)->_idx);
  else
    implementation(NULL, ra_, false, st);
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation(&cbuf, ra_, false, NULL);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("add %s, rsp, #%d]\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);

  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg    = ra_->get_encode(this);

  if (Assembler::operand_valid_for_add_sub_immediate(offset)) {
    __ add(as_Register(reg), sp, offset);
  } else {
    ShouldNotReachHere();
  }
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_).
  return 4;
}

//=============================================================================

#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  st->print_cr("# MachUEPNode");
  if (UseCompressedClassPointers) {
    st->print_cr("\tldrw rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    if (Universe::narrow_klass_shift() != 0) {
      st->print_cr("\tdecode_klass_not_null rscratch1, rscratch1");
    }
  } else {
   st->print_cr("\tldr rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
  }
  st->print_cr("\tcmp r0, rscratch1\t # Inline cache check");
  st->print_cr("\tbne, SharedRuntime::_ic_miss_stub");
}
#endif

void MachUEPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const
{
  // This is the unverified entry point.
  MacroAssembler _masm(&cbuf);

  // no need to worry about 4-byte of br alignment on AArch64
  __ cmp_klass(j_rarg0, rscratch2, rscratch1);
  Label skip;
  // TODO
  // can we avoid this skip and still use a reloc?
  __ br(Assembler::EQ, skip);
  __ b(RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  __ bind(skip);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_);
}

// REQUIRED EMIT CODE

//=============================================================================

// Emit exception handler code.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf)
{
  // mov rscratch1 #exception_blob_entry_point
  // br rscratch1
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_exception_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();
  __ b(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf)
{
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_deopt_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();

  __ adr(lr, __ pc());
  // should we load this into rscratch1 and use a br?
  __ b(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));

  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// REQUIRED MATCHER CODE

//=============================================================================

const bool Matcher::match_rule_supported(int opcode) {

  // TODO 
  // identify extra cases that we might want to provide match rules for
  // e.g. Op_StrEquals and other intrinsics
  if (!has_match_rule(opcode)) {
    return false;
  }

  return true;  // Per default match rules are supported.
}

int Matcher::regnum_to_fpu_offset(int regnum)
{
  Unimplemented();
  return 0;
}

bool Matcher::is_short_branch_offset(int rule, int br_size, int offset)
{
  Unimplemented();
  return false;
}

const bool Matcher::isSimpleConstant64(jlong value) {
  // Will one (StoreL ConL) be cheaper than two (StoreI ConI)?.
  // Probably always true, even if a temp register is required.
  return true;
}

// true just means we have fast l2f conversion
const bool Matcher::convL2FSupported(void) {
  return true;
}

// Vector width in bytes.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  int size = MIN2(16,(int)MaxVectorSize);
  // Minimum 2 values in vector
  if (size < 2*type2aelembytes(bt)) size = 0;
  // But never < 4
  if (size < 4) size = 0;
  return size;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}
const int Matcher::min_vector_size(const BasicType bt) {
//  For the moment limit the vector size to 8 bytes
    int size = 8 / type2aelembytes(bt);
    if (size < 2) size = 2;
    return size;
}

// Vector ideal reg.
const int Matcher::vector_ideal_reg(int len) {
  switch(len) {
    case  8: return Op_VecD;
    case 16: return Op_VecX;
  }
  ShouldNotReachHere();
  return 0;
}

const int Matcher::vector_shift_count_ideal_reg(int size) {
  return Op_VecX;
}

// AES support not yet implemented
const bool Matcher::pass_original_key_for_aes() {
  return false;
}

// x86 supports misaligned vectors store/load.
const bool Matcher::misaligned_vectors_ok() {
  return !AlignVector; // can be changed by flag
}

// false => size gets scaled to BytesPerLong, ok.
const bool Matcher::init_array_count_is_in_bytes = false;

// Threshold size for cleararray.
const int Matcher::init_array_short_size = 18 * BytesPerLong;

// Use conditional move (CMOVL)
const int Matcher::long_cmove_cost() {
  // long cmoves are no more expensive than int cmoves
  return 0;
}

const int Matcher::float_cmove_cost() {
  // float cmoves are no more expensive than int cmoves
  return 0;
}

// Does the CPU require late expand (see block.cpp for description of late expand)?
const bool Matcher::require_postalloc_expand = false;

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?  True for Intel but false for most RISCs
const bool Matcher::clone_shift_expressions = false;

// Do we need to mask the count passed to shift instructions or does
// the cpu only look at the lower 5/6 bits anyway?
const bool Matcher::need_masked_shift_count = false;

// This affects two different things:
//  - how Decode nodes are matched
//  - how ImplicitNullCheck opportunities are recognized
// If true, the matcher will try to remove all Decodes and match them
// (as operands) into nodes. NullChecks are not prepared to deal with 
// Decodes by final_graph_reshaping().
// If false, final_graph_reshaping() forces the decode behind the Cmp
// for a NullCheck. The matcher matches the Decode node into a register.
// Implicit_null_check optimization moves the Decode along with the 
// memory operation back up before the NullCheck.
bool Matcher::narrow_oop_use_complex_address() {
  return Universe::narrow_oop_shift() == 0;
}

bool Matcher::narrow_klass_use_complex_address() {
// TODO
// decide whether we need to set this to true
  return false;
}

// Is it better to copy float constants, or load them directly from
// memory?  Intel can load a float constant from a direct address,
// requiring no extra registers.  Most RISCs will have to materialize
// an address into a register first, so they would do better to copy
// the constant from stack.
const bool Matcher::rematerialize_float_constants = false;

// If CPU can load and store mis-aligned doubles directly then no
// fixup is needed.  Else we split the double into 2 integer pieces
// and move it piece-by-piece.  Only happens when passing doubles into
// C code as the Java calling convention forces doubles to be aligned.
const bool Matcher::misaligned_doubles_ok = true;

// No-op on amd64
void Matcher::pd_implicit_null_fixup(MachNode *node, uint idx) {
  Unimplemented();
}

// Advertise here if the CPU requires explicit rounding operations to
// implement the UseStrictFP mode.
const bool Matcher::strict_fp_requires_explicit_rounding = false;

// Are floats converted to double when stored to stack during
// deoptimization?
bool Matcher::float_in_double() { return true; }

// Do ints take an entire long register or just half?
// The relevant question is how the int is callee-saved:
// the whole long is written but de-opt'ing will have to extract
// the relevant 32 bits.
const bool Matcher::int_in_long = true;

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  R0_num || reg == R0_H_num ||
    reg ==  R1_num || reg == R1_H_num ||
    reg ==  R2_num || reg == R2_H_num ||
    reg ==  R3_num || reg == R3_H_num ||
    reg ==  R4_num || reg == R4_H_num ||
    reg ==  R5_num || reg == R5_H_num ||
    reg ==  R6_num || reg == R6_H_num ||
    reg ==  R7_num || reg == R7_H_num ||
    reg ==  V0_num || reg == V0_H_num ||
    reg ==  V1_num || reg == V1_H_num ||
    reg ==  V2_num || reg == V2_H_num ||
    reg ==  V3_num || reg == V3_H_num ||
    reg ==  V4_num || reg == V4_H_num ||
    reg ==  V5_num || reg == V5_H_num ||
    reg ==  V6_num || reg == V6_H_num ||
    reg ==  V7_num || reg == V7_H_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI.
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL.
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL.
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

// helper for encoding java_to_runtime calls on sim
//
// this is needed to compute the extra arguments required when
// planting a call to the simulator blrt instruction. the TypeFunc
// can be queried to identify the counts for integral, and floating
// arguments and the return type

static void getCallInfo(const TypeFunc *tf, int &gpcnt, int &fpcnt, int &rtype)
{
  int gps = 0;
  int fps = 0;
  const TypeTuple *domain = tf->domain();
  int max = domain->cnt();
  for (int i = TypeFunc::Parms; i < max; i++) {
    const Type *t = domain->field_at(i);
    switch(t->basic_type()) {
    case T_FLOAT:
    case T_DOUBLE:
      fps++;
    default:
      gps++;
    }
  }
  gpcnt = gps;
  fpcnt = fps;
  BasicType rt = tf->return_type();
  switch (rt) {
  case T_VOID:
    rtype = MacroAssembler::ret_type_void;
    break;
  default:
    rtype = MacroAssembler::ret_type_integral;
    break;
  case T_FLOAT:
    rtype = MacroAssembler::ret_type_float;
    break;
  case T_DOUBLE:
    rtype = MacroAssembler::ret_type_double;
    break;
  }
}

#define MOV_VOLATILE(REG, BASE, INDEX, SCALE, DISP, SCRATCH, INSN)	\
  MacroAssembler _masm(&cbuf);						\
  {									\
    guarantee(INDEX == -1, "mode not permitted for volatile");		\
    guarantee(DISP == 0, "mode not permitted for volatile");		\
    guarantee(SCALE == 0, "mode not permitted for volatile");		\
    __ INSN(REG, as_Register(BASE));					\
  }

typedef void (MacroAssembler::* mem_insn)(Register Rt, const Address &adr);
typedef void (MacroAssembler::* mem_float_insn)(FloatRegister Rt, const Address &adr);
typedef void (MacroAssembler::* mem_vector_insn)(FloatRegister Rt,
                                  MacroAssembler::SIMD_RegVariant T, const Address &adr);

  // Used for all non-volatile memory accesses.  The use of
  // $mem->opcode() to discover whether this pattern uses sign-extended
  // offsets is something of a kludge.
  static void loadStore(MacroAssembler masm, mem_insn insn,
			 Register reg, int opcode,
			 Register base, int index, int size, int disp)
  {
    Address::extend scale;

    // Hooboy, this is fugly.  We need a way to communicate to the
    // encoder that the index needs to be sign extended, so we have to
    // enumerate all the cases.
    switch (opcode) {
    case INDINDEXSCALEDOFFSETI2L:
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDOFFSETI2LN:
    case INDINDEXSCALEDI2LN:
    case INDINDEXOFFSETI2L:
    case INDINDEXOFFSETI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      (masm.*insn)(reg, Address(base, disp));
    } else {
      if (disp == 0) {
	(masm.*insn)(reg, Address(base, as_Register(index), scale));
      } else {
	masm.lea(rscratch1, Address(base, disp));
	(masm.*insn)(reg, Address(rscratch1, as_Register(index), scale));
      }
    }
  }

  static void loadStore(MacroAssembler masm, mem_float_insn insn,
			 FloatRegister reg, int opcode,
			 Register base, int index, int size, int disp)
  {
    Address::extend scale;

    switch (opcode) {
    case INDINDEXSCALEDOFFSETI2L:
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDOFFSETI2LN:
    case INDINDEXSCALEDI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

     if (index == -1) {
      (masm.*insn)(reg, Address(base, disp));
    } else {
      if (disp == 0) {
	(masm.*insn)(reg, Address(base, as_Register(index), scale));
      } else {
	masm.lea(rscratch1, Address(base, disp));
	(masm.*insn)(reg, Address(rscratch1, as_Register(index), scale));
      }
    }
  }

  static void loadStore(MacroAssembler masm, mem_vector_insn insn,
                         FloatRegister reg, MacroAssembler::SIMD_RegVariant T,
                         int opcode, Register base, int index, int size, int disp)
  {
    if (index == -1) {
      (masm.*insn)(reg, T, Address(base, disp));
    } else {
      assert(disp == 0, "unsupported address mode");
      (masm.*insn)(reg, T, Address(base, as_Register(index), Address::lsl(size)));
    }
  }


#line 994 "../generated/adfiles/ad_aarch64.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( INSN_COST == 100, "Expect (100) to equal 100");
  assert( BRANCH_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( CALL_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( VOLATILE_REF_COST == 1000, "Expect (10 * INSN_COST) to equal 1000");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'N', // R27
  'N', // R27_H
  'N', // R28
  'N', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'C', // V8
  'C', // V8_H
  'C', // V8_J
  'C', // V8_K
  'C', // V9
  'C', // V9_H
  'C', // V9_J
  'C', // V9_K
  'C', // V10
  'C', // V10_H
  'C', // V10_J
  'C', // V10_K
  'C', // V11
  'C', // V11_H
  'C', // V11_J
  'C', // V11_K
  'C', // V12
  'C', // V12_H
  'C', // V12_J
  'C', // V12_K
  'C', // V13
  'C', // V13_H
  'C', // V13_J
  'C', // V13_K
  'C', // V14
  'C', // V14_H
  'C', // V14_J
  'C', // V14_K
  'C', // V15
  'C', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'E', // R19
  'E', // R19_H
  'E', // R20
  'E', // R20_H
  'E', // R21
  'E', // R21_H
  'E', // R22
  'E', // R22_H
  'E', // R23
  'E', // R23_H
  'E', // R24
  'E', // R24_H
  'E', // R25
  'E', // R25_H
  'E', // R26
  'E', // R26_H
  'E', // R27
  'E', // R27_H
  'E', // R28
  'E', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'C', // V8
  'C', // V8_H
  'C', // V8_J
  'C', // V8_K
  'C', // V9
  'C', // V9_H
  'C', // V9_J
  'C', // V9_K
  'C', // V10
  'C', // V10_H
  'C', // V10_J
  'C', // V10_K
  'C', // V11
  'C', // V11_H
  'C', // V11_J
  'C', // V11_K
  'C', // V12
  'C', // V12_H
  'C', // V12_J
  'C', // V12_K
  'C', // V13
  'C', // V13_H
  'C', // V13_J
  'C', // V13_K
  'C', // V14
  'C', // V14_H
  'C', // V14_J
  'C', // V14_K
  'C', // V15
  'C', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immI_le_4_rule,
  /*   13 */  immI_31_rule,
  /*   14 */  immI_8_rule,
  /*   15 */  immI_16_rule,
  /*   16 */  immI_24_rule,
  /*   17 */  immI_32_rule,
  /*   18 */  immI_48_rule,
  /*   19 */  immI_56_rule,
  /*   20 */  immI_64_rule,
  /*   21 */  immI_255_rule,
  /*   22 */  immI_65535_rule,
  /*   23 */  immL_63_rule,
  /*   24 */  immL_255_rule,
  /*   25 */  immL_65535_rule,
  /*   26 */  immL_4294967295_rule,
  /*   27 */  immL_bitmask_rule,
  /*   28 */  immI_bitmask_rule,
  /*   29 */  immIScale_rule,
  /*   30 */  immI26_rule,
  /*   31 */  immI19_rule,
  /*   32 */  immIU12_rule,
  /*   33 */  immLU12_rule,
  /*   34 */  immIOffset_rule,
  /*   35 */  immLoffset_rule,
  /*   36 */  immIAddSub_rule,
  /*   37 */  immILog_rule,
  /*   38 */  immL_rule,
  /*   39 */  immL0_rule,
  /*   40 */  immL_1_rule,
  /*   41 */  immL_M1_rule,
  /*   42 */  immL_pc_off_rule,
  /*   43 */  immLAddSub_rule,
  /*   44 */  immLLog_rule,
  /*   45 */  immL_32bits_rule,
  /*   46 */  immP_rule,
  /*   47 */  immP0_rule,
  /*   48 */  immP_1_rule,
  /*   49 */  immPollPage_rule,
  /*   50 */  immByteMapBase_rule,
  /*   51 */  immP_M1_rule,
  /*   52 */  immP_M2_rule,
  /*   53 */  immD_rule,
  /*   54 */  immD0_rule,
  /*   55 */  immDPacked_rule,
  /*   56 */  immF_rule,
  /*   57 */  immF0_rule,
  /*   58 */  immFPacked_rule,
  /*   59 */  immN_rule,
  /*   60 */  immN0_rule,
  /*   61 */  immNKlass_rule,
  /*   62 */  iRegI_rule,
  /*   63 */  iRegINoSp_rule,
  /*   64 */  iRegL_rule,
  /*   65 */  iRegLNoSp_rule,
  /*   66 */  iRegP_rule,
  /*   67 */  iRegPNoSp_rule,
  /*   68 */  iRegP_R0_rule,
  /*   69 */  iRegP_R1_rule,
  /*   70 */  iRegP_R2_rule,
  /*   71 */  iRegP_R3_rule,
  /*   72 */  iRegP_R4_rule,
  /*   73 */  iRegP_R5_rule,
  /*   74 */  iRegP_R10_rule,
  /*   75 */  iRegL_R11_rule,
  /*   76 */  iRegP_FP_rule,
  /*   77 */  iRegI_R0_rule,
  /*   78 */  iRegI_R2_rule,
  /*   79 */  iRegI_R3_rule,
  /*   80 */  iRegI_R4_rule,
  /*   81 */  iRegN_rule,
  /*   82 */  iRegNNoSp_rule,
  /*   83 */  iRegIHeapbase_rule,
  /*   84 */  vRegF_rule,
  /*   85 */  vRegD_rule,
  /*   86 */  vecD_rule,
  /*   87 */  vecX_rule,
  /*   88 */  vRegD_V0_rule,
  /*   89 */  vRegD_V1_rule,
  /*   90 */  vRegD_V2_rule,
  /*   91 */  vRegD_V3_rule,
  /*   92 */  rFlagsReg_rule,
  /*   93 */  rFlagsRegU_rule,
  /*   94 */  inline_cache_RegP_rule,
  /*   95 */  interpreter_method_oop_RegP_rule,
  /*   96 */  thread_RegP_rule,
  /*   97 */  lr_RegP_rule,
  /*   98 */  indirect_rule,
  /*   99 */  indIndexScaledOffsetI_rule,
  /*  100 */  indIndexScaledOffsetL_rule,
  /*  101 */  indIndexOffsetI2L_rule,
  /*  102 */  indIndexScaledOffsetI2L_rule,
  /*  103 */  indIndexScaledI2L_rule,
  /*  104 */  indIndexScaled_rule,
  /*  105 */  indIndex_rule,
  /*  106 */  indOffI_rule,
  /*  107 */  indOffL_rule,
  /*  108 */  indirectN_rule,
  /*  109 */  indIndexScaledOffsetIN_rule,
  /*  110 */  indIndexScaledOffsetLN_rule,
  /*  111 */  indIndexOffsetI2LN_rule,
  /*  112 */  indIndexScaledOffsetI2LN_rule,
  /*  113 */  indIndexScaledI2LN_rule,
  /*  114 */  indIndexScaledN_rule,
  /*  115 */  indIndexN_rule,
  /*  116 */  indOffIN_rule,
  /*  117 */  indOffLN_rule,
  /*  118 */  thread_anchor_pc_rule,
  /*  119 */  stackSlotP_rule,
  /*  120 */  stackSlotI_rule,
  /*  121 */  stackSlotF_rule,
  /*  122 */  stackSlotD_rule,
  /*  123 */  stackSlotL_rule,
  /*  124 */  cmpOp_rule,
  /*  125 */  cmpOpU_rule,
  /*  126 */  iRegL2I_rule,
  // last operand
  /*  127 */  vmem_rule,
  /*  128 */  memory_rule,
  /*  129 */  iRegIorL2I_rule,
  // last operand class
  /*  130 */  _LShiftL_iRegL_immIScale_rule,
  /*  131 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*  132 */  _ConvI2L_iRegI__rule,
  /*  133 */  _AddP_iRegP__ConvI2L_iRegI__rule,
  /*  134 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  135 */  _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  136 */  _DecodeN_iRegN__rule,
  /*  137 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  138 */  _AddP__DecodeN_iRegN___ConvI2L_iRegI__rule,
  /*  139 */  _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  140 */  _LoadB_memory__rule,
  /*  141 */  _LoadUB_memory__rule,
  /*  142 */  _LoadS_memory__rule,
  /*  143 */  _LoadUS_memory__rule,
  /*  144 */  _LoadI_memory__rule,
  /*  145 */  _ConvI2L__LoadI_memory___rule,
  /*  146 */  _LoadL_memory__rule,
  /*  147 */  _CastP2X_iRegP__rule,
  /*  148 */  _CastP2X__DecodeN_iRegN___rule,
  /*  149 */  _Binary_iRegP_iRegP_rule,
  /*  150 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  151 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  152 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  153 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  154 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  155 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  156 */  _Binary_immI0_iRegIorL2I_rule,
  /*  157 */  _Binary_iRegIorL2I_immI0_rule,
  /*  158 */  _Binary_immI_1_immI0_rule,
  /*  159 */  _Binary_iRegL_iRegL_rule,
  /*  160 */  _Binary_iRegL_immL0_rule,
  /*  161 */  _Binary_immL0_iRegL_rule,
  /*  162 */  _Binary_iRegP_immP0_rule,
  /*  163 */  _Binary_immP0_iRegP_rule,
  /*  164 */  _Binary_iRegN_iRegN_rule,
  /*  165 */  _Binary_iRegN_immN0_rule,
  /*  166 */  _Binary_immN0_iRegN_rule,
  /*  167 */  _Binary_vRegF_vRegF_rule,
  /*  168 */  _Binary_vRegD_vRegD_rule,
  /*  169 */  _ConvL2I_iRegL__rule,
  /*  170 */  _ConvI2L_iRegIorL2I__rule,
  /*  171 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  172 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  173 */  _MulL_iRegL_iRegL_rule,
  /*  174 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  175 */  _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule,
  /*  176 */  _RShiftL_iRegL_immL_63_rule,
  /*  177 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  178 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  179 */  _XorL_iRegL_immL_M1_rule,
  /*  180 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  181 */  _XorL_iRegL_iRegL_rule,
  /*  182 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  183 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  184 */  _URShiftL_iRegL_immI_rule,
  /*  185 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  186 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  187 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  188 */  _RShiftL_iRegL_immI_rule,
  /*  189 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  190 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  191 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  192 */  _LShiftL_iRegL_immI_rule,
  /*  193 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  194 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  195 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  196 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  197 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  198 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  199 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  200 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  201 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  202 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  203 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  204 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  205 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  206 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  207 */  _LShiftL_iRegL_iRegI_rule,
  /*  208 */  _SubI_immI_64_iRegI_rule,
  /*  209 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  210 */  _SubI_immI0_iRegI_rule,
  /*  211 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  212 */  _LShiftI_iRegL_iRegI_rule,
  /*  213 */  _SubI_immI_32_iRegI_rule,
  /*  214 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  215 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  216 */  _URShiftL_iRegL_iRegI_rule,
  /*  217 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  218 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  219 */  _URShiftI_iRegL_iRegI_rule,
  /*  220 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  221 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  222 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  223 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  224 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  225 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  226 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  227 */  _LShiftL_iRegL_immI_48_rule,
  /*  228 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  229 */  _LShiftL_iRegL_immI_32_rule,
  /*  230 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  231 */  _LShiftL_iRegL_immI_56_rule,
  /*  232 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  233 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  234 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  235 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  236 */  _AndL_iRegL_immL_255_rule,
  /*  237 */  _AndL_iRegL_immL_65535_rule,
  /*  238 */  _AndL_iRegL_immL_4294967295_rule,
  /*  239 */  _ConvF2D_vRegF__rule,
  /*  240 */  _SqrtD__ConvF2D_vRegF___rule,
  /*  241 */  _OverflowMulI_iRegIorL2I_iRegIorL2I_rule,
  /*  242 */  _OverflowMulL_iRegL_iRegL_rule,
  /*  243 */  _CmpI_iRegIorL2I_immI0_rule,
  /*  244 */  _CmpL_iRegL_immL0_rule,
  /*  245 */  _CmpP_iRegP_immP0_rule,
  /*  246 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  247 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  248 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  249 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  250 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  251 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  252 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  253 */  _Binary_iRegP_R1_iRegI_R3_rule,
  // last internally defined operand
  /*  254 */  iRegINoSp_rule,
  /*  255 */  iRegLNoSp_rule,
  /*  256 */  iRegPNoSp_rule,
  /*  257 */  iRegPNoSp_rule,
  /*  258 */  iRegPNoSp_rule,
  /*  259 */  iRegPNoSp_rule,
  /*  260 */  iRegPNoSp_rule,
  /*  261 */  iRegNNoSp_rule,
  /*  262 */  iRegNNoSp_rule,
  /*  263 */  iRegNNoSp_rule,
  /*  264 */  vRegF_rule,
  /*  265 */  vRegF_rule,
  /*  266 */  vRegD_rule,
  /*  267 */  vRegD_rule,
  /*  268 */  iRegINoSp_rule,
  /*  269 */  iRegINoSp_rule,
  /*  270 */  iRegINoSp_rule,
  /*  271 */  iRegINoSp_rule,
  /*  272 */  iRegPNoSp_rule,
  /*  273 */  iRegLNoSp_rule,
  /*  274 */  iRegPNoSp_rule,
  /*  275 */  iRegPNoSp_rule,
  /*  276 */  iRegI_rule,
  /*  277 */  rFlagsReg_rule,
  /*  278 */  rFlagsReg_rule,
  /*  279 */  rFlagsReg_rule,
  /*  280 */  vRegF_rule,
  /*  281 */  vRegD_rule,
  /*  282 */  vRegF_rule,
  /*  283 */  vRegD_rule,
  /*  284 */  iRegINoSp_rule,
  /*  285 */  vRegF_rule,
  /*  286 */  iRegLNoSp_rule,
  /*  287 */  vRegD_rule,
  /*  288 */  iRegINoSp_rule,
  /*  289 */  vRegF_rule,
  /*  290 */  iRegLNoSp_rule,
  /*  291 */  vRegD_rule,
  /*  292 */  rFlagsReg_rule,
  /*  293 */  rFlagsReg_rule,
  /*  294 */  rFlagsReg_rule,
  /*  295 */  rFlagsReg_rule,
  /*  296 */  rFlagsReg_rule,
  /*  297 */  rFlagsReg_rule,
  /*  298 */  rFlagsReg_rule,
  /*  299 */  rFlagsReg_rule,
  /*  300 */  rFlagsReg_rule,
  /*  301 */  rFlagsReg_rule,
  /*  302 */  rFlagsReg_rule,
  /*  303 */  rFlagsReg_rule,
  /*  304 */  rFlagsReg_rule,
  /*  305 */  rFlagsReg_rule,
  /*  306 */  rFlagsReg_rule,
  /*  307 */  rFlagsReg_rule,
  /*  308 */  rFlagsRegU_rule,
  /*  309 */  rFlagsRegU_rule,
  /*  310 */  rFlagsRegU_rule,
  /*  311 */  rFlagsRegU_rule,
  /*  312 */  rFlagsReg_rule,
  /*  313 */  rFlagsReg_rule,
  /*  314 */  rFlagsReg_rule,
  /*  315 */  rFlagsReg_rule,
  /*  316 */  rFlagsRegU_rule,
  /*  317 */  rFlagsRegU_rule,
  /*  318 */  rFlagsRegU_rule,
  /*  319 */  rFlagsRegU_rule,
  /*  320 */  rFlagsReg_rule,
  /*  321 */  rFlagsReg_rule,
  /*  322 */  rFlagsReg_rule,
  /*  323 */  rFlagsReg_rule,
  /*  324 */  rFlagsReg_rule,
  /*  325 */  rFlagsReg_rule,
  /*  326 */  rFlagsReg_rule,
  /*  327 */  thread_RegP_rule,
  /*  328 */  vecX_rule,
  /*  329 */  vecX_rule,
  /*  330 */  iRegINoSp_rule,
  /*  331 */  iRegLNoSp_rule,
  /*  332 */  iRegINoSp_rule,
  /*  333 */  iRegLNoSp_rule,
  /*  334 */  iRegINoSp_rule,
  /*  335 */  iRegLNoSp_rule,
  /*  336 */  iRegINoSp_rule,
  /*  337 */  iRegLNoSp_rule,
  /*  338 */  iRegINoSp_rule,
  /*  339 */  iRegLNoSp_rule,
  /*  340 */  iRegLNoSp_rule,
  /*  341 */  iRegLNoSp_rule,
  /*  342 */  iRegINoSp_rule,
  /*  343 */  iRegPNoSp_rule,
  /*  344 */  iRegNNoSp_rule,
  /*  345 */  iRegPNoSp_rule,
  /*  346 */  iRegNNoSp_rule,
  /*  347 */  vRegF_rule,
  /*  348 */  vRegD_rule,
  /*  349 */  Universe_rule,
  /*  350 */  Universe_rule,
  /*  351 */  Universe_rule,
  /*  352 */  Universe_rule,
  /*  353 */  Universe_rule,
  /*  354 */  Universe_rule,
  /*  355 */  Universe_rule,
  /*  356 */  Universe_rule,
  /*  357 */  Universe_rule,
  /*  358 */  Universe_rule,
  /*  359 */  Universe_rule,
  /*  360 */  Universe_rule,
  /*  361 */  Universe_rule,
  /*  362 */  Universe_rule,
  /*  363 */  Universe_rule,
  /*  364 */  Universe_rule,
  /*  365 */  Universe_rule,
  /*  366 */  Universe_rule,
  /*  367 */  Universe_rule,
  /*  368 */  iRegINoSp_rule,
  /*  369 */  iRegLNoSp_rule,
  /*  370 */  iRegINoSp_rule,
  /*  371 */  iRegINoSp_rule,
  /*  372 */  iRegINoSp_rule,
  /*  373 */  iRegINoSp_rule,
  /*  374 */  iRegINoSp_rule,
  /*  375 */  iRegINoSp_rule,
  /*  376 */  Universe_rule,
  /*  377 */  Universe_rule,
  /*  378 */  Universe_rule,
  /*  379 */  Universe_rule,
  /*  380 */  Universe_rule,
  /*  381 */  Universe_rule,
  /*  382 */  Universe_rule,
  /*  383 */  Universe_rule,
  /*  384 */  iRegINoSp_rule,
  /*  385 */  iRegINoSp_rule,
  /*  386 */  iRegNNoSp_rule,
  /*  387 */  iRegNNoSp_rule,
  /*  388 */  iRegPNoSp_rule,
  /*  389 */  iRegPNoSp_rule,
  /*  390 */  iRegNNoSp_rule,
  /*  391 */  iRegPNoSp_rule,
  /*  392 */  iRegPNoSp_rule,
  /*  393 */  iRegINoSp_rule,
  /*  394 */  iRegINoSp_rule,
  /*  395 */  iRegINoSp_rule,
  /*  396 */  iRegINoSp_rule,
  /*  397 */  iRegI_rule,
  /*  398 */  iRegL_rule,
  /*  399 */  iRegI_rule,
  /*  400 */  iRegP_rule,
  /*  401 */  iRegLNoSp_rule,
  /*  402 */  Universe_rule,
  /*  403 */  iRegLNoSp_rule,
  /*  404 */  Universe_rule,
  /*  405 */  iRegINoSp_rule,
  /*  406 */  Universe_rule,
  /*  407 */  iRegINoSp_rule,
  /*  408 */  Universe_rule,
  /*  409 */  iRegINoSp_rule,
  /*  410 */  iRegINoSp_rule,
  /*  411 */  iRegINoSp_rule,
  /*  412 */  iRegINoSp_rule,
  /*  413 */  iRegINoSp_rule,
  /*  414 */  iRegINoSp_rule,
  /*  415 */  iRegINoSp_rule,
  /*  416 */  iRegINoSp_rule,
  /*  417 */  iRegLNoSp_rule,
  /*  418 */  iRegLNoSp_rule,
  /*  419 */  iRegLNoSp_rule,
  /*  420 */  iRegLNoSp_rule,
  /*  421 */  iRegLNoSp_rule,
  /*  422 */  iRegLNoSp_rule,
  /*  423 */  iRegPNoSp_rule,
  /*  424 */  iRegPNoSp_rule,
  /*  425 */  iRegPNoSp_rule,
  /*  426 */  iRegPNoSp_rule,
  /*  427 */  iRegPNoSp_rule,
  /*  428 */  iRegPNoSp_rule,
  /*  429 */  iRegNNoSp_rule,
  /*  430 */  iRegNNoSp_rule,
  /*  431 */  iRegNNoSp_rule,
  /*  432 */  iRegNNoSp_rule,
  /*  433 */  iRegNNoSp_rule,
  /*  434 */  iRegNNoSp_rule,
  /*  435 */  vRegF_rule,
  /*  436 */  vRegF_rule,
  /*  437 */  vRegD_rule,
  /*  438 */  vRegD_rule,
  /*  439 */  iRegINoSp_rule,
  /*  440 */  iRegINoSp_rule,
  /*  441 */  iRegINoSp_rule,
  /*  442 */  iRegPNoSp_rule,
  /*  443 */  iRegPNoSp_rule,
  /*  444 */  iRegPNoSp_rule,
  /*  445 */  iRegPNoSp_rule,
  /*  446 */  iRegLNoSp_rule,
  /*  447 */  iRegPNoSp_rule,
  /*  448 */  iRegLNoSp_rule,
  /*  449 */  iRegLNoSp_rule,
  /*  450 */  iRegINoSp_rule,
  /*  451 */  iRegINoSp_rule,
  /*  452 */  iRegLNoSp_rule,
  /*  453 */  iRegLNoSp_rule,
  /*  454 */  iRegINoSp_rule,
  /*  455 */  iRegLNoSp_rule,
  /*  456 */  iRegINoSp_rule,
  /*  457 */  iRegLNoSp_rule,
  /*  458 */  iRegLNoSp_rule,
  /*  459 */  iRegLNoSp_rule,
  /*  460 */  iRegLNoSp_rule,
  /*  461 */  iRegINoSp_rule,
  /*  462 */  iRegINoSp_rule,
  /*  463 */  iRegINoSp_rule,
  /*  464 */  iRegLNoSp_rule,
  /*  465 */  iRegLNoSp_rule,
  /*  466 */  iRegLNoSp_rule,
  /*  467 */  iRegINoSp_rule,
  /*  468 */  iRegINoSp_rule,
  /*  469 */  iRegINoSp_rule,
  /*  470 */  iRegINoSp_rule,
  /*  471 */  iRegLNoSp_rule,
  /*  472 */  iRegLNoSp_rule,
  /*  473 */  iRegLNoSp_rule,
  /*  474 */  iRegLNoSp_rule,
  /*  475 */  iRegINoSp_rule,
  /*  476 */  iRegLNoSp_rule,
  /*  477 */  iRegINoSp_rule,
  /*  478 */  iRegINoSp_rule,
  /*  479 */  iRegINoSp_rule,
  /*  480 */  iRegINoSp_rule,
  /*  481 */  iRegINoSp_rule,
  /*  482 */  iRegINoSp_rule,
  /*  483 */  iRegLNoSp_rule,
  /*  484 */  iRegLNoSp_rule,
  /*  485 */  iRegLNoSp_rule,
  /*  486 */  iRegLNoSp_rule,
  /*  487 */  iRegLNoSp_rule,
  /*  488 */  iRegLNoSp_rule,
  /*  489 */  iRegLNoSp_rule,
  /*  490 */  iRegLNoSp_rule,
  /*  491 */  iRegINoSp_rule,
  /*  492 */  iRegINoSp_rule,
  /*  493 */  iRegINoSp_rule,
  /*  494 */  iRegLNoSp_rule,
  /*  495 */  iRegLNoSp_rule,
  /*  496 */  iRegINoSp_rule,
  /*  497 */  iRegINoSp_rule,
  /*  498 */  iRegLNoSp_rule,
  /*  499 */  iRegLNoSp_rule,
  /*  500 */  iRegINoSp_rule,
  /*  501 */  iRegINoSp_rule,
  /*  502 */  iRegLNoSp_rule,
  /*  503 */  iRegLNoSp_rule,
  /*  504 */  iRegINoSp_rule,
  /*  505 */  iRegINoSp_rule,
  /*  506 */  iRegLNoSp_rule,
  /*  507 */  iRegLNoSp_rule,
  /*  508 */  iRegINoSp_rule,
  /*  509 */  iRegINoSp_rule,
  /*  510 */  iRegLNoSp_rule,
  /*  511 */  iRegLNoSp_rule,
  /*  512 */  iRegINoSp_rule,
  /*  513 */  iRegINoSp_rule,
  /*  514 */  iRegLNoSp_rule,
  /*  515 */  iRegLNoSp_rule,
  /*  516 */  iRegINoSp_rule,
  /*  517 */  iRegINoSp_rule,
  /*  518 */  iRegINoSp_rule,
  /*  519 */  iRegINoSp_rule,
  /*  520 */  iRegLNoSp_rule,
  /*  521 */  iRegLNoSp_rule,
  /*  522 */  iRegLNoSp_rule,
  /*  523 */  iRegLNoSp_rule,
  /*  524 */  iRegINoSp_rule,
  /*  525 */  iRegINoSp_rule,
  /*  526 */  iRegINoSp_rule,
  /*  527 */  iRegINoSp_rule,
  /*  528 */  iRegLNoSp_rule,
  /*  529 */  iRegLNoSp_rule,
  /*  530 */  iRegLNoSp_rule,
  /*  531 */  iRegLNoSp_rule,
  /*  532 */  iRegINoSp_rule,
  /*  533 */  iRegINoSp_rule,
  /*  534 */  iRegINoSp_rule,
  /*  535 */  iRegINoSp_rule,
  /*  536 */  iRegLNoSp_rule,
  /*  537 */  iRegLNoSp_rule,
  /*  538 */  iRegLNoSp_rule,
  /*  539 */  iRegLNoSp_rule,
  /*  540 */  iRegINoSp_rule,
  /*  541 */  iRegINoSp_rule,
  /*  542 */  iRegLNoSp_rule,
  /*  543 */  iRegLNoSp_rule,
  /*  544 */  iRegINoSp_rule,
  /*  545 */  iRegINoSp_rule,
  /*  546 */  iRegLNoSp_rule,
  /*  547 */  iRegLNoSp_rule,
  /*  548 */  iRegINoSp_rule,
  /*  549 */  iRegINoSp_rule,
  /*  550 */  iRegLNoSp_rule,
  /*  551 */  iRegLNoSp_rule,
  /*  552 */  iRegINoSp_rule,
  /*  553 */  iRegINoSp_rule,
  /*  554 */  iRegLNoSp_rule,
  /*  555 */  iRegLNoSp_rule,
  /*  556 */  iRegINoSp_rule,
  /*  557 */  iRegINoSp_rule,
  /*  558 */  iRegLNoSp_rule,
  /*  559 */  iRegLNoSp_rule,
  /*  560 */  iRegINoSp_rule,
  /*  561 */  iRegINoSp_rule,
  /*  562 */  iRegLNoSp_rule,
  /*  563 */  iRegLNoSp_rule,
  /*  564 */  iRegINoSp_rule,
  /*  565 */  iRegINoSp_rule,
  /*  566 */  iRegLNoSp_rule,
  /*  567 */  iRegLNoSp_rule,
  /*  568 */  iRegINoSp_rule,
  /*  569 */  iRegINoSp_rule,
  /*  570 */  iRegLNoSp_rule,
  /*  571 */  iRegLNoSp_rule,
  /*  572 */  iRegINoSp_rule,
  /*  573 */  iRegINoSp_rule,
  /*  574 */  iRegLNoSp_rule,
  /*  575 */  iRegLNoSp_rule,
  /*  576 */  iRegINoSp_rule,
  /*  577 */  iRegINoSp_rule,
  /*  578 */  iRegLNoSp_rule,
  /*  579 */  iRegLNoSp_rule,
  /*  580 */  iRegINoSp_rule,
  /*  581 */  iRegINoSp_rule,
  /*  582 */  iRegLNoSp_rule,
  /*  583 */  iRegLNoSp_rule,
  /*  584 */  iRegINoSp_rule,
  /*  585 */  iRegINoSp_rule,
  /*  586 */  iRegLNoSp_rule,
  /*  587 */  iRegLNoSp_rule,
  /*  588 */  iRegINoSp_rule,
  /*  589 */  iRegINoSp_rule,
  /*  590 */  iRegLNoSp_rule,
  /*  591 */  iRegLNoSp_rule,
  /*  592 */  iRegINoSp_rule,
  /*  593 */  iRegINoSp_rule,
  /*  594 */  iRegLNoSp_rule,
  /*  595 */  iRegLNoSp_rule,
  /*  596 */  iRegINoSp_rule,
  /*  597 */  iRegINoSp_rule,
  /*  598 */  iRegLNoSp_rule,
  /*  599 */  iRegLNoSp_rule,
  /*  600 */  iRegINoSp_rule,
  /*  601 */  iRegLNoSp_rule,
  /*  602 */  iRegINoSp_rule,
  /*  603 */  iRegLNoSp_rule,
  /*  604 */  iRegINoSp_rule,
  /*  605 */  iRegLNoSp_rule,
  /*  606 */  iRegLNoSp_rule,
  /*  607 */  iRegINoSp_rule,
  /*  608 */  iRegLNoSp_rule,
  /*  609 */  iRegINoSp_rule,
  /*  610 */  iRegINoSp_rule,
  /*  611 */  iRegLNoSp_rule,
  /*  612 */  iRegLNoSp_rule,
  /*  613 */  iRegLNoSp_rule,
  /*  614 */  iRegLNoSp_rule,
  /*  615 */  iRegINoSp_rule,
  /*  616 */  iRegINoSp_rule,
  /*  617 */  iRegLNoSp_rule,
  /*  618 */  iRegLNoSp_rule,
  /*  619 */  iRegINoSp_rule,
  /*  620 */  iRegINoSp_rule,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  iRegLNoSp_rule,
  /*  624 */  iRegLNoSp_rule,
  /*  625 */  iRegLNoSp_rule,
  /*  626 */  iRegLNoSp_rule,
  /*  627 */  iRegLNoSp_rule,
  /*  628 */  iRegLNoSp_rule,
  /*  629 */  iRegLNoSp_rule,
  /*  630 */  iRegLNoSp_rule,
  /*  631 */  0,
  /*  632 */  0,
  /*  633 */  iRegLNoSp_rule,
  /*  634 */  iRegLNoSp_rule,
  /*  635 */  iRegLNoSp_rule,
  /*  636 */  iRegLNoSp_rule,
  /*  637 */  iRegLNoSp_rule,
  /*  638 */  iRegLNoSp_rule,
  /*  639 */  iRegLNoSp_rule,
  /*  640 */  iRegLNoSp_rule,
  /*  641 */  iRegLNoSp_rule,
  /*  642 */  iRegLNoSp_rule,
  /*  643 */  iRegLNoSp_rule,
  /*  644 */  iRegINoSp_rule,
  /*  645 */  iRegINoSp_rule,
  /*  646 */  iRegINoSp_rule,
  /*  647 */  iRegINoSp_rule,
  /*  648 */  iRegINoSp_rule,
  /*  649 */  iRegINoSp_rule,
  /*  650 */  iRegLNoSp_rule,
  /*  651 */  iRegLNoSp_rule,
  /*  652 */  iRegLNoSp_rule,
  /*  653 */  iRegLNoSp_rule,
  /*  654 */  iRegLNoSp_rule,
  /*  655 */  iRegLNoSp_rule,
  /*  656 */  iRegLNoSp_rule,
  /*  657 */  iRegLNoSp_rule,
  /*  658 */  iRegINoSp_rule,
  /*  659 */  iRegINoSp_rule,
  /*  660 */  iRegINoSp_rule,
  /*  661 */  iRegINoSp_rule,
  /*  662 */  iRegLNoSp_rule,
  /*  663 */  iRegLNoSp_rule,
  /*  664 */  iRegLNoSp_rule,
  /*  665 */  iRegLNoSp_rule,
  /*  666 */  iRegLNoSp_rule,
  /*  667 */  iRegLNoSp_rule,
  /*  668 */  iRegINoSp_rule,
  /*  669 */  iRegINoSp_rule,
  /*  670 */  iRegLNoSp_rule,
  /*  671 */  iRegLNoSp_rule,
  /*  672 */  iRegLNoSp_rule,
  /*  673 */  vRegF_rule,
  /*  674 */  vRegD_rule,
  /*  675 */  vRegF_rule,
  /*  676 */  vRegD_rule,
  /*  677 */  vRegF_rule,
  /*  678 */  vRegD_rule,
  /*  679 */  vRegF_rule,
  /*  680 */  vRegD_rule,
  /*  681 */  vRegD_rule,
  /*  682 */  vRegF_rule,
  /*  683 */  iRegINoSp_rule,
  /*  684 */  iRegINoSp_rule,
  /*  685 */  iRegINoSp_rule,
  /*  686 */  iRegINoSp_rule,
  /*  687 */  iRegINoSp_rule,
  /*  688 */  iRegINoSp_rule,
  /*  689 */  iRegLNoSp_rule,
  /*  690 */  iRegLNoSp_rule,
  /*  691 */  iRegLNoSp_rule,
  /*  692 */  iRegLNoSp_rule,
  /*  693 */  iRegLNoSp_rule,
  /*  694 */  iRegLNoSp_rule,
  /*  695 */  iRegLNoSp_rule,
  /*  696 */  iRegLNoSp_rule,
  /*  697 */  iRegINoSp_rule,
  /*  698 */  iRegINoSp_rule,
  /*  699 */  iRegINoSp_rule,
  /*  700 */  vRegF_rule,
  /*  701 */  vRegD_rule,
  /*  702 */  iRegINoSp_rule,
  /*  703 */  iRegLNoSp_rule,
  /*  704 */  vRegF_rule,
  /*  705 */  vRegF_rule,
  /*  706 */  iRegINoSp_rule,
  /*  707 */  iRegLNoSp_rule,
  /*  708 */  vRegD_rule,
  /*  709 */  vRegD_rule,
  /*  710 */  stackSlotI_rule,
  /*  711 */  stackSlotF_rule,
  /*  712 */  stackSlotL_rule,
  /*  713 */  stackSlotD_rule,
  /*  714 */  Universe_rule,
  /*  715 */  Universe_rule,
  /*  716 */  Universe_rule,
  /*  717 */  iRegINoSp_rule,
  /*  718 */  iRegINoSp_rule,
  /*  719 */  iRegINoSp_rule,
  /*  720 */  iRegINoSp_rule,
  /*  721 */  iRegINoSp_rule,
  /*  722 */  iRegINoSp_rule,
  /*  723 */  iRegINoSp_rule,
  /*  724 */  iRegINoSp_rule,
  /*  725 */  iRegINoSp_rule,
  /*  726 */  Universe_rule,
  /*  727 */  Universe_rule,
  /*  728 */  Universe_rule,
  /*  729 */  Universe_rule,
  /*  730 */  Universe_rule,
  /*  731 */  Universe_rule,
  /*  732 */  Universe_rule,
  /*  733 */  Universe_rule,
  /*  734 */  Universe_rule,
  /*  735 */  Universe_rule,
  /*  736 */  Universe_rule,
  /*  737 */  Universe_rule,
  /*  738 */  Universe_rule,
  /*  739 */  Universe_rule,
  /*  740 */  Universe_rule,
  /*  741 */  Universe_rule,
  /*  742 */  Universe_rule,
  /*  743 */  iRegP_R0_rule,
  /*  744 */  Universe_rule,
  /*  745 */  Universe_rule,
  /*  746 */  Universe_rule,
  /*  747 */  iRegP_R5_rule,
  /*  748 */  iRegI_R0_rule,
  /*  749 */  iRegI_R0_rule,
  /*  750 */  iRegI_R0_rule,
  /*  751 */  iRegI_R0_rule,
  /*  752 */  iRegI_R0_rule,
  /*  753 */  iRegI_R0_rule,
  /*  754 */  vecD_rule,
  /*  755 */  vecD_rule,
  /*  756 */  vecX_rule,
  /*  757 */  Universe_rule,
  /*  758 */  Universe_rule,
  /*  759 */  Universe_rule,
  /*  760 */  vecD_rule,
  /*  761 */  vecX_rule,
  /*  762 */  vecD_rule,
  /*  763 */  vecX_rule,
  /*  764 */  vecD_rule,
  /*  765 */  vecX_rule,
  /*  766 */  vecD_rule,
  /*  767 */  vecX_rule,
  /*  768 */  vecD_rule,
  /*  769 */  vecX_rule,
  /*  770 */  vecD_rule,
  /*  771 */  vecX_rule,
  /*  772 */  vecX_rule,
  /*  773 */  vecX_rule,
  /*  774 */  vecD_rule,
  /*  775 */  vecX_rule,
  /*  776 */  vecX_rule,
  /*  777 */  vecD_rule,
  /*  778 */  vecX_rule,
  /*  779 */  vecD_rule,
  /*  780 */  vecX_rule,
  /*  781 */  vecD_rule,
  /*  782 */  vecX_rule,
  /*  783 */  vecX_rule,
  /*  784 */  vecD_rule,
  /*  785 */  vecX_rule,
  /*  786 */  vecX_rule,
  /*  787 */  vecD_rule,
  /*  788 */  vecX_rule,
  /*  789 */  vecD_rule,
  /*  790 */  vecX_rule,
  /*  791 */  vecD_rule,
  /*  792 */  vecX_rule,
  /*  793 */  vecX_rule,
  /*  794 */  vecD_rule,
  /*  795 */  vecX_rule,
  /*  796 */  vecX_rule,
  /*  797 */  vecD_rule,
  /*  798 */  vecX_rule,
  /*  799 */  vecD_rule,
  /*  800 */  vecX_rule,
  /*  801 */  vecD_rule,
  /*  802 */  vecX_rule,
  /*  803 */  vecX_rule,
  /*  804 */  vecD_rule,
  /*  805 */  vecX_rule,
  /*  806 */  vecX_rule,
  /*  807 */  vecD_rule,
  /*  808 */  vecX_rule,
  /*  809 */  vecD_rule,
  /*  810 */  vecX_rule,
  /*  811 */  vecD_rule,
  /*  812 */  vecX_rule,
  /*  813 */  vecD_rule,
  /*  814 */  vecD_rule,
  /*  815 */  vecX_rule,
  /*  816 */  vecX_rule,
  /*  817 */  vecD_rule,
  /*  818 */  vecX_rule,
  /*  819 */  vecD_rule,
  /*  820 */  vecX_rule,
  /*  821 */  vecD_rule,
  /*  822 */  vecX_rule,
  /*  823 */  vecD_rule,
  /*  824 */  vecX_rule,
  /*  825 */  vecD_rule,
  /*  826 */  vecD_rule,
  /*  827 */  vecX_rule,
  /*  828 */  vecX_rule,
  /*  829 */  vecD_rule,
  /*  830 */  vecX_rule,
  /*  831 */  vecD_rule,
  /*  832 */  vecX_rule,
  /*  833 */  vecD_rule,
  /*  834 */  vecX_rule,
  /*  835 */  vecD_rule,
  /*  836 */  vecX_rule,
  /*  837 */  vecD_rule,
  /*  838 */  vecD_rule,
  /*  839 */  vecX_rule,
  /*  840 */  vecX_rule,
  /*  841 */  vecD_rule,
  /*  842 */  vecX_rule,
  /*  843 */  vecD_rule,
  /*  844 */  vecX_rule,
  /*  845 */  vecD_rule,
  /*  846 */  vecX_rule,
  /*  847 */  vecD_rule,
  /*  848 */  vecX_rule,
  /*  849 */  vecX_rule,
  /*  850 */  vecX_rule,
  /*  851 */  vecX_rule,
  /*  852 */  vecX_rule,
  /*  853 */  vecX_rule,
  /*  854 */  vecX_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*  100 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*  101 */  _AddP_iRegP__ConvI2L_iRegI__rule,
  /*  102 */  _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  103 */  iRegP_rule,
  /*  104 */  iRegP_rule,
  /*  105 */  iRegP_rule,
  /*  106 */  iRegP_rule,
  /*  107 */  iRegP_rule,
  /*  108 */  iRegN_rule,
  /*  109 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  110 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  111 */  _AddP__DecodeN_iRegN___ConvI2L_iRegI__rule,
  /*  112 */  _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  113 */  _DecodeN_iRegN__rule,
  /*  114 */  _DecodeN_iRegN__rule,
  /*  115 */  _DecodeN_iRegN__rule,
  /*  116 */  _DecodeN_iRegN__rule,
  /*  117 */  _DecodeN_iRegN__rule,
  /*  118 */  thread_RegP_rule,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  iRegL_rule,
  // last operand
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  // last operand class
  /*  130 */  iRegL_rule,
  /*  131 */  iRegP_rule,
  /*  132 */  iRegI_rule,
  /*  133 */  iRegP_rule,
  /*  134 */  _ConvI2L_iRegI__rule,
  /*  135 */  iRegP_rule,
  /*  136 */  iRegN_rule,
  /*  137 */  _DecodeN_iRegN__rule,
  /*  138 */  _DecodeN_iRegN__rule,
  /*  139 */  _DecodeN_iRegN__rule,
  /*  140 */  memory_rule,
  /*  141 */  memory_rule,
  /*  142 */  memory_rule,
  /*  143 */  memory_rule,
  /*  144 */  memory_rule,
  /*  145 */  _LoadI_memory__rule,
  /*  146 */  memory_rule,
  /*  147 */  iRegP_rule,
  /*  148 */  _DecodeN_iRegN__rule,
  /*  149 */  iRegP_rule,
  /*  150 */  iRegLNoSp_rule,
  /*  151 */  iRegINoSp_rule,
  /*  152 */  iRegNNoSp_rule,
  /*  153 */  cmpOp_rule,
  /*  154 */  iRegIorL2I_rule,
  /*  155 */  cmpOpU_rule,
  /*  156 */  immI0_rule,
  /*  157 */  iRegIorL2I_rule,
  /*  158 */  immI_1_rule,
  /*  159 */  iRegL_rule,
  /*  160 */  iRegL_rule,
  /*  161 */  immL0_rule,
  /*  162 */  iRegP_rule,
  /*  163 */  immP0_rule,
  /*  164 */  iRegN_rule,
  /*  165 */  iRegN_rule,
  /*  166 */  immN0_rule,
  /*  167 */  vRegF_rule,
  /*  168 */  vRegD_rule,
  /*  169 */  iRegL_rule,
  /*  170 */  iRegIorL2I_rule,
  /*  171 */  _ConvI2L_iRegIorL2I__rule,
  /*  172 */  iRegIorL2I_rule,
  /*  173 */  iRegL_rule,
  /*  174 */  iRegIorL2I_rule,
  /*  175 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  176 */  iRegL_rule,
  /*  177 */  _RShiftL_iRegL_immL_63_rule,
  /*  178 */  iRegIorL2I_rule,
  /*  179 */  iRegL_rule,
  /*  180 */  iRegIorL2I_rule,
  /*  181 */  iRegL_rule,
  /*  182 */  iRegIorL2I_rule,
  /*  183 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  184 */  iRegL_rule,
  /*  185 */  _URShiftL_iRegL_immI_rule,
  /*  186 */  iRegIorL2I_rule,
  /*  187 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  188 */  iRegL_rule,
  /*  189 */  _RShiftL_iRegL_immI_rule,
  /*  190 */  iRegIorL2I_rule,
  /*  191 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  192 */  iRegL_rule,
  /*  193 */  _LShiftL_iRegL_immI_rule,
  /*  194 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  195 */  iRegIorL2I_rule,
  /*  196 */  _URShiftL_iRegL_immI_rule,
  /*  197 */  iRegL_rule,
  /*  198 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  199 */  iRegIorL2I_rule,
  /*  200 */  _RShiftL_iRegL_immI_rule,
  /*  201 */  iRegL_rule,
  /*  202 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  203 */  iRegIorL2I_rule,
  /*  204 */  _LShiftL_iRegL_immI_rule,
  /*  205 */  iRegL_rule,
  /*  206 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  207 */  iRegL_rule,
  /*  208 */  immI_64_rule,
  /*  209 */  iRegL_rule,
  /*  210 */  immI0_rule,
  /*  211 */  iRegL_rule,
  /*  212 */  iRegL_rule,
  /*  213 */  immI_32_rule,
  /*  214 */  iRegL_rule,
  /*  215 */  iRegL_rule,
  /*  216 */  iRegL_rule,
  /*  217 */  iRegL_rule,
  /*  218 */  iRegL_rule,
  /*  219 */  iRegL_rule,
  /*  220 */  iRegL_rule,
  /*  221 */  iRegL_rule,
  /*  222 */  iRegIorL2I_rule,
  /*  223 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  224 */  iRegIorL2I_rule,
  /*  225 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  226 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  227 */  iRegL_rule,
  /*  228 */  _LShiftL_iRegL_immI_48_rule,
  /*  229 */  iRegL_rule,
  /*  230 */  _LShiftL_iRegL_immI_32_rule,
  /*  231 */  iRegL_rule,
  /*  232 */  _LShiftL_iRegL_immI_56_rule,
  /*  233 */  _LShiftL_iRegL_immI_56_rule,
  /*  234 */  iRegIorL2I_rule,
  /*  235 */  iRegIorL2I_rule,
  /*  236 */  iRegL_rule,
  /*  237 */  iRegL_rule,
  /*  238 */  iRegL_rule,
  /*  239 */  vRegF_rule,
  /*  240 */  _ConvF2D_vRegF__rule,
  /*  241 */  iRegIorL2I_rule,
  /*  242 */  iRegL_rule,
  /*  243 */  iRegIorL2I_rule,
  /*  244 */  iRegL_rule,
  /*  245 */  iRegP_rule,
  /*  246 */  iRegP_R4_rule,
  /*  247 */  iRegP_R1_rule,
  /*  248 */  iRegP_R3_rule,
  /*  249 */  iRegP_R1_rule,
  /*  250 */  iRegP_R3_rule,
  /*  251 */  iRegP_R3_rule,
  /*  252 */  iRegP_R1_rule,
  /*  253 */  iRegP_R1_rule,
  // last internally defined operand
  /*  254 */  immI_rule,
  /*  255 */  immL_rule,
  /*  256 */  immP_rule,
  /*  257 */  immP0_rule,
  /*  258 */  immP_1_rule,
  /*  259 */  immPollPage_rule,
  /*  260 */  immByteMapBase_rule,
  /*  261 */  immN_rule,
  /*  262 */  immN0_rule,
  /*  263 */  immNKlass_rule,
  /*  264 */  immFPacked_rule,
  /*  265 */  immF_rule,
  /*  266 */  immDPacked_rule,
  /*  267 */  immD_rule,
  /*  268 */  iRegIorL2I_rule,
  /*  269 */  iRegL_rule,
  /*  270 */  iRegIorL2I_rule,
  /*  271 */  iRegL_rule,
  /*  272 */  iRegL_rule,
  /*  273 */  iRegP_rule,
  /*  274 */  iRegPNoSp_rule,
  /*  275 */  iRegPNoSp_rule,
  /*  276 */  iRegI_rule,
  /*  277 */  memory_rule,
  /*  278 */  indirect_rule,
  /*  279 */  indirect_rule,
  /*  280 */  vRegF_rule,
  /*  281 */  vRegD_rule,
  /*  282 */  vRegF_rule,
  /*  283 */  vRegD_rule,
  /*  284 */  stackSlotF_rule,
  /*  285 */  stackSlotI_rule,
  /*  286 */  stackSlotD_rule,
  /*  287 */  stackSlotL_rule,
  /*  288 */  vRegF_rule,
  /*  289 */  iRegI_rule,
  /*  290 */  vRegD_rule,
  /*  291 */  iRegL_rule,
  /*  292 */  iRegIorL2I_rule,
  /*  293 */  iRegIorL2I_rule,
  /*  294 */  iRegL_rule,
  /*  295 */  iRegL_rule,
  /*  296 */  iRegIorL2I_rule,
  /*  297 */  iRegIorL2I_rule,
  /*  298 */  iRegL_rule,
  /*  299 */  iRegL_rule,
  /*  300 */  immI0_rule,
  /*  301 */  immI0_rule,
  /*  302 */  iRegIorL2I_rule,
  /*  303 */  iRegL_rule,
  /*  304 */  iRegI_rule,
  /*  305 */  iRegI_rule,
  /*  306 */  iRegI_rule,
  /*  307 */  iRegI_rule,
  /*  308 */  iRegI_rule,
  /*  309 */  iRegI_rule,
  /*  310 */  iRegI_rule,
  /*  311 */  iRegI_rule,
  /*  312 */  iRegL_rule,
  /*  313 */  iRegL_rule,
  /*  314 */  iRegL_rule,
  /*  315 */  iRegL_rule,
  /*  316 */  iRegP_rule,
  /*  317 */  iRegN_rule,
  /*  318 */  iRegP_rule,
  /*  319 */  iRegN_rule,
  /*  320 */  vRegF_rule,
  /*  321 */  vRegF_rule,
  /*  322 */  vRegD_rule,
  /*  323 */  vRegD_rule,
  /*  324 */  iRegP_rule,
  /*  325 */  iRegP_rule,
  /*  326 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  327 */  0,
  /*  328 */  iRegIorL2I_rule,
  /*  329 */  iRegIorL2I_rule,
  /*  330 */  memory_rule,
  /*  331 */  _LoadB_memory__rule,
  /*  332 */  memory_rule,
  /*  333 */  _LoadUB_memory__rule,
  /*  334 */  memory_rule,
  /*  335 */  _LoadS_memory__rule,
  /*  336 */  memory_rule,
  /*  337 */  _LoadUS_memory__rule,
  /*  338 */  memory_rule,
  /*  339 */  _LoadI_memory__rule,
  /*  340 */  _ConvI2L__LoadI_memory___rule,
  /*  341 */  memory_rule,
  /*  342 */  memory_rule,
  /*  343 */  memory_rule,
  /*  344 */  memory_rule,
  /*  345 */  memory_rule,
  /*  346 */  memory_rule,
  /*  347 */  memory_rule,
  /*  348 */  memory_rule,
  /*  349 */  memory_rule,
  /*  350 */  memory_rule,
  /*  351 */  memory_rule,
  /*  352 */  memory_rule,
  /*  353 */  memory_rule,
  /*  354 */  memory_rule,
  /*  355 */  memory_rule,
  /*  356 */  memory_rule,
  /*  357 */  memory_rule,
  /*  358 */  memory_rule,
  /*  359 */  memory_rule,
  /*  360 */  memory_rule,
  /*  361 */  memory_rule,
  /*  362 */  memory_rule,
  /*  363 */  memory_rule,
  /*  364 */  memory_rule,
  /*  365 */  memory_rule,
  /*  366 */  memory_rule,
  /*  367 */  memory_rule,
  /*  368 */  iRegIorL2I_rule,
  /*  369 */  iRegL_rule,
  /*  370 */  iRegIorL2I_rule,
  /*  371 */  iRegIorL2I_rule,
  /*  372 */  iRegIorL2I_rule,
  /*  373 */  _LoadI_memory__rule,
  /*  374 */  iRegL_rule,
  /*  375 */  _LoadL_memory__rule,
  /*  376 */  0,
  /*  377 */  0,
  /*  378 */  0,
  /*  379 */  0,
  /*  380 */  0,
  /*  381 */  0,
  /*  382 */  0,
  /*  383 */  0,
  /*  384 */  _CastP2X_iRegP__rule,
  /*  385 */  _CastP2X__DecodeN_iRegN___rule,
  /*  386 */  iRegP_rule,
  /*  387 */  iRegP_rule,
  /*  388 */  iRegN_rule,
  /*  389 */  iRegN_rule,
  /*  390 */  iRegP_rule,
  /*  391 */  iRegN_rule,
  /*  392 */  indirect_rule,
  /*  393 */  indirect_rule,
  /*  394 */  indirect_rule,
  /*  395 */  indirect_rule,
  /*  396 */  indirect_rule,
  /*  397 */  indirect_rule,
  /*  398 */  indirect_rule,
  /*  399 */  indirect_rule,
  /*  400 */  indirect_rule,
  /*  401 */  indirect_rule,
  /*  402 */  indirect_rule,
  /*  403 */  indirect_rule,
  /*  404 */  indirect_rule,
  /*  405 */  indirect_rule,
  /*  406 */  indirect_rule,
  /*  407 */  indirect_rule,
  /*  408 */  indirect_rule,
  /*  409 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  410 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  411 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  412 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  413 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  414 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  415 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  416 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  417 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  418 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  419 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  420 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  421 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  422 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  423 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  424 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  425 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  426 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  427 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  428 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  429 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  430 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  431 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  432 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  433 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  434 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  435 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  436 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  437 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  438 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  439 */  iRegIorL2I_rule,
  /*  440 */  iRegIorL2I_rule,
  /*  441 */  _ConvL2I_iRegL__rule,
  /*  442 */  iRegP_rule,
  /*  443 */  iRegP_rule,
  /*  444 */  iRegP_rule,
  /*  445 */  iRegP_rule,
  /*  446 */  _ConvI2L_iRegIorL2I__rule,
  /*  447 */  iRegP_rule,
  /*  448 */  iRegL_rule,
  /*  449 */  iRegL_rule,
  /*  450 */  iRegIorL2I_rule,
  /*  451 */  iRegIorL2I_rule,
  /*  452 */  iRegL_rule,
  /*  453 */  iRegL_rule,
  /*  454 */  immI0_rule,
  /*  455 */  immL0_rule,
  /*  456 */  iRegIorL2I_rule,
  /*  457 */  _ConvI2L_iRegIorL2I__rule,
  /*  458 */  _ConvI2L_iRegIorL2I__rule,
  /*  459 */  iRegL_rule,
  /*  460 */  iRegL_rule,
  /*  461 */  iRegIorL2I_rule,
  /*  462 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  463 */  iRegIorL2I_rule,
  /*  464 */  iRegL_rule,
  /*  465 */  _MulL_iRegL_iRegL_rule,
  /*  466 */  iRegL_rule,
  /*  467 */  iRegIorL2I_rule,
  /*  468 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  469 */  iRegIorL2I_rule,
  /*  470 */  _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule,
  /*  471 */  iRegL_rule,
  /*  472 */  _RShiftL_iRegL_immL_63_rule,
  /*  473 */  iRegL_rule,
  /*  474 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  475 */  iRegIorL2I_rule,
  /*  476 */  iRegL_rule,
  /*  477 */  iRegIorL2I_rule,
  /*  478 */  iRegIorL2I_rule,
  /*  479 */  iRegIorL2I_rule,
  /*  480 */  iRegIorL2I_rule,
  /*  481 */  iRegIorL2I_rule,
  /*  482 */  iRegIorL2I_rule,
  /*  483 */  iRegL_rule,
  /*  484 */  iRegL_rule,
  /*  485 */  iRegL_rule,
  /*  486 */  iRegL_rule,
  /*  487 */  _CastP2X_iRegP__rule,
  /*  488 */  iRegL_rule,
  /*  489 */  iRegL_rule,
  /*  490 */  iRegL_rule,
  /*  491 */  iRegIorL2I_rule,
  /*  492 */  iRegIorL2I_rule,
  /*  493 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  494 */  iRegL_rule,
  /*  495 */  _XorL_iRegL_immL_M1_rule,
  /*  496 */  iRegIorL2I_rule,
  /*  497 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  498 */  iRegL_rule,
  /*  499 */  _XorL_iRegL_immL_M1_rule,
  /*  500 */  immI_M1_rule,
  /*  501 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  502 */  immL_M1_rule,
  /*  503 */  _XorL_iRegL_iRegL_rule,
  /*  504 */  iRegIorL2I_rule,
  /*  505 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  506 */  iRegL_rule,
  /*  507 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  508 */  iRegIorL2I_rule,
  /*  509 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  510 */  iRegL_rule,
  /*  511 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  512 */  iRegIorL2I_rule,
  /*  513 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  514 */  iRegL_rule,
  /*  515 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  516 */  immI_M1_rule,
  /*  517 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  518 */  immI_M1_rule,
  /*  519 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  520 */  immL_M1_rule,
  /*  521 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  522 */  immL_M1_rule,
  /*  523 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  524 */  immI_M1_rule,
  /*  525 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  526 */  immI_M1_rule,
  /*  527 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  528 */  immL_M1_rule,
  /*  529 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  530 */  immL_M1_rule,
  /*  531 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  532 */  immI_M1_rule,
  /*  533 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  534 */  immI_M1_rule,
  /*  535 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  536 */  immL_M1_rule,
  /*  537 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  538 */  immL_M1_rule,
  /*  539 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  540 */  iRegIorL2I_rule,
  /*  541 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  542 */  iRegL_rule,
  /*  543 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  544 */  iRegIorL2I_rule,
  /*  545 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  546 */  iRegL_rule,
  /*  547 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  548 */  iRegIorL2I_rule,
  /*  549 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  550 */  iRegL_rule,
  /*  551 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  552 */  iRegIorL2I_rule,
  /*  553 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  554 */  iRegL_rule,
  /*  555 */  _URShiftL_iRegL_immI_rule,
  /*  556 */  iRegIorL2I_rule,
  /*  557 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  558 */  iRegL_rule,
  /*  559 */  _RShiftL_iRegL_immI_rule,
  /*  560 */  iRegIorL2I_rule,
  /*  561 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  562 */  iRegL_rule,
  /*  563 */  _LShiftL_iRegL_immI_rule,
  /*  564 */  iRegIorL2I_rule,
  /*  565 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  566 */  iRegL_rule,
  /*  567 */  _URShiftL_iRegL_immI_rule,
  /*  568 */  iRegIorL2I_rule,
  /*  569 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  570 */  iRegL_rule,
  /*  571 */  _RShiftL_iRegL_immI_rule,
  /*  572 */  iRegIorL2I_rule,
  /*  573 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  574 */  iRegL_rule,
  /*  575 */  _LShiftL_iRegL_immI_rule,
  /*  576 */  iRegIorL2I_rule,
  /*  577 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  578 */  iRegL_rule,
  /*  579 */  _URShiftL_iRegL_immI_rule,
  /*  580 */  iRegIorL2I_rule,
  /*  581 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  582 */  iRegL_rule,
  /*  583 */  _RShiftL_iRegL_immI_rule,
  /*  584 */  iRegIorL2I_rule,
  /*  585 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  586 */  iRegL_rule,
  /*  587 */  _LShiftL_iRegL_immI_rule,
  /*  588 */  iRegIorL2I_rule,
  /*  589 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  590 */  iRegL_rule,
  /*  591 */  _URShiftL_iRegL_immI_rule,
  /*  592 */  iRegIorL2I_rule,
  /*  593 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  594 */  iRegL_rule,
  /*  595 */  _RShiftL_iRegL_immI_rule,
  /*  596 */  iRegIorL2I_rule,
  /*  597 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  598 */  iRegL_rule,
  /*  599 */  _LShiftL_iRegL_immI_rule,
  /*  600 */  iRegIorL2I_rule,
  /*  601 */  iRegL_rule,
  /*  602 */  iRegIorL2I_rule,
  /*  603 */  iRegL_rule,
  /*  604 */  iRegIorL2I_rule,
  /*  605 */  iRegL_rule,
  /*  606 */  _LShiftL_iRegL_immI_rule,
  /*  607 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  608 */  _LShiftL_iRegL_immI_rule,
  /*  609 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  610 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  611 */  _URShiftL_iRegL_immI_rule,
  /*  612 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  613 */  _LShiftL_iRegL_immI_rule,
  /*  614 */  _URShiftL_iRegL_immI_rule,
  /*  615 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  616 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  617 */  _LShiftL_iRegL_immI_rule,
  /*  618 */  _URShiftL_iRegL_immI_rule,
  /*  619 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  620 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  _LShiftL_iRegL_iRegI_rule,
  /*  624 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  625 */  _LShiftL_iRegL_iRegI_rule,
  /*  626 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  627 */  _LShiftI_iRegL_iRegI_rule,
  /*  628 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  629 */  _LShiftI_iRegL_iRegI_rule,
  /*  630 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  631 */  0,
  /*  632 */  0,
  /*  633 */  _URShiftL_iRegL_iRegI_rule,
  /*  634 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  635 */  _URShiftL_iRegL_iRegI_rule,
  /*  636 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  637 */  _URShiftI_iRegL_iRegI_rule,
  /*  638 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  639 */  _URShiftI_iRegL_iRegI_rule,
  /*  640 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  641 */  iRegL_rule,
  /*  642 */  _ConvI2L_iRegIorL2I__rule,
  /*  643 */  iRegL_rule,
  /*  644 */  iRegIorL2I_rule,
  /*  645 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  646 */  iRegIorL2I_rule,
  /*  647 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  648 */  iRegIorL2I_rule,
  /*  649 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  650 */  iRegL_rule,
  /*  651 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  652 */  iRegL_rule,
  /*  653 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  654 */  iRegL_rule,
  /*  655 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  656 */  iRegL_rule,
  /*  657 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  658 */  iRegIorL2I_rule,
  /*  659 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  660 */  iRegIorL2I_rule,
  /*  661 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  662 */  iRegL_rule,
  /*  663 */  _AndL_iRegL_immL_255_rule,
  /*  664 */  iRegL_rule,
  /*  665 */  _AndL_iRegL_immL_65535_rule,
  /*  666 */  iRegL_rule,
  /*  667 */  _AndL_iRegL_immL_4294967295_rule,
  /*  668 */  iRegIorL2I_rule,
  /*  669 */  iRegIorL2I_rule,
  /*  670 */  iRegL_rule,
  /*  671 */  iRegL_rule,
  /*  672 */  iRegL_rule,
  /*  673 */  vRegF_rule,
  /*  674 */  vRegD_rule,
  /*  675 */  vRegF_rule,
  /*  676 */  vRegD_rule,
  /*  677 */  vRegF_rule,
  /*  678 */  vRegD_rule,
  /*  679 */  vRegF_rule,
  /*  680 */  vRegD_rule,
  /*  681 */  vRegD_rule,
  /*  682 */  _SqrtD__ConvF2D_vRegF___rule,
  /*  683 */  iRegIorL2I_rule,
  /*  684 */  iRegIorL2I_rule,
  /*  685 */  iRegIorL2I_rule,
  /*  686 */  iRegIorL2I_rule,
  /*  687 */  iRegIorL2I_rule,
  /*  688 */  iRegIorL2I_rule,
  /*  689 */  iRegL_rule,
  /*  690 */  iRegL_rule,
  /*  691 */  iRegL_rule,
  /*  692 */  iRegL_rule,
  /*  693 */  iRegL_rule,
  /*  694 */  iRegL_rule,
  /*  695 */  iRegIorL2I_rule,
  /*  696 */  _ConvI2L_iRegIorL2I__rule,
  /*  697 */  iRegL_rule,
  /*  698 */  iRegIorL2I_rule,
  /*  699 */  iRegP_rule,
  /*  700 */  vRegD_rule,
  /*  701 */  vRegF_rule,
  /*  702 */  vRegF_rule,
  /*  703 */  vRegF_rule,
  /*  704 */  iRegIorL2I_rule,
  /*  705 */  iRegL_rule,
  /*  706 */  vRegD_rule,
  /*  707 */  vRegD_rule,
  /*  708 */  iRegIorL2I_rule,
  /*  709 */  iRegL_rule,
  /*  710 */  vRegF_rule,
  /*  711 */  iRegI_rule,
  /*  712 */  vRegD_rule,
  /*  713 */  iRegL_rule,
  /*  714 */  iRegL_R11_rule,
  /*  715 */  cmpOp_rule,
  /*  716 */  cmpOp_rule,
  /*  717 */  vRegF_rule,
  /*  718 */  vRegD_rule,
  /*  719 */  vRegF_rule,
  /*  720 */  vRegD_rule,
  /*  721 */  iRegL_rule,
  /*  722 */  iRegIorL2I_rule,
  /*  723 */  iRegIorL2I_rule,
  /*  724 */  iRegI_rule,
  /*  725 */  iRegI_rule,
  /*  726 */  0,
  /*  727 */  cmpOp_rule,
  /*  728 */  cmpOpU_rule,
  /*  729 */  cmpOp_rule,
  /*  730 */  cmpOp_rule,
  /*  731 */  cmpOp_rule,
  /*  732 */  cmpOp_rule,
  /*  733 */  cmpOpU_rule,
  /*  734 */  iRegP_rule,
  /*  735 */  0,
  /*  736 */  0,
  /*  737 */  0,
  /*  738 */  0,
  /*  739 */  0,
  /*  740 */  0,
  /*  741 */  iRegPNoSp_rule,
  /*  742 */  iRegPNoSp_rule,
  /*  743 */  0,
  /*  744 */  0,
  /*  745 */  0,
  /*  746 */  0,
  /*  747 */  iRegP_R4_rule,
  /*  748 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  749 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  750 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  751 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  752 */  iRegP_R1_rule,
  /*  753 */  iRegP_R2_rule,
  /*  754 */  vmem_rule,
  /*  755 */  vmem_rule,
  /*  756 */  vmem_rule,
  /*  757 */  vmem_rule,
  /*  758 */  vmem_rule,
  /*  759 */  vmem_rule,
  /*  760 */  iRegIorL2I_rule,
  /*  761 */  iRegIorL2I_rule,
  /*  762 */  immI_rule,
  /*  763 */  immI_rule,
  /*  764 */  iRegIorL2I_rule,
  /*  765 */  iRegIorL2I_rule,
  /*  766 */  immI_rule,
  /*  767 */  immI_rule,
  /*  768 */  iRegIorL2I_rule,
  /*  769 */  iRegIorL2I_rule,
  /*  770 */  immI_rule,
  /*  771 */  immI_rule,
  /*  772 */  iRegL_rule,
  /*  773 */  immI0_rule,
  /*  774 */  vRegF_rule,
  /*  775 */  vRegF_rule,
  /*  776 */  vRegD_rule,
  /*  777 */  vecD_rule,
  /*  778 */  vecX_rule,
  /*  779 */  vecD_rule,
  /*  780 */  vecX_rule,
  /*  781 */  vecD_rule,
  /*  782 */  vecX_rule,
  /*  783 */  vecX_rule,
  /*  784 */  vecD_rule,
  /*  785 */  vecX_rule,
  /*  786 */  vecX_rule,
  /*  787 */  vecD_rule,
  /*  788 */  vecX_rule,
  /*  789 */  vecD_rule,
  /*  790 */  vecX_rule,
  /*  791 */  vecD_rule,
  /*  792 */  vecX_rule,
  /*  793 */  vecX_rule,
  /*  794 */  vecD_rule,
  /*  795 */  vecX_rule,
  /*  796 */  vecX_rule,
  /*  797 */  vecD_rule,
  /*  798 */  vecX_rule,
  /*  799 */  vecD_rule,
  /*  800 */  vecX_rule,
  /*  801 */  vecD_rule,
  /*  802 */  vecX_rule,
  /*  803 */  vecX_rule,
  /*  804 */  vecD_rule,
  /*  805 */  vecX_rule,
  /*  806 */  vecX_rule,
  /*  807 */  vecD_rule,
  /*  808 */  vecX_rule,
  /*  809 */  vecD_rule,
  /*  810 */  vecX_rule,
  /*  811 */  vecD_rule,
  /*  812 */  vecX_rule,
  /*  813 */  vecD_rule,
  /*  814 */  vecD_rule,
  /*  815 */  vecX_rule,
  /*  816 */  vecX_rule,
  /*  817 */  vecD_rule,
  /*  818 */  vecX_rule,
  /*  819 */  vecD_rule,
  /*  820 */  vecX_rule,
  /*  821 */  vecD_rule,
  /*  822 */  vecX_rule,
  /*  823 */  vecD_rule,
  /*  824 */  vecX_rule,
  /*  825 */  vecD_rule,
  /*  826 */  vecD_rule,
  /*  827 */  vecX_rule,
  /*  828 */  vecX_rule,
  /*  829 */  vecD_rule,
  /*  830 */  vecX_rule,
  /*  831 */  vecD_rule,
  /*  832 */  vecX_rule,
  /*  833 */  vecD_rule,
  /*  834 */  vecX_rule,
  /*  835 */  vecD_rule,
  /*  836 */  vecX_rule,
  /*  837 */  vecD_rule,
  /*  838 */  vecD_rule,
  /*  839 */  vecX_rule,
  /*  840 */  vecX_rule,
  /*  841 */  vecD_rule,
  /*  842 */  vecX_rule,
  /*  843 */  vecD_rule,
  /*  844 */  vecX_rule,
  /*  845 */  vecD_rule,
  /*  846 */  vecX_rule,
  /*  847 */  vecD_rule,
  /*  848 */  vecX_rule,
  /*  849 */  vecX_rule,
  /*  850 */  vecX_rule,
  /*  851 */  vecX_rule,
  /*  852 */  vecX_rule,
  /*  853 */  vecX_rule,
  /*  854 */  vecX_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  immIU12_rule,
  /*  100 */  immLU12_rule,
  /*  101 */  immLU12_rule,
  /*  102 */  immLU12_rule,
  /*  103 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  104 */  _LShiftL_iRegL_immIScale_rule,
  /*  105 */  iRegL_rule,
  /*  106 */  immIOffset_rule,
  /*  107 */  immLoffset_rule,
  /*  108 */  0,
  /*  109 */  immIU12_rule,
  /*  110 */  immLU12_rule,
  /*  111 */  immLU12_rule,
  /*  112 */  immLU12_rule,
  /*  113 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  114 */  _LShiftL_iRegL_immIScale_rule,
  /*  115 */  iRegL_rule,
  /*  116 */  immIOffset_rule,
  /*  117 */  immLoffset_rule,
  /*  118 */  immL_pc_off_rule,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  // last operand
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  // last operand class
  /*  130 */  immIScale_rule,
  /*  131 */  _LShiftL_iRegL_immIScale_rule,
  /*  132 */  0,
  /*  133 */  _ConvI2L_iRegI__rule,
  /*  134 */  immIScale_rule,
  /*  135 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  136 */  0,
  /*  137 */  _LShiftL_iRegL_immIScale_rule,
  /*  138 */  _ConvI2L_iRegI__rule,
  /*  139 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  iRegP_rule,
  /*  150 */  iRegLNoSp_rule,
  /*  151 */  iRegINoSp_rule,
  /*  152 */  iRegNNoSp_rule,
  /*  153 */  rFlagsReg_rule,
  /*  154 */  iRegIorL2I_rule,
  /*  155 */  rFlagsRegU_rule,
  /*  156 */  iRegIorL2I_rule,
  /*  157 */  immI0_rule,
  /*  158 */  immI0_rule,
  /*  159 */  iRegL_rule,
  /*  160 */  immL0_rule,
  /*  161 */  iRegL_rule,
  /*  162 */  immP0_rule,
  /*  163 */  iRegP_rule,
  /*  164 */  iRegN_rule,
  /*  165 */  immN0_rule,
  /*  166 */  iRegN_rule,
  /*  167 */  vRegF_rule,
  /*  168 */  vRegD_rule,
  /*  169 */  0,
  /*  170 */  0,
  /*  171 */  immIScale_rule,
  /*  172 */  iRegIorL2I_rule,
  /*  173 */  iRegL_rule,
  /*  174 */  immI_31_rule,
  /*  175 */  immI_31_rule,
  /*  176 */  immL_63_rule,
  /*  177 */  immL_63_rule,
  /*  178 */  immI_M1_rule,
  /*  179 */  immL_M1_rule,
  /*  180 */  iRegIorL2I_rule,
  /*  181 */  iRegL_rule,
  /*  182 */  immI_rule,
  /*  183 */  immI_M1_rule,
  /*  184 */  immI_rule,
  /*  185 */  immL_M1_rule,
  /*  186 */  immI_rule,
  /*  187 */  immI_M1_rule,
  /*  188 */  immI_rule,
  /*  189 */  immL_M1_rule,
  /*  190 */  immI_rule,
  /*  191 */  immI_M1_rule,
  /*  192 */  immI_rule,
  /*  193 */  immL_M1_rule,
  /*  194 */  iRegIorL2I_rule,
  /*  195 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  196 */  iRegL_rule,
  /*  197 */  _URShiftL_iRegL_immI_rule,
  /*  198 */  iRegIorL2I_rule,
  /*  199 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  200 */  iRegL_rule,
  /*  201 */  _RShiftL_iRegL_immI_rule,
  /*  202 */  iRegIorL2I_rule,
  /*  203 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  204 */  iRegL_rule,
  /*  205 */  _LShiftL_iRegL_immI_rule,
  /*  206 */  immI_bitmask_rule,
  /*  207 */  iRegI_rule,
  /*  208 */  iRegI_rule,
  /*  209 */  _SubI_immI_64_iRegI_rule,
  /*  210 */  iRegI_rule,
  /*  211 */  _SubI_immI0_iRegI_rule,
  /*  212 */  iRegI_rule,
  /*  213 */  iRegI_rule,
  /*  214 */  _SubI_immI_32_iRegI_rule,
  /*  215 */  _SubI_immI0_iRegI_rule,
  /*  216 */  iRegI_rule,
  /*  217 */  _SubI_immI_64_iRegI_rule,
  /*  218 */  _SubI_immI0_iRegI_rule,
  /*  219 */  iRegI_rule,
  /*  220 */  _SubI_immI_32_iRegI_rule,
  /*  221 */  _SubI_immI0_iRegI_rule,
  /*  222 */  immI_16_rule,
  /*  223 */  immI_16_rule,
  /*  224 */  immI_24_rule,
  /*  225 */  immI_24_rule,
  /*  226 */  immI_24_rule,
  /*  227 */  immI_48_rule,
  /*  228 */  immI_48_rule,
  /*  229 */  immI_32_rule,
  /*  230 */  immI_32_rule,
  /*  231 */  immI_56_rule,
  /*  232 */  immI_56_rule,
  /*  233 */  immI_56_rule,
  /*  234 */  immI_255_rule,
  /*  235 */  immI_65535_rule,
  /*  236 */  immL_255_rule,
  /*  237 */  immL_65535_rule,
  /*  238 */  immL_4294967295_rule,
  /*  239 */  0,
  /*  240 */  0,
  /*  241 */  iRegIorL2I_rule,
  /*  242 */  iRegL_rule,
  /*  243 */  immI0_rule,
  /*  244 */  immL0_rule,
  /*  245 */  immP0_rule,
  /*  246 */  iRegP_R0_rule,
  /*  247 */  iRegI_R2_rule,
  /*  248 */  iRegI_R4_rule,
  /*  249 */  iRegI_R4_rule,
  /*  250 */  iRegI_R2_rule,
  /*  251 */  immI_le_4_rule,
  /*  252 */  iRegP_R3_rule,
  /*  253 */  iRegI_R3_rule,
  // last internally defined operand
  /*  254 */  0,
  /*  255 */  0,
  /*  256 */  0,
  /*  257 */  0,
  /*  258 */  0,
  /*  259 */  0,
  /*  260 */  0,
  /*  261 */  0,
  /*  262 */  0,
  /*  263 */  0,
  /*  264 */  0,
  /*  265 */  0,
  /*  266 */  0,
  /*  267 */  0,
  /*  268 */  0,
  /*  269 */  0,
  /*  270 */  0,
  /*  271 */  0,
  /*  272 */  0,
  /*  273 */  0,
  /*  274 */  0,
  /*  275 */  0,
  /*  276 */  0,
  /*  277 */  _Binary_iRegP_iRegP_rule,
  /*  278 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  279 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  280 */  0,
  /*  281 */  0,
  /*  282 */  0,
  /*  283 */  0,
  /*  284 */  0,
  /*  285 */  0,
  /*  286 */  0,
  /*  287 */  0,
  /*  288 */  0,
  /*  289 */  0,
  /*  290 */  0,
  /*  291 */  0,
  /*  292 */  iRegIorL2I_rule,
  /*  293 */  immIAddSub_rule,
  /*  294 */  iRegL_rule,
  /*  295 */  immLAddSub_rule,
  /*  296 */  iRegIorL2I_rule,
  /*  297 */  immIAddSub_rule,
  /*  298 */  iRegL_rule,
  /*  299 */  immLAddSub_rule,
  /*  300 */  iRegIorL2I_rule,
  /*  301 */  iRegL_rule,
  /*  302 */  iRegIorL2I_rule,
  /*  303 */  iRegL_rule,
  /*  304 */  iRegI_rule,
  /*  305 */  immI0_rule,
  /*  306 */  immIAddSub_rule,
  /*  307 */  immI_rule,
  /*  308 */  iRegI_rule,
  /*  309 */  immI0_rule,
  /*  310 */  immIAddSub_rule,
  /*  311 */  immI_rule,
  /*  312 */  iRegL_rule,
  /*  313 */  immI0_rule,
  /*  314 */  immLAddSub_rule,
  /*  315 */  immL_rule,
  /*  316 */  iRegP_rule,
  /*  317 */  iRegN_rule,
  /*  318 */  immP0_rule,
  /*  319 */  immN0_rule,
  /*  320 */  vRegF_rule,
  /*  321 */  immF0_rule,
  /*  322 */  vRegD_rule,
  /*  323 */  immD0_rule,
  /*  324 */  iRegP_rule,
  /*  325 */  iRegP_rule,
  /*  326 */  immP0_rule,
  /*  327 */  0,
  /*  328 */  0,
  /*  329 */  0,
  /*  330 */  0,
  /*  331 */  0,
  /*  332 */  0,
  /*  333 */  0,
  /*  334 */  0,
  /*  335 */  0,
  /*  336 */  0,
  /*  337 */  0,
  /*  338 */  0,
  /*  339 */  0,
  /*  340 */  immL_32bits_rule,
  /*  341 */  0,
  /*  342 */  0,
  /*  343 */  0,
  /*  344 */  0,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  immI0_rule,
  /*  350 */  iRegIorL2I_rule,
  /*  351 */  immI0_rule,
  /*  352 */  iRegIorL2I_rule,
  /*  353 */  immI0_rule,
  /*  354 */  iRegIorL2I_rule,
  /*  355 */  immI0_rule,
  /*  356 */  iRegL_rule,
  /*  357 */  immL0_rule,
  /*  358 */  iRegP_rule,
  /*  359 */  immP0_rule,
  /*  360 */  iRegN_rule,
  /*  361 */  immN0_rule,
  /*  362 */  vRegF_rule,
  /*  363 */  vRegD_rule,
  /*  364 */  iRegN_rule,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  0,
  /*  377 */  0,
  /*  378 */  0,
  /*  379 */  0,
  /*  380 */  0,
  /*  381 */  0,
  /*  382 */  0,
  /*  383 */  0,
  /*  384 */  0,
  /*  385 */  0,
  /*  386 */  0,
  /*  387 */  0,
  /*  388 */  0,
  /*  389 */  0,
  /*  390 */  0,
  /*  391 */  0,
  /*  392 */  0,
  /*  393 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  394 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  395 */  _Binary_iRegP_iRegP_rule,
  /*  396 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  397 */  iRegINoSp_rule,
  /*  398 */  iRegLNoSp_rule,
  /*  399 */  iRegNNoSp_rule,
  /*  400 */  iRegPNoSp_rule,
  /*  401 */  iRegL_rule,
  /*  402 */  iRegL_rule,
  /*  403 */  immLAddSub_rule,
  /*  404 */  immLAddSub_rule,
  /*  405 */  iRegIorL2I_rule,
  /*  406 */  iRegIorL2I_rule,
  /*  407 */  immIAddSub_rule,
  /*  408 */  immIAddSub_rule,
  /*  409 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  410 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  411 */  _Binary_immI0_iRegIorL2I_rule,
  /*  412 */  _Binary_immI0_iRegIorL2I_rule,
  /*  413 */  _Binary_iRegIorL2I_immI0_rule,
  /*  414 */  _Binary_iRegIorL2I_immI0_rule,
  /*  415 */  _Binary_immI_1_immI0_rule,
  /*  416 */  _Binary_immI_1_immI0_rule,
  /*  417 */  _Binary_iRegL_iRegL_rule,
  /*  418 */  _Binary_iRegL_iRegL_rule,
  /*  419 */  _Binary_iRegL_immL0_rule,
  /*  420 */  _Binary_iRegL_immL0_rule,
  /*  421 */  _Binary_immL0_iRegL_rule,
  /*  422 */  _Binary_immL0_iRegL_rule,
  /*  423 */  _Binary_iRegP_iRegP_rule,
  /*  424 */  _Binary_iRegP_iRegP_rule,
  /*  425 */  _Binary_iRegP_immP0_rule,
  /*  426 */  _Binary_iRegP_immP0_rule,
  /*  427 */  _Binary_immP0_iRegP_rule,
  /*  428 */  _Binary_immP0_iRegP_rule,
  /*  429 */  _Binary_iRegN_iRegN_rule,
  /*  430 */  _Binary_iRegN_iRegN_rule,
  /*  431 */  _Binary_iRegN_immN0_rule,
  /*  432 */  _Binary_iRegN_immN0_rule,
  /*  433 */  _Binary_immN0_iRegN_rule,
  /*  434 */  _Binary_immN0_iRegN_rule,
  /*  435 */  _Binary_vRegF_vRegF_rule,
  /*  436 */  _Binary_vRegF_vRegF_rule,
  /*  437 */  _Binary_vRegD_vRegD_rule,
  /*  438 */  _Binary_vRegD_vRegD_rule,
  /*  439 */  iRegIorL2I_rule,
  /*  440 */  immIAddSub_rule,
  /*  441 */  immIAddSub_rule,
  /*  442 */  iRegL_rule,
  /*  443 */  _ConvI2L_iRegIorL2I__rule,
  /*  444 */  _LShiftL_iRegL_immIScale_rule,
  /*  445 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  446 */  immI_rule,
  /*  447 */  immLAddSub_rule,
  /*  448 */  iRegL_rule,
  /*  449 */  immLAddSub_rule,
  /*  450 */  iRegIorL2I_rule,
  /*  451 */  immIAddSub_rule,
  /*  452 */  iRegL_rule,
  /*  453 */  immLAddSub_rule,
  /*  454 */  iRegIorL2I_rule,
  /*  455 */  iRegIorL2I_rule,
  /*  456 */  iRegIorL2I_rule,
  /*  457 */  _ConvI2L_iRegIorL2I__rule,
  /*  458 */  _ConvI2L_iRegIorL2I__rule,
  /*  459 */  iRegL_rule,
  /*  460 */  iRegL_rule,
  /*  461 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  462 */  iRegIorL2I_rule,
  /*  463 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  464 */  _MulL_iRegL_iRegL_rule,
  /*  465 */  iRegL_rule,
  /*  466 */  _MulL_iRegL_iRegL_rule,
  /*  467 */  iRegIorL2I_rule,
  /*  468 */  immI_31_rule,
  /*  469 */  _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule,
  /*  470 */  iRegIorL2I_rule,
  /*  471 */  iRegL_rule,
  /*  472 */  immL_63_rule,
  /*  473 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  474 */  iRegL_rule,
  /*  475 */  iRegIorL2I_rule,
  /*  476 */  iRegL_rule,
  /*  477 */  iRegIorL2I_rule,
  /*  478 */  immI_rule,
  /*  479 */  iRegIorL2I_rule,
  /*  480 */  immI_rule,
  /*  481 */  iRegIorL2I_rule,
  /*  482 */  immI_rule,
  /*  483 */  iRegIorL2I_rule,
  /*  484 */  immI_rule,
  /*  485 */  iRegIorL2I_rule,
  /*  486 */  immI_rule,
  /*  487 */  immI_rule,
  /*  488 */  iRegIorL2I_rule,
  /*  489 */  immI_rule,
  /*  490 */  immL_M1_rule,
  /*  491 */  immI_M1_rule,
  /*  492 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  493 */  iRegIorL2I_rule,
  /*  494 */  _XorL_iRegL_immL_M1_rule,
  /*  495 */  iRegL_rule,
  /*  496 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  497 */  iRegIorL2I_rule,
  /*  498 */  _XorL_iRegL_immL_M1_rule,
  /*  499 */  iRegL_rule,
  /*  500 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  501 */  immI_M1_rule,
  /*  502 */  _XorL_iRegL_iRegL_rule,
  /*  503 */  immL_M1_rule,
  /*  504 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  505 */  iRegIorL2I_rule,
  /*  506 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  507 */  iRegL_rule,
  /*  508 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  509 */  iRegIorL2I_rule,
  /*  510 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  511 */  iRegL_rule,
  /*  512 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  513 */  iRegIorL2I_rule,
  /*  514 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  515 */  iRegL_rule,
  /*  516 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  517 */  immI_M1_rule,
  /*  518 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  519 */  immI_M1_rule,
  /*  520 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  521 */  immL_M1_rule,
  /*  522 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  523 */  immL_M1_rule,
  /*  524 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  525 */  immI_M1_rule,
  /*  526 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  527 */  immI_M1_rule,
  /*  528 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  529 */  immL_M1_rule,
  /*  530 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  531 */  immL_M1_rule,
  /*  532 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  533 */  immI_M1_rule,
  /*  534 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  535 */  immI_M1_rule,
  /*  536 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  537 */  immL_M1_rule,
  /*  538 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  539 */  immL_M1_rule,
  /*  540 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  541 */  iRegIorL2I_rule,
  /*  542 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  543 */  iRegL_rule,
  /*  544 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  545 */  iRegIorL2I_rule,
  /*  546 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  547 */  iRegL_rule,
  /*  548 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  549 */  iRegIorL2I_rule,
  /*  550 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  551 */  iRegL_rule,
  /*  552 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  553 */  iRegIorL2I_rule,
  /*  554 */  _URShiftL_iRegL_immI_rule,
  /*  555 */  iRegL_rule,
  /*  556 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  557 */  iRegIorL2I_rule,
  /*  558 */  _RShiftL_iRegL_immI_rule,
  /*  559 */  iRegL_rule,
  /*  560 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  561 */  iRegIorL2I_rule,
  /*  562 */  _LShiftL_iRegL_immI_rule,
  /*  563 */  iRegL_rule,
  /*  564 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  565 */  iRegIorL2I_rule,
  /*  566 */  _URShiftL_iRegL_immI_rule,
  /*  567 */  iRegL_rule,
  /*  568 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  569 */  iRegIorL2I_rule,
  /*  570 */  _RShiftL_iRegL_immI_rule,
  /*  571 */  iRegL_rule,
  /*  572 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  573 */  iRegIorL2I_rule,
  /*  574 */  _LShiftL_iRegL_immI_rule,
  /*  575 */  iRegL_rule,
  /*  576 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  577 */  iRegIorL2I_rule,
  /*  578 */  _URShiftL_iRegL_immI_rule,
  /*  579 */  iRegL_rule,
  /*  580 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  581 */  iRegIorL2I_rule,
  /*  582 */  _RShiftL_iRegL_immI_rule,
  /*  583 */  iRegL_rule,
  /*  584 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  585 */  iRegIorL2I_rule,
  /*  586 */  _LShiftL_iRegL_immI_rule,
  /*  587 */  iRegL_rule,
  /*  588 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  589 */  iRegIorL2I_rule,
  /*  590 */  _URShiftL_iRegL_immI_rule,
  /*  591 */  iRegL_rule,
  /*  592 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  593 */  iRegIorL2I_rule,
  /*  594 */  _RShiftL_iRegL_immI_rule,
  /*  595 */  iRegL_rule,
  /*  596 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  597 */  iRegIorL2I_rule,
  /*  598 */  _LShiftL_iRegL_immI_rule,
  /*  599 */  iRegL_rule,
  /*  600 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  601 */  _URShiftL_iRegL_immI_rule,
  /*  602 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  603 */  _RShiftL_iRegL_immI_rule,
  /*  604 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  605 */  _LShiftL_iRegL_immI_rule,
  /*  606 */  immI_rule,
  /*  607 */  immI_rule,
  /*  608 */  immI_rule,
  /*  609 */  immI_rule,
  /*  610 */  immI_bitmask_rule,
  /*  611 */  immL_bitmask_rule,
  /*  612 */  0,
  /*  613 */  _URShiftL_iRegL_immI_rule,
  /*  614 */  _LShiftL_iRegL_immI_rule,
  /*  615 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  616 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  617 */  _URShiftL_iRegL_immI_rule,
  /*  618 */  _LShiftL_iRegL_immI_rule,
  /*  619 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  620 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  624 */  _LShiftL_iRegL_iRegI_rule,
  /*  625 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  626 */  _LShiftL_iRegL_iRegI_rule,
  /*  627 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  628 */  _LShiftI_iRegL_iRegI_rule,
  /*  629 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  630 */  _LShiftI_iRegL_iRegI_rule,
  /*  631 */  0,
  /*  632 */  0,
  /*  633 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  634 */  _URShiftL_iRegL_iRegI_rule,
  /*  635 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  636 */  _URShiftL_iRegL_iRegI_rule,
  /*  637 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  638 */  _URShiftI_iRegL_iRegI_rule,
  /*  639 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  640 */  _URShiftI_iRegL_iRegI_rule,
  /*  641 */  _ConvI2L_iRegIorL2I__rule,
  /*  642 */  iRegL_rule,
  /*  643 */  _ConvI2L_iRegIorL2I__rule,
  /*  644 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  645 */  iRegIorL2I_rule,
  /*  646 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  647 */  iRegIorL2I_rule,
  /*  648 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  649 */  iRegIorL2I_rule,
  /*  650 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  651 */  iRegL_rule,
  /*  652 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  653 */  iRegL_rule,
  /*  654 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  655 */  iRegL_rule,
  /*  656 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  657 */  iRegL_rule,
  /*  658 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  659 */  iRegIorL2I_rule,
  /*  660 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  661 */  iRegIorL2I_rule,
  /*  662 */  _AndL_iRegL_immL_255_rule,
  /*  663 */  iRegL_rule,
  /*  664 */  _AndL_iRegL_immL_65535_rule,
  /*  665 */  iRegL_rule,
  /*  666 */  _AndL_iRegL_immL_4294967295_rule,
  /*  667 */  iRegL_rule,
  /*  668 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  669 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  670 */  _AndL_iRegL_immL_255_rule,
  /*  671 */  _AndL_iRegL_immL_65535_rule,
  /*  672 */  _AndL_iRegL_immL_4294967295_rule,
  /*  673 */  vRegF_rule,
  /*  674 */  vRegD_rule,
  /*  675 */  vRegF_rule,
  /*  676 */  vRegD_rule,
  /*  677 */  vRegF_rule,
  /*  678 */  vRegD_rule,
  /*  679 */  vRegF_rule,
  /*  680 */  vRegD_rule,
  /*  681 */  0,
  /*  682 */  0,
  /*  683 */  iRegIorL2I_rule,
  /*  684 */  immILog_rule,
  /*  685 */  iRegIorL2I_rule,
  /*  686 */  immILog_rule,
  /*  687 */  iRegIorL2I_rule,
  /*  688 */  immILog_rule,
  /*  689 */  iRegL_rule,
  /*  690 */  immLLog_rule,
  /*  691 */  iRegL_rule,
  /*  692 */  immLLog_rule,
  /*  693 */  iRegL_rule,
  /*  694 */  immLLog_rule,
  /*  695 */  0,
  /*  696 */  immL_32bits_rule,
  /*  697 */  0,
  /*  698 */  0,
  /*  699 */  0,
  /*  700 */  0,
  /*  701 */  0,
  /*  702 */  0,
  /*  703 */  0,
  /*  704 */  0,
  /*  705 */  0,
  /*  706 */  0,
  /*  707 */  0,
  /*  708 */  0,
  /*  709 */  0,
  /*  710 */  0,
  /*  711 */  0,
  /*  712 */  0,
  /*  713 */  0,
  /*  714 */  iRegP_R10_rule,
  /*  715 */  _OverflowMulI_iRegIorL2I_iRegIorL2I_rule,
  /*  716 */  _OverflowMulL_iRegL_iRegL_rule,
  /*  717 */  vRegF_rule,
  /*  718 */  vRegD_rule,
  /*  719 */  immF0_rule,
  /*  720 */  immD0_rule,
  /*  721 */  iRegL_rule,
  /*  722 */  iRegIorL2I_rule,
  /*  723 */  immI0_rule,
  /*  724 */  iRegI_rule,
  /*  725 */  iRegI_rule,
  /*  726 */  0,
  /*  727 */  rFlagsReg_rule,
  /*  728 */  rFlagsRegU_rule,
  /*  729 */  _CmpI_iRegIorL2I_immI0_rule,
  /*  730 */  _CmpL_iRegL_immL0_rule,
  /*  731 */  _CmpP_iRegP_immP0_rule,
  /*  732 */  rFlagsReg_rule,
  /*  733 */  rFlagsRegU_rule,
  /*  734 */  0,
  /*  735 */  0,
  /*  736 */  0,
  /*  737 */  0,
  /*  738 */  0,
  /*  739 */  0,
  /*  740 */  0,
  /*  741 */  inline_cache_RegP_rule,
  /*  742 */  iRegP_R0_rule,
  /*  743 */  0,
  /*  744 */  0,
  /*  745 */  0,
  /*  746 */  0,
  /*  747 */  iRegP_R0_rule,
  /*  748 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  749 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  750 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  751 */  iRegI_R4_rule,
  /*  752 */  iRegP_R2_rule,
  /*  753 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /*  754 */  0,
  /*  755 */  0,
  /*  756 */  0,
  /*  757 */  vecD_rule,
  /*  758 */  vecD_rule,
  /*  759 */  vecX_rule,
  /*  760 */  0,
  /*  761 */  0,
  /*  762 */  0,
  /*  763 */  0,
  /*  764 */  0,
  /*  765 */  0,
  /*  766 */  0,
  /*  767 */  0,
  /*  768 */  0,
  /*  769 */  0,
  /*  770 */  0,
  /*  771 */  0,
  /*  772 */  0,
  /*  773 */  0,
  /*  774 */  0,
  /*  775 */  0,
  /*  776 */  0,
  /*  777 */  vecD_rule,
  /*  778 */  vecX_rule,
  /*  779 */  vecD_rule,
  /*  780 */  vecX_rule,
  /*  781 */  vecD_rule,
  /*  782 */  vecX_rule,
  /*  783 */  vecX_rule,
  /*  784 */  vecD_rule,
  /*  785 */  vecX_rule,
  /*  786 */  vecX_rule,
  /*  787 */  vecD_rule,
  /*  788 */  vecX_rule,
  /*  789 */  vecD_rule,
  /*  790 */  vecX_rule,
  /*  791 */  vecD_rule,
  /*  792 */  vecX_rule,
  /*  793 */  vecX_rule,
  /*  794 */  vecD_rule,
  /*  795 */  vecX_rule,
  /*  796 */  vecX_rule,
  /*  797 */  vecD_rule,
  /*  798 */  vecX_rule,
  /*  799 */  vecD_rule,
  /*  800 */  vecX_rule,
  /*  801 */  vecD_rule,
  /*  802 */  vecX_rule,
  /*  803 */  vecX_rule,
  /*  804 */  vecD_rule,
  /*  805 */  vecX_rule,
  /*  806 */  vecX_rule,
  /*  807 */  vecD_rule,
  /*  808 */  vecX_rule,
  /*  809 */  vecD_rule,
  /*  810 */  vecX_rule,
  /*  811 */  vecD_rule,
  /*  812 */  vecX_rule,
  /*  813 */  vecX_rule,
  /*  814 */  vecX_rule,
  /*  815 */  vecX_rule,
  /*  816 */  vecX_rule,
  /*  817 */  vecX_rule,
  /*  818 */  vecX_rule,
  /*  819 */  immI_rule,
  /*  820 */  immI_rule,
  /*  821 */  immI_rule,
  /*  822 */  immI_rule,
  /*  823 */  immI_rule,
  /*  824 */  immI_rule,
  /*  825 */  vecX_rule,
  /*  826 */  vecX_rule,
  /*  827 */  vecX_rule,
  /*  828 */  vecX_rule,
  /*  829 */  vecX_rule,
  /*  830 */  vecX_rule,
  /*  831 */  immI_rule,
  /*  832 */  immI_rule,
  /*  833 */  immI_rule,
  /*  834 */  immI_rule,
  /*  835 */  immI_rule,
  /*  836 */  immI_rule,
  /*  837 */  vecX_rule,
  /*  838 */  vecX_rule,
  /*  839 */  vecX_rule,
  /*  840 */  vecX_rule,
  /*  841 */  vecX_rule,
  /*  842 */  vecX_rule,
  /*  843 */  immI_rule,
  /*  844 */  immI_rule,
  /*  845 */  immI_rule,
  /*  846 */  immI_rule,
  /*  847 */  immI_rule,
  /*  848 */  immI_rule,
  /*  849 */  vecX_rule,
  /*  850 */  vecX_rule,
  /*  851 */  vecX_rule,
  /*  852 */  immI_rule,
  /*  853 */  immI_rule,
  /*  854 */  immI_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMI_LE_4",
  /*   13 */  "IMMI_31",
  /*   14 */  "IMMI_8",
  /*   15 */  "IMMI_16",
  /*   16 */  "IMMI_24",
  /*   17 */  "IMMI_32",
  /*   18 */  "IMMI_48",
  /*   19 */  "IMMI_56",
  /*   20 */  "IMMI_64",
  /*   21 */  "IMMI_255",
  /*   22 */  "IMMI_65535",
  /*   23 */  "IMML_63",
  /*   24 */  "IMML_255",
  /*   25 */  "IMML_65535",
  /*   26 */  "IMML_4294967295",
  /*   27 */  "IMML_BITMASK",
  /*   28 */  "IMMI_BITMASK",
  /*   29 */  "IMMISCALE",
  /*   30 */  "IMMI26",
  /*   31 */  "IMMI19",
  /*   32 */  "IMMIU12",
  /*   33 */  "IMMLU12",
  /*   34 */  "IMMIOFFSET",
  /*   35 */  "IMMLOFFSET",
  /*   36 */  "IMMIADDSUB",
  /*   37 */  "IMMILOG",
  /*   38 */  "IMML",
  /*   39 */  "IMML0",
  /*   40 */  "IMML_1",
  /*   41 */  "IMML_M1",
  /*   42 */  "IMML_PC_OFF",
  /*   43 */  "IMMLADDSUB",
  /*   44 */  "IMMLLOG",
  /*   45 */  "IMML_32BITS",
  /*   46 */  "IMMP",
  /*   47 */  "IMMP0",
  /*   48 */  "IMMP_1",
  /*   49 */  "IMMPOLLPAGE",
  /*   50 */  "IMMBYTEMAPBASE",
  /*   51 */  "IMMP_M1",
  /*   52 */  "IMMP_M2",
  /*   53 */  "IMMD",
  /*   54 */  "IMMD0",
  /*   55 */  "IMMDPACKED",
  /*   56 */  "IMMF",
  /*   57 */  "IMMF0",
  /*   58 */  "IMMFPACKED",
  /*   59 */  "IMMN",
  /*   60 */  "IMMN0",
  /*   61 */  "IMMNKLASS",
  /*   62 */  "IREGI",
  /*   63 */  "IREGINOSP",
  /*   64 */  "IREGL",
  /*   65 */  "IREGLNOSP",
  /*   66 */  "IREGP",
  /*   67 */  "IREGPNOSP",
  /*   68 */  "IREGP_R0",
  /*   69 */  "IREGP_R1",
  /*   70 */  "IREGP_R2",
  /*   71 */  "IREGP_R3",
  /*   72 */  "IREGP_R4",
  /*   73 */  "IREGP_R5",
  /*   74 */  "IREGP_R10",
  /*   75 */  "IREGL_R11",
  /*   76 */  "IREGP_FP",
  /*   77 */  "IREGI_R0",
  /*   78 */  "IREGI_R2",
  /*   79 */  "IREGI_R3",
  /*   80 */  "IREGI_R4",
  /*   81 */  "IREGN",
  /*   82 */  "IREGNNOSP",
  /*   83 */  "IREGIHEAPBASE",
  /*   84 */  "VREGF",
  /*   85 */  "VREGD",
  /*   86 */  "VECD",
  /*   87 */  "VECX",
  /*   88 */  "VREGD_V0",
  /*   89 */  "VREGD_V1",
  /*   90 */  "VREGD_V2",
  /*   91 */  "VREGD_V3",
  /*   92 */  "RFLAGSREG",
  /*   93 */  "RFLAGSREGU",
  /*   94 */  "INLINE_CACHE_REGP",
  /*   95 */  "INTERPRETER_METHOD_OOP_REGP",
  /*   96 */  "THREAD_REGP",
  /*   97 */  "LR_REGP",
  /*   98 */  "INDIRECT",
  /*   99 */  "INDINDEXSCALEDOFFSETI",
  /*  100 */  "INDINDEXSCALEDOFFSETL",
  /*  101 */  "INDINDEXOFFSETI2L",
  /*  102 */  "INDINDEXSCALEDOFFSETI2L",
  /*  103 */  "INDINDEXSCALEDI2L",
  /*  104 */  "INDINDEXSCALED",
  /*  105 */  "INDINDEX",
  /*  106 */  "INDOFFI",
  /*  107 */  "INDOFFL",
  /*  108 */  "INDIRECTN",
  /*  109 */  "INDINDEXSCALEDOFFSETIN",
  /*  110 */  "INDINDEXSCALEDOFFSETLN",
  /*  111 */  "INDINDEXOFFSETI2LN",
  /*  112 */  "INDINDEXSCALEDOFFSETI2LN",
  /*  113 */  "INDINDEXSCALEDI2LN",
  /*  114 */  "INDINDEXSCALEDN",
  /*  115 */  "INDINDEXN",
  /*  116 */  "INDOFFIN",
  /*  117 */  "INDOFFLN",
  /*  118 */  "THREAD_ANCHOR_PC",
  /*  119 */  "STACKSLOTP",
  /*  120 */  "STACKSLOTI",
  /*  121 */  "STACKSLOTF",
  /*  122 */  "STACKSLOTD",
  /*  123 */  "STACKSLOTL",
  /*  124 */  "CMPOP",
  /*  125 */  "CMPOPU",
  /*  126 */  "IREGL2I",
  // last operand
  /*  127 */  "VMEM",
  /*  128 */  "MEMORY",
  /*  129 */  "IREGIORL2I",
  // last operand class
  /*  130 */  "_LShiftL_iRegL_immIScale",
  /*  131 */  "_AddP_iRegP__LShiftL_iRegL_immIScale",
  /*  132 */  "_ConvI2L_iRegI_",
  /*  133 */  "_AddP_iRegP__ConvI2L_iRegI_",
  /*  134 */  "_LShiftL__ConvI2L_iRegI__immIScale",
  /*  135 */  "_AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale",
  /*  136 */  "_DecodeN_iRegN_",
  /*  137 */  "_AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale",
  /*  138 */  "_AddP__DecodeN_iRegN___ConvI2L_iRegI_",
  /*  139 */  "_AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale",
  /*  140 */  "_LoadB_memory_",
  /*  141 */  "_LoadUB_memory_",
  /*  142 */  "_LoadS_memory_",
  /*  143 */  "_LoadUS_memory_",
  /*  144 */  "_LoadI_memory_",
  /*  145 */  "_ConvI2L__LoadI_memory__",
  /*  146 */  "_LoadL_memory_",
  /*  147 */  "_CastP2X_iRegP_",
  /*  148 */  "_CastP2X__DecodeN_iRegN__",
  /*  149 */  "_Binary_iRegP_iRegP",
  /*  150 */  "_Binary_iRegLNoSp_iRegLNoSp",
  /*  151 */  "_Binary_iRegINoSp_iRegINoSp",
  /*  152 */  "_Binary_iRegNNoSp_iRegNNoSp",
  /*  153 */  "_Binary_cmpOp_rFlagsReg",
  /*  154 */  "_Binary_iRegIorL2I_iRegIorL2I",
  /*  155 */  "_Binary_cmpOpU_rFlagsRegU",
  /*  156 */  "_Binary_immI0_iRegIorL2I",
  /*  157 */  "_Binary_iRegIorL2I_immI0",
  /*  158 */  "_Binary_immI_1_immI0",
  /*  159 */  "_Binary_iRegL_iRegL",
  /*  160 */  "_Binary_iRegL_immL0",
  /*  161 */  "_Binary_immL0_iRegL",
  /*  162 */  "_Binary_iRegP_immP0",
  /*  163 */  "_Binary_immP0_iRegP",
  /*  164 */  "_Binary_iRegN_iRegN",
  /*  165 */  "_Binary_iRegN_immN0",
  /*  166 */  "_Binary_immN0_iRegN",
  /*  167 */  "_Binary_vRegF_vRegF",
  /*  168 */  "_Binary_vRegD_vRegD",
  /*  169 */  "_ConvL2I_iRegL_",
  /*  170 */  "_ConvI2L_iRegIorL2I_",
  /*  171 */  "_LShiftL__ConvI2L_iRegIorL2I__immIScale",
  /*  172 */  "_MulI_iRegIorL2I_iRegIorL2I",
  /*  173 */  "_MulL_iRegL_iRegL",
  /*  174 */  "_RShiftI_iRegIorL2I_immI_31",
  /*  175 */  "_URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31",
  /*  176 */  "_RShiftL_iRegL_immL_63",
  /*  177 */  "_URShiftL__RShiftL_iRegL_immL_63_immL_63",
  /*  178 */  "_XorI_iRegIorL2I_immI_M1",
  /*  179 */  "_XorL_iRegL_immL_M1",
  /*  180 */  "_XorI_iRegIorL2I_iRegIorL2I",
  /*  181 */  "_XorL_iRegL_iRegL",
  /*  182 */  "_URShiftI_iRegIorL2I_immI",
  /*  183 */  "_XorI__URShiftI_iRegIorL2I_immI_immI_M1",
  /*  184 */  "_URShiftL_iRegL_immI",
  /*  185 */  "_XorL__URShiftL_iRegL_immI_immL_M1",
  /*  186 */  "_RShiftI_iRegIorL2I_immI",
  /*  187 */  "_XorI__RShiftI_iRegIorL2I_immI_immI_M1",
  /*  188 */  "_RShiftL_iRegL_immI",
  /*  189 */  "_XorL__RShiftL_iRegL_immI_immL_M1",
  /*  190 */  "_LShiftI_iRegIorL2I_immI",
  /*  191 */  "_XorI__LShiftI_iRegIorL2I_immI_immI_M1",
  /*  192 */  "_LShiftL_iRegL_immI",
  /*  193 */  "_XorL__LShiftL_iRegL_immI_immL_M1",
  /*  194 */  "_XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  195 */  "_XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI",
  /*  196 */  "_XorL__URShiftL_iRegL_immI_iRegL",
  /*  197 */  "_XorL_iRegL__URShiftL_iRegL_immI",
  /*  198 */  "_XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  199 */  "_XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI",
  /*  200 */  "_XorL__RShiftL_iRegL_immI_iRegL",
  /*  201 */  "_XorL_iRegL__RShiftL_iRegL_immI",
  /*  202 */  "_XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  203 */  "_XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI",
  /*  204 */  "_XorL__LShiftL_iRegL_immI_iRegL",
  /*  205 */  "_XorL_iRegL__LShiftL_iRegL_immI",
  /*  206 */  "_AndI__URShiftI_iRegIorL2I_immI_immI_bitmask",
  /*  207 */  "_LShiftL_iRegL_iRegI",
  /*  208 */  "_SubI_immI_64_iRegI",
  /*  209 */  "_URShiftL_iRegL__SubI_immI_64_iRegI",
  /*  210 */  "_SubI_immI0_iRegI",
  /*  211 */  "_URShiftL_iRegL__SubI_immI0_iRegI",
  /*  212 */  "_LShiftI_iRegL_iRegI",
  /*  213 */  "_SubI_immI_32_iRegI",
  /*  214 */  "_URShiftI_iRegL__SubI_immI_32_iRegI",
  /*  215 */  "_URShiftI_iRegL__SubI_immI0_iRegI",
  /*  216 */  "_URShiftL_iRegL_iRegI",
  /*  217 */  "_LShiftL_iRegL__SubI_immI_64_iRegI",
  /*  218 */  "_LShiftL_iRegL__SubI_immI0_iRegI",
  /*  219 */  "_URShiftI_iRegL_iRegI",
  /*  220 */  "_LShiftI_iRegL__SubI_immI_32_iRegI",
  /*  221 */  "_LShiftI_iRegL__SubI_immI0_iRegI",
  /*  222 */  "_LShiftI_iRegIorL2I_immI_16",
  /*  223 */  "_RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16",
  /*  224 */  "_LShiftI_iRegIorL2I_immI_24",
  /*  225 */  "_RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  226 */  "_URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  227 */  "_LShiftL_iRegL_immI_48",
  /*  228 */  "_RShiftL__LShiftL_iRegL_immI_48_immI_48",
  /*  229 */  "_LShiftL_iRegL_immI_32",
  /*  230 */  "_RShiftL__LShiftL_iRegL_immI_32_immI_32",
  /*  231 */  "_LShiftL_iRegL_immI_56",
  /*  232 */  "_RShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  233 */  "_URShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  234 */  "_AndI_iRegIorL2I_immI_255",
  /*  235 */  "_AndI_iRegIorL2I_immI_65535",
  /*  236 */  "_AndL_iRegL_immL_255",
  /*  237 */  "_AndL_iRegL_immL_65535",
  /*  238 */  "_AndL_iRegL_immL_4294967295",
  /*  239 */  "_ConvF2D_vRegF_",
  /*  240 */  "_SqrtD__ConvF2D_vRegF__",
  /*  241 */  "_OverflowMulI_iRegIorL2I_iRegIorL2I",
  /*  242 */  "_OverflowMulL_iRegL_iRegL",
  /*  243 */  "_CmpI_iRegIorL2I_immI0",
  /*  244 */  "_CmpL_iRegL_immL0",
  /*  245 */  "_CmpP_iRegP_immP0",
  /*  246 */  "_PartialSubtypeCheck_iRegP_R4_iRegP_R0",
  /*  247 */  "_Binary_iRegP_R1_iRegI_R2",
  /*  248 */  "_Binary_iRegP_R3_iRegI_R4",
  /*  249 */  "_Binary_iRegP_R1_iRegI_R4",
  /*  250 */  "_Binary_iRegP_R3_iRegI_R2",
  /*  251 */  "_Binary_iRegP_R3_immI_le_4",
  /*  252 */  "_Binary_iRegP_R1_iRegP_R3",
  /*  253 */  "_Binary_iRegP_R1_iRegI_R3",
  // last internally defined operand
  /*  254 */  "loadConI",
  /*  255 */  "loadConL",
  /*  256 */  "loadConP",
  /*  257 */  "loadConP0",
  /*  258 */  "loadConP1",
  /*  259 */  "loadConPollPage",
  /*  260 */  "loadByteMapBase",
  /*  261 */  "loadConN",
  /*  262 */  "loadConN0",
  /*  263 */  "loadConNKlass",
  /*  264 */  "loadConF_packed",
  /*  265 */  "loadConF",
  /*  266 */  "loadConD_packed",
  /*  267 */  "loadConD",
  /*  268 */  "countLeadingZerosI",
  /*  269 */  "countLeadingZerosL",
  /*  270 */  "countTrailingZerosI",
  /*  271 */  "countTrailingZerosL",
  /*  272 */  "castX2P",
  /*  273 */  "castP2X",
  /*  274 */  "checkCastPP",
  /*  275 */  "castPP",
  /*  276 */  "castII",
  /*  277 */  "storePConditional",
  /*  278 */  "storeLConditional",
  /*  279 */  "storeIConditional",
  /*  280 */  "negF_reg_reg",
  /*  281 */  "negD_reg_reg",
  /*  282 */  "absF_reg",
  /*  283 */  "absD_reg",
  /*  284 */  "MoveF2I_stack_reg",
  /*  285 */  "MoveI2F_stack_reg",
  /*  286 */  "MoveD2L_stack_reg",
  /*  287 */  "MoveL2D_stack_reg",
  /*  288 */  "MoveF2I_reg_reg",
  /*  289 */  "MoveI2F_reg_reg",
  /*  290 */  "MoveD2L_reg_reg",
  /*  291 */  "MoveL2D_reg_reg",
  /*  292 */  "overflowAddI_reg_reg",
  /*  293 */  "overflowAddI_reg_imm",
  /*  294 */  "overflowAddL_reg_reg",
  /*  295 */  "overflowAddL_reg_imm",
  /*  296 */  "overflowSubI_reg_reg",
  /*  297 */  "overflowSubI_reg_imm",
  /*  298 */  "overflowSubL_reg_reg",
  /*  299 */  "overflowSubL_reg_imm",
  /*  300 */  "overflowNegI_reg",
  /*  301 */  "overflowNegL_reg",
  /*  302 */  "overflowMulI_reg",
  /*  303 */  "overflowMulL_reg",
  /*  304 */  "compI_reg_reg",
  /*  305 */  "compI_reg_immI0",
  /*  306 */  "compI_reg_immIAddSub",
  /*  307 */  "compI_reg_immI",
  /*  308 */  "compU_reg_reg",
  /*  309 */  "compU_reg_immI0",
  /*  310 */  "compU_reg_immIAddSub",
  /*  311 */  "compU_reg_immI",
  /*  312 */  "compL_reg_reg",
  /*  313 */  "compL_reg_immI0",
  /*  314 */  "compL_reg_immLAddSub",
  /*  315 */  "compL_reg_immL",
  /*  316 */  "compP_reg_reg",
  /*  317 */  "compN_reg_reg",
  /*  318 */  "testP_reg",
  /*  319 */  "testN_reg",
  /*  320 */  "compF_reg_reg",
  /*  321 */  "compF_reg_zero",
  /*  322 */  "compD_reg_reg",
  /*  323 */  "compD_reg_zero",
  /*  324 */  "cmpFastLock",
  /*  325 */  "cmpFastUnlock",
  /*  326 */  "partialSubtypeCheckVsZero",
  /*  327 */  "tlsLoadP",
  /*  328 */  "vshiftcntL",
  /*  329 */  "vshiftcntR",
  /*  330 */  "loadB",
  /*  331 */  "loadB2L",
  /*  332 */  "loadUB",
  /*  333 */  "loadUB2L",
  /*  334 */  "loadS",
  /*  335 */  "loadS2L",
  /*  336 */  "loadUS",
  /*  337 */  "loadUS2L",
  /*  338 */  "loadI",
  /*  339 */  "loadI2L",
  /*  340 */  "loadUI2L",
  /*  341 */  "loadL",
  /*  342 */  "loadRange",
  /*  343 */  "loadP",
  /*  344 */  "loadN",
  /*  345 */  "loadKlass",
  /*  346 */  "loadNKlass",
  /*  347 */  "loadF",
  /*  348 */  "loadD",
  /*  349 */  "storeimmCM0",
  /*  350 */  "storeB",
  /*  351 */  "storeimmB0",
  /*  352 */  "storeC",
  /*  353 */  "storeimmC0",
  /*  354 */  "storeI",
  /*  355 */  "storeimmI0",
  /*  356 */  "storeL",
  /*  357 */  "storeimmL0",
  /*  358 */  "storeP",
  /*  359 */  "storeimmP0",
  /*  360 */  "storeN",
  /*  361 */  "storeImmN0",
  /*  362 */  "storeF",
  /*  363 */  "storeD",
  /*  364 */  "storeNKlass",
  /*  365 */  "prefetchr",
  /*  366 */  "prefetchw",
  /*  367 */  "prefetchnta",
  /*  368 */  "bytes_reverse_int",
  /*  369 */  "bytes_reverse_long",
  /*  370 */  "bytes_reverse_unsigned_short",
  /*  371 */  "bytes_reverse_short",
  /*  372 */  "popCountI",
  /*  373 */  "popCountI_mem",
  /*  374 */  "popCountL",
  /*  375 */  "popCountL_mem",
  /*  376 */  "load_fence",
  /*  377 */  "membar_acquire",
  /*  378 */  "membar_acquire_lock",
  /*  379 */  "store_fence",
  /*  380 */  "membar_release",
  /*  381 */  "membar_storestore",
  /*  382 */  "membar_release_lock",
  /*  383 */  "membar_volatile",
  /*  384 */  "convP2I",
  /*  385 */  "convN2I",
  /*  386 */  "encodeHeapOop",
  /*  387 */  "encodeHeapOop_not_null",
  /*  388 */  "decodeHeapOop",
  /*  389 */  "decodeHeapOop_not_null",
  /*  390 */  "encodeKlass_not_null",
  /*  391 */  "decodeKlass_not_null",
  /*  392 */  "loadPLocked",
  /*  393 */  "compareAndSwapI",
  /*  394 */  "compareAndSwapL",
  /*  395 */  "compareAndSwapP",
  /*  396 */  "compareAndSwapN",
  /*  397 */  "get_and_setI",
  /*  398 */  "get_and_setL",
  /*  399 */  "get_and_setN",
  /*  400 */  "get_and_setP",
  /*  401 */  "get_and_addL",
  /*  402 */  "get_and_addL_no_res",
  /*  403 */  "get_and_addLi",
  /*  404 */  "get_and_addLi_no_res",
  /*  405 */  "get_and_addI",
  /*  406 */  "get_and_addI_no_res",
  /*  407 */  "get_and_addIi",
  /*  408 */  "get_and_addIi_no_res",
  /*  409 */  "cmovI_reg_reg",
  /*  410 */  "cmovUI_reg_reg",
  /*  411 */  "cmovI_zero_reg",
  /*  412 */  "cmovUI_zero_reg",
  /*  413 */  "cmovI_reg_zero",
  /*  414 */  "cmovUI_reg_zero",
  /*  415 */  "cmovI_reg_zero_one",
  /*  416 */  "cmovUI_reg_zero_one",
  /*  417 */  "cmovL_reg_reg",
  /*  418 */  "cmovUL_reg_reg",
  /*  419 */  "cmovL_reg_zero",
  /*  420 */  "cmovUL_reg_zero",
  /*  421 */  "cmovL_zero_reg",
  /*  422 */  "cmovUL_zero_reg",
  /*  423 */  "cmovP_reg_reg",
  /*  424 */  "cmovUP_reg_reg",
  /*  425 */  "cmovP_reg_zero",
  /*  426 */  "cmovUP_reg_zero",
  /*  427 */  "cmovP_zero_reg",
  /*  428 */  "cmovUP_zero_reg",
  /*  429 */  "cmovN_reg_reg",
  /*  430 */  "cmovUN_reg_reg",
  /*  431 */  "cmovN_reg_zero",
  /*  432 */  "cmovUN_reg_zero",
  /*  433 */  "cmovN_zero_reg",
  /*  434 */  "cmovUN_zero_reg",
  /*  435 */  "cmovF_reg",
  /*  436 */  "cmovUF_reg",
  /*  437 */  "cmovD_reg",
  /*  438 */  "cmovUD_reg",
  /*  439 */  "addI_reg_reg",
  /*  440 */  "addI_reg_imm",
  /*  441 */  "addI_reg_imm_i2l",
  /*  442 */  "addP_reg_reg",
  /*  443 */  "addP_reg_reg_ext",
  /*  444 */  "addP_reg_reg_lsl",
  /*  445 */  "addP_reg_reg_ext_shift",
  /*  446 */  "lshift_ext",
  /*  447 */  "addP_reg_imm",
  /*  448 */  "addL_reg_reg",
  /*  449 */  "addL_reg_imm",
  /*  450 */  "subI_reg_reg",
  /*  451 */  "subI_reg_imm",
  /*  452 */  "subL_reg_reg",
  /*  453 */  "subL_reg_imm",
  /*  454 */  "negI_reg",
  /*  455 */  "negL_reg",
  /*  456 */  "mulI",
  /*  457 */  "smulI",
  /*  458 */  "smulI_0",
  /*  459 */  "mulL",
  /*  460 */  "mulHiL_rReg",
  /*  461 */  "maddI",
  /*  462 */  "maddI_0",
  /*  463 */  "msubI",
  /*  464 */  "maddL",
  /*  465 */  "maddL_0",
  /*  466 */  "msubL",
  /*  467 */  "divI",
  /*  468 */  "signExtract",
  /*  469 */  "div2Round",
  /*  470 */  "div2Round_0",
  /*  471 */  "divL",
  /*  472 */  "signExtractL",
  /*  473 */  "div2RoundL",
  /*  474 */  "div2RoundL_0",
  /*  475 */  "modI",
  /*  476 */  "modL",
  /*  477 */  "lShiftI_reg_reg",
  /*  478 */  "lShiftI_reg_imm",
  /*  479 */  "urShiftI_reg_reg",
  /*  480 */  "urShiftI_reg_imm",
  /*  481 */  "rShiftI_reg_reg",
  /*  482 */  "rShiftI_reg_imm",
  /*  483 */  "lShiftL_reg_reg",
  /*  484 */  "lShiftL_reg_imm",
  /*  485 */  "urShiftL_reg_reg",
  /*  486 */  "urShiftL_reg_imm",
  /*  487 */  "urShiftP_reg_imm",
  /*  488 */  "rShiftL_reg_reg",
  /*  489 */  "rShiftL_reg_imm",
  /*  490 */  "regL_not_reg",
  /*  491 */  "regI_not_reg",
  /*  492 */  "AndI_reg_not_reg",
  /*  493 */  "AndI_reg_not_reg_0",
  /*  494 */  "AndL_reg_not_reg",
  /*  495 */  "AndL_reg_not_reg_0",
  /*  496 */  "OrI_reg_not_reg",
  /*  497 */  "OrI_reg_not_reg_0",
  /*  498 */  "OrL_reg_not_reg",
  /*  499 */  "OrL_reg_not_reg_0",
  /*  500 */  "XorI_reg_not_reg",
  /*  501 */  "XorI_reg_not_reg_0",
  /*  502 */  "XorL_reg_not_reg",
  /*  503 */  "XorL_reg_not_reg_0",
  /*  504 */  "AndI_reg_URShift_not_reg",
  /*  505 */  "AndI_reg_URShift_not_reg_0",
  /*  506 */  "AndL_reg_URShift_not_reg",
  /*  507 */  "AndL_reg_URShift_not_reg_0",
  /*  508 */  "AndI_reg_RShift_not_reg",
  /*  509 */  "AndI_reg_RShift_not_reg_0",
  /*  510 */  "AndL_reg_RShift_not_reg",
  /*  511 */  "AndL_reg_RShift_not_reg_0",
  /*  512 */  "AndI_reg_LShift_not_reg",
  /*  513 */  "AndI_reg_LShift_not_reg_0",
  /*  514 */  "AndL_reg_LShift_not_reg",
  /*  515 */  "AndL_reg_LShift_not_reg_0",
  /*  516 */  "XorI_reg_URShift_not_reg",
  /*  517 */  "XorI_reg_URShift_not_reg_1",
  /*  518 */  "XorI_reg_URShift_not_reg_0",
  /*  519 */  "XorI_reg_URShift_not_reg_2",
  /*  520 */  "XorL_reg_URShift_not_reg",
  /*  521 */  "XorL_reg_URShift_not_reg_1",
  /*  522 */  "XorL_reg_URShift_not_reg_0",
  /*  523 */  "XorL_reg_URShift_not_reg_2",
  /*  524 */  "XorI_reg_RShift_not_reg",
  /*  525 */  "XorI_reg_RShift_not_reg_1",
  /*  526 */  "XorI_reg_RShift_not_reg_0",
  /*  527 */  "XorI_reg_RShift_not_reg_2",
  /*  528 */  "XorL_reg_RShift_not_reg",
  /*  529 */  "XorL_reg_RShift_not_reg_1",
  /*  530 */  "XorL_reg_RShift_not_reg_0",
  /*  531 */  "XorL_reg_RShift_not_reg_2",
  /*  532 */  "XorI_reg_LShift_not_reg",
  /*  533 */  "XorI_reg_LShift_not_reg_1",
  /*  534 */  "XorI_reg_LShift_not_reg_0",
  /*  535 */  "XorI_reg_LShift_not_reg_2",
  /*  536 */  "XorL_reg_LShift_not_reg",
  /*  537 */  "XorL_reg_LShift_not_reg_1",
  /*  538 */  "XorL_reg_LShift_not_reg_0",
  /*  539 */  "XorL_reg_LShift_not_reg_2",
  /*  540 */  "OrI_reg_URShift_not_reg",
  /*  541 */  "OrI_reg_URShift_not_reg_0",
  /*  542 */  "OrL_reg_URShift_not_reg",
  /*  543 */  "OrL_reg_URShift_not_reg_0",
  /*  544 */  "OrI_reg_RShift_not_reg",
  /*  545 */  "OrI_reg_RShift_not_reg_0",
  /*  546 */  "OrL_reg_RShift_not_reg",
  /*  547 */  "OrL_reg_RShift_not_reg_0",
  /*  548 */  "OrI_reg_LShift_not_reg",
  /*  549 */  "OrI_reg_LShift_not_reg_0",
  /*  550 */  "OrL_reg_LShift_not_reg",
  /*  551 */  "OrL_reg_LShift_not_reg_0",
  /*  552 */  "AndI_reg_URShift_reg",
  /*  553 */  "AndI_reg_URShift_reg_0",
  /*  554 */  "AndL_reg_URShift_reg",
  /*  555 */  "AndL_reg_URShift_reg_0",
  /*  556 */  "AndI_reg_RShift_reg",
  /*  557 */  "AndI_reg_RShift_reg_0",
  /*  558 */  "AndL_reg_RShift_reg",
  /*  559 */  "AndL_reg_RShift_reg_0",
  /*  560 */  "AndI_reg_LShift_reg",
  /*  561 */  "AndI_reg_LShift_reg_0",
  /*  562 */  "AndL_reg_LShift_reg",
  /*  563 */  "AndL_reg_LShift_reg_0",
  /*  564 */  "XorI_reg_URShift_reg",
  /*  565 */  "XorI_reg_URShift_reg_0",
  /*  566 */  "XorL_reg_URShift_reg",
  /*  567 */  "XorL_reg_URShift_reg_0",
  /*  568 */  "XorI_reg_RShift_reg",
  /*  569 */  "XorI_reg_RShift_reg_0",
  /*  570 */  "XorL_reg_RShift_reg",
  /*  571 */  "XorL_reg_RShift_reg_0",
  /*  572 */  "XorI_reg_LShift_reg",
  /*  573 */  "XorI_reg_LShift_reg_0",
  /*  574 */  "XorL_reg_LShift_reg",
  /*  575 */  "XorL_reg_LShift_reg_0",
  /*  576 */  "OrI_reg_URShift_reg",
  /*  577 */  "OrI_reg_URShift_reg_0",
  /*  578 */  "OrL_reg_URShift_reg",
  /*  579 */  "OrL_reg_URShift_reg_0",
  /*  580 */  "OrI_reg_RShift_reg",
  /*  581 */  "OrI_reg_RShift_reg_0",
  /*  582 */  "OrL_reg_RShift_reg",
  /*  583 */  "OrL_reg_RShift_reg_0",
  /*  584 */  "OrI_reg_LShift_reg",
  /*  585 */  "OrI_reg_LShift_reg_0",
  /*  586 */  "OrL_reg_LShift_reg",
  /*  587 */  "OrL_reg_LShift_reg_0",
  /*  588 */  "AddI_reg_URShift_reg",
  /*  589 */  "AddI_reg_URShift_reg_0",
  /*  590 */  "AddL_reg_URShift_reg",
  /*  591 */  "AddL_reg_URShift_reg_0",
  /*  592 */  "AddI_reg_RShift_reg",
  /*  593 */  "AddI_reg_RShift_reg_0",
  /*  594 */  "AddL_reg_RShift_reg",
  /*  595 */  "AddL_reg_RShift_reg_0",
  /*  596 */  "AddI_reg_LShift_reg",
  /*  597 */  "AddI_reg_LShift_reg_0",
  /*  598 */  "AddL_reg_LShift_reg",
  /*  599 */  "AddL_reg_LShift_reg_0",
  /*  600 */  "SubI_reg_URShift_reg",
  /*  601 */  "SubL_reg_URShift_reg",
  /*  602 */  "SubI_reg_RShift_reg",
  /*  603 */  "SubL_reg_RShift_reg",
  /*  604 */  "SubI_reg_LShift_reg",
  /*  605 */  "SubL_reg_LShift_reg",
  /*  606 */  "sbfmL",
  /*  607 */  "sbfmwI",
  /*  608 */  "ubfmL",
  /*  609 */  "ubfmwI",
  /*  610 */  "ubfxwI",
  /*  611 */  "ubfxL",
  /*  612 */  "ubfxIConvI2L",
  /*  613 */  "extrOrL",
  /*  614 */  "extrOrL_0",
  /*  615 */  "extrOrI",
  /*  616 */  "extrOrI_0",
  /*  617 */  "extrAddL",
  /*  618 */  "extrAddL_0",
  /*  619 */  "extrAddI",
  /*  620 */  "extrAddI_0",
  /*  621 */  "rolL_rReg",
  /*  622 */  "rolI_rReg",
  /*  623 */  "rolL_rReg_Var_C_64",
  /*  624 */  "rolL_rReg_Var_C_64_0",
  /*  625 */  "rolL_rReg_Var_C0",
  /*  626 */  "rolL_rReg_Var_C0_0",
  /*  627 */  "rolI_rReg_Var_C_32",
  /*  628 */  "rolI_rReg_Var_C_32_0",
  /*  629 */  "rolI_rReg_Var_C0",
  /*  630 */  "rolI_rReg_Var_C0_0",
  /*  631 */  "rorL_rReg",
  /*  632 */  "rorI_rReg",
  /*  633 */  "rorL_rReg_Var_C_64",
  /*  634 */  "rorL_rReg_Var_C_64_0",
  /*  635 */  "rorL_rReg_Var_C0",
  /*  636 */  "rorL_rReg_Var_C0_0",
  /*  637 */  "rorI_rReg_Var_C_32",
  /*  638 */  "rorI_rReg_Var_C_32_0",
  /*  639 */  "rorI_rReg_Var_C0",
  /*  640 */  "rorI_rReg_Var_C0_0",
  /*  641 */  "AddExtI",
  /*  642 */  "AddExtI_0",
  /*  643 */  "SubExtI",
  /*  644 */  "AddExtI_sxth",
  /*  645 */  "AddExtI_sxth_0",
  /*  646 */  "AddExtI_sxtb",
  /*  647 */  "AddExtI_sxtb_0",
  /*  648 */  "AddExtI_uxtb",
  /*  649 */  "AddExtI_uxtb_0",
  /*  650 */  "AddExtL_sxth",
  /*  651 */  "AddExtL_sxth_0",
  /*  652 */  "AddExtL_sxtw",
  /*  653 */  "AddExtL_sxtw_0",
  /*  654 */  "AddExtL_sxtb",
  /*  655 */  "AddExtL_sxtb_0",
  /*  656 */  "AddExtL_uxtb",
  /*  657 */  "AddExtL_uxtb_0",
  /*  658 */  "AddExtI_uxtb_and",
  /*  659 */  "AddExtI_uxtb_and_0",
  /*  660 */  "AddExtI_uxth_and",
  /*  661 */  "AddExtI_uxth_and_0",
  /*  662 */  "AddExtL_uxtb_and",
  /*  663 */  "AddExtL_uxtb_and_0",
  /*  664 */  "AddExtL_uxth_and",
  /*  665 */  "AddExtL_uxth_and_0",
  /*  666 */  "AddExtL_uxtw_and",
  /*  667 */  "AddExtL_uxtw_and_0",
  /*  668 */  "SubExtI_uxtb_and",
  /*  669 */  "SubExtI_uxth_and",
  /*  670 */  "SubExtL_uxtb_and",
  /*  671 */  "SubExtL_uxth_and",
  /*  672 */  "SubExtL_uxtw_and",
  /*  673 */  "addF_reg_reg",
  /*  674 */  "addD_reg_reg",
  /*  675 */  "subF_reg_reg",
  /*  676 */  "subD_reg_reg",
  /*  677 */  "mulF_reg_reg",
  /*  678 */  "mulD_reg_reg",
  /*  679 */  "divF_reg_reg",
  /*  680 */  "divD_reg_reg",
  /*  681 */  "sqrtD_reg",
  /*  682 */  "sqrtF_reg",
  /*  683 */  "andI_reg_reg",
  /*  684 */  "andI_reg_imm",
  /*  685 */  "orI_reg_reg",
  /*  686 */  "orI_reg_imm",
  /*  687 */  "xorI_reg_reg",
  /*  688 */  "xorI_reg_imm",
  /*  689 */  "andL_reg_reg",
  /*  690 */  "andL_reg_imm",
  /*  691 */  "orL_reg_reg",
  /*  692 */  "orL_reg_imm",
  /*  693 */  "xorL_reg_reg",
  /*  694 */  "xorL_reg_imm",
  /*  695 */  "convI2L_reg_reg",
  /*  696 */  "convUI2L_reg_reg",
  /*  697 */  "convL2I_reg",
  /*  698 */  "convI2B",
  /*  699 */  "convP2B",
  /*  700 */  "convD2F_reg",
  /*  701 */  "convF2D_reg",
  /*  702 */  "convF2I_reg_reg",
  /*  703 */  "convF2L_reg_reg",
  /*  704 */  "convI2F_reg_reg",
  /*  705 */  "convL2F_reg_reg",
  /*  706 */  "convD2I_reg_reg",
  /*  707 */  "convD2L_reg_reg",
  /*  708 */  "convI2D_reg_reg",
  /*  709 */  "convL2D_reg_reg",
  /*  710 */  "MoveF2I_reg_stack",
  /*  711 */  "MoveI2F_reg_stack",
  /*  712 */  "MoveD2L_reg_stack",
  /*  713 */  "MoveL2D_reg_stack",
  /*  714 */  "clearArray_reg_reg",
  /*  715 */  "overflowMulI_reg_branch",
  /*  716 */  "overflowMulL_reg_branch",
  /*  717 */  "compF3_reg_reg",
  /*  718 */  "compD3_reg_reg",
  /*  719 */  "compF3_reg_immF0",
  /*  720 */  "compD3_reg_immD0",
  /*  721 */  "cmpL3_reg_reg",
  /*  722 */  "cmpLTMask_reg_reg",
  /*  723 */  "cmpLTMask_reg_zero",
  /*  724 */  "minI_rReg",
  /*  725 */  "maxI_rReg",
  /*  726 */  "branch",
  /*  727 */  "branchCon",
  /*  728 */  "branchConU",
  /*  729 */  "cmpI_imm0_branch",
  /*  730 */  "cmpL_imm0_branch",
  /*  731 */  "cmpP_imm0_branch",
  /*  732 */  "branchLoopEnd",
  /*  733 */  "branchLoopEndU",
  /*  734 */  "safePoint",
  /*  735 */  "CallStaticJavaDirect",
  /*  736 */  "CallStaticJavaDirectHandle",
  /*  737 */  "CallDynamicJavaDirect",
  /*  738 */  "CallRuntimeDirect",
  /*  739 */  "CallLeafDirect",
  /*  740 */  "CallLeafNoFPDirect",
  /*  741 */  "TailCalljmpInd",
  /*  742 */  "TailjmpInd",
  /*  743 */  "CreateException",
  /*  744 */  "RethrowException",
  /*  745 */  "Ret",
  /*  746 */  "ShouldNotReachHere",
  /*  747 */  "partialSubtypeCheck",
  /*  748 */  "string_compare",
  /*  749 */  "string_indexof",
  /*  750 */  "string_indexof_con",
  /*  751 */  "string_equals",
  /*  752 */  "array_equals",
  /*  753 */  "encode_iso_array",
  /*  754 */  "loadV4",
  /*  755 */  "loadV8",
  /*  756 */  "loadV16",
  /*  757 */  "storeV4",
  /*  758 */  "storeV8",
  /*  759 */  "storeV16",
  /*  760 */  "replicate8B",
  /*  761 */  "replicate16B",
  /*  762 */  "replicate8B_imm",
  /*  763 */  "replicate16B_imm",
  /*  764 */  "replicate4S",
  /*  765 */  "replicate8S",
  /*  766 */  "replicate4S_imm",
  /*  767 */  "replicate8S_imm",
  /*  768 */  "replicate2I",
  /*  769 */  "replicate4I",
  /*  770 */  "replicate2I_imm",
  /*  771 */  "replicate4I_imm",
  /*  772 */  "replicate2L",
  /*  773 */  "replicate2L_zero",
  /*  774 */  "replicate2F",
  /*  775 */  "replicate4F",
  /*  776 */  "replicate2D",
  /*  777 */  "vadd8B",
  /*  778 */  "vadd16B",
  /*  779 */  "vadd4S",
  /*  780 */  "vadd8S",
  /*  781 */  "vadd2I",
  /*  782 */  "vadd4I",
  /*  783 */  "vadd2L",
  /*  784 */  "vadd2F",
  /*  785 */  "vadd4F",
  /*  786 */  "vadd2D",
  /*  787 */  "vsub8B",
  /*  788 */  "vsub16B",
  /*  789 */  "vsub4S",
  /*  790 */  "vsub8S",
  /*  791 */  "vsub2I",
  /*  792 */  "vsub4I",
  /*  793 */  "vsub2L",
  /*  794 */  "vsub2F",
  /*  795 */  "vsub4F",
  /*  796 */  "vsub2D",
  /*  797 */  "vmul4S",
  /*  798 */  "vmul8S",
  /*  799 */  "vmul2I",
  /*  800 */  "vmul4I",
  /*  801 */  "vmul2F",
  /*  802 */  "vmul4F",
  /*  803 */  "vmul2D",
  /*  804 */  "vdiv2F",
  /*  805 */  "vdiv4F",
  /*  806 */  "vdiv2D",
  /*  807 */  "vand8B",
  /*  808 */  "vand16B",
  /*  809 */  "vor8B",
  /*  810 */  "vor16B",
  /*  811 */  "vxor8B",
  /*  812 */  "vxor16B",
  /*  813 */  "vsll8B",
  /*  814 */  "vsll8B_0",
  /*  815 */  "vsll16B",
  /*  816 */  "vsll16B_0",
  /*  817 */  "vsrl8B",
  /*  818 */  "vsrl16B",
  /*  819 */  "vsll8B_imm",
  /*  820 */  "vsll16B_imm",
  /*  821 */  "vsra8B_imm",
  /*  822 */  "vsra16B_imm",
  /*  823 */  "vsrl8B_imm",
  /*  824 */  "vsrl16B_imm",
  /*  825 */  "vsll4S",
  /*  826 */  "vsll4S_0",
  /*  827 */  "vsll8S",
  /*  828 */  "vsll8S_0",
  /*  829 */  "vsrl4S",
  /*  830 */  "vsrl8S",
  /*  831 */  "vsll4S_imm",
  /*  832 */  "vsll8S_imm",
  /*  833 */  "vsra4S_imm",
  /*  834 */  "vsra8S_imm",
  /*  835 */  "vsrl4S_imm",
  /*  836 */  "vsrl8S_imm",
  /*  837 */  "vsll2I",
  /*  838 */  "vsll2I_0",
  /*  839 */  "vsll4I",
  /*  840 */  "vsll4I_0",
  /*  841 */  "vsrl2I",
  /*  842 */  "vsrl4I",
  /*  843 */  "vsll2I_imm",
  /*  844 */  "vsll4I_imm",
  /*  845 */  "vsra2I_imm",
  /*  846 */  "vsra4I_imm",
  /*  847 */  "vsrl2I_imm",
  /*  848 */  "vsrl4I_imm",
  /*  849 */  "vsll2L",
  /*  850 */  "vsll2L_0",
  /*  851 */  "vsrl2L",
  /*  852 */  "vsll2L_imm",
  /*  853 */  "vsra2L_imm",
  /*  854 */  "vsrl2L_imm",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  true,
  /*   60 */  true,
  /*   61 */  true,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  true,
  /*  125 */  true,
  /*  126 */  false,
  // last operand
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  // last operand class
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  // last internally defined operand
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // RegFlags: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // _last_machine_leaf: 13
  0, // AbsD: 14
  0, // AbsF: 15
  0, // AbsI: 16
  0, // AddD: 17
  0, // AddF: 18
  0, // AddI: 19
  0, // AddL: 20
  0, // AddP: 21
  0, // Allocate: 22
  0, // AllocateArray: 23
  0, // AndI: 24
  0, // AndL: 25
  0, // AryEq: 26
  0, // AtanD: 27
  1, // Binary: 28
  1, // Bool: 29
  0, // BoxLock: 30
  0, // ReverseBytesI: 31
  0, // ReverseBytesL: 32
  0, // ReverseBytesUS: 33
  0, // ReverseBytesS: 34
  0, // CProj: 35
  0, // CallDynamicJava: 36
  0, // CallJava: 37
  0, // CallLeaf: 38
  0, // CallLeafNoFP: 39
  0, // CallRuntime: 40
  0, // CallStaticJava: 41
  0, // CastII: 42
  0, // CastX2P: 43
  0, // CastP2X: 44
  0, // CastPP: 45
  0, // Catch: 46
  0, // CatchProj: 47
  0, // CheckCastPP: 48
  0, // ClearArray: 49
  0, // ConstraintCast: 50
  0, // CMoveD: 51
  0, // CMoveF: 52
  0, // CMoveI: 53
  0, // CMoveL: 54
  0, // CMoveP: 55
  0, // CMoveN: 56
  1, // CmpN: 57
  1, // CmpD: 58
  0, // CmpD3: 59
  1, // CmpF: 60
  0, // CmpF3: 61
  1, // CmpI: 62
  1, // CmpL: 63
  0, // CmpL3: 64
  0, // CmpLTMask: 65
  1, // CmpP: 66
  1, // CmpU: 67
  0, // CompareAndSwapI: 68
  0, // CompareAndSwapL: 69
  0, // CompareAndSwapP: 70
  0, // CompareAndSwapN: 71
  0, // GetAndAddI: 72
  0, // GetAndAddL: 73
  0, // GetAndSetI: 74
  0, // GetAndSetL: 75
  0, // GetAndSetP: 76
  0, // GetAndSetN: 77
  0, // Con: 78
  0, // ConN: 79
  0, // ConNKlass: 80
  0, // ConD: 81
  0, // ConF: 82
  0, // ConI: 83
  0, // ConL: 84
  0, // ConP: 85
  0, // Conv2B: 86
  0, // ConvD2F: 87
  0, // ConvD2I: 88
  0, // ConvD2L: 89
  0, // ConvF2D: 90
  0, // ConvF2I: 91
  0, // ConvF2L: 92
  0, // ConvI2D: 93
  0, // ConvI2F: 94
  0, // ConvI2L: 95
  0, // ConvL2D: 96
  0, // ConvL2F: 97
  0, // ConvL2I: 98
  0, // CosD: 99
  0, // CountedLoop: 100
  0, // CountedLoopEnd: 101
  0, // CountLeadingZerosI: 102
  0, // CountLeadingZerosL: 103
  0, // CountTrailingZerosI: 104
  0, // CountTrailingZerosL: 105
  0, // CreateEx: 106
  0, // DecodeN: 107
  0, // DecodeNKlass: 108
  0, // DivD: 109
  0, // DivF: 110
  0, // DivI: 111
  0, // DivL: 112
  0, // DivMod: 113
  0, // DivModI: 114
  0, // DivModL: 115
  0, // EncodeISOArray: 116
  0, // EncodeP: 117
  0, // EncodePKlass: 118
  0, // ExpD: 119
  1, // FastLock: 120
  1, // FastUnlock: 121
  0, // Goto: 122
  0, // Halt: 123
  0, // If: 124
  0, // IfFalse: 125
  0, // IfTrue: 126
  0, // Initialize: 127
  0, // JProj: 128
  0, // Jump: 129
  0, // JumpProj: 130
  0, // LShiftI: 131
  0, // LShiftL: 132
  0, // LoadB: 133
  0, // LoadUB: 134
  0, // LoadUS: 135
  0, // LoadD: 136
  0, // LoadD_unaligned: 137
  0, // LoadF: 138
  0, // LoadI: 139
  0, // LoadKlass: 140
  0, // LoadNKlass: 141
  0, // LoadL: 142
  0, // LoadL_unaligned: 143
  0, // LoadPLocked: 144
  0, // LoadP: 145
  0, // LoadN: 146
  0, // LoadRange: 147
  0, // LoadS: 148
  0, // Lock: 149
  0, // LogD: 150
  0, // Log10D: 151
  0, // Loop: 152
  0, // LoopLimit: 153
  0, // Mach: 154
  0, // MachProj: 155
  0, // MaxI: 156
  0, // MemBarAcquire: 157
  0, // LoadFence: 158
  0, // MemBarAcquireLock: 159
  0, // MemBarCPUOrder: 160
  0, // MemBarRelease: 161
  0, // StoreFence: 162
  0, // MemBarReleaseLock: 163
  0, // MemBarVolatile: 164
  0, // MemBarStoreStore: 165
  0, // MergeMem: 166
  0, // MinI: 167
  0, // ModD: 168
  0, // ModF: 169
  0, // ModI: 170
  0, // ModL: 171
  0, // MoveI2F: 172
  0, // MoveF2I: 173
  0, // MoveL2D: 174
  0, // MoveD2L: 175
  0, // MulD: 176
  0, // MulF: 177
  0, // MulHiL: 178
  0, // MulI: 179
  0, // MulL: 180
  0, // Multi: 181
  0, // NegD: 182
  0, // NegF: 183
  0, // NeverBranch: 184
  0, // Opaque1: 185
  0, // Opaque2: 186
  0, // Opaque3: 187
  0, // ProfileBoolean: 188
  0, // OrI: 189
  0, // OrL: 190
  1, // OverflowAddI: 191
  1, // OverflowSubI: 192
  1, // OverflowMulI: 193
  1, // OverflowAddL: 194
  1, // OverflowSubL: 195
  1, // OverflowMulL: 196
  0, // PCTable: 197
  0, // Parm: 198
  0, // PartialSubtypeCheck: 199
  0, // Phi: 200
  0, // PopCountI: 201
  0, // PopCountL: 202
  0, // PowD: 203
  0, // PrefetchAllocation: 204
  0, // PrefetchRead: 205
  0, // PrefetchWrite: 206
  0, // Proj: 207
  0, // RShiftI: 208
  0, // RShiftL: 209
  0, // Region: 210
  0, // Rethrow: 211
  0, // Return: 212
  0, // Root: 213
  0, // RoundDouble: 214
  0, // RoundFloat: 215
  0, // SafePoint: 216
  0, // SafePointScalarObject: 217
  0, // SCMemProj: 218
  0, // SinD: 219
  0, // SqrtD: 220
  0, // Start: 221
  0, // StartOSR: 222
  0, // StoreB: 223
  0, // StoreC: 224
  0, // StoreCM: 225
  0, // StorePConditional: 226
  0, // StoreIConditional: 227
  0, // StoreLConditional: 228
  0, // StoreD: 229
  0, // StoreF: 230
  0, // StoreI: 231
  0, // StoreL: 232
  0, // StoreP: 233
  0, // StoreN: 234
  0, // StoreNKlass: 235
  0, // StrComp: 236
  0, // StrEquals: 237
  0, // StrIndexOf: 238
  0, // SubD: 239
  0, // SubF: 240
  0, // SubI: 241
  0, // SubL: 242
  0, // TailCall: 243
  0, // TailJump: 244
  0, // TanD: 245
  0, // ThreadLocal: 246
  0, // Unlock: 247
  0, // URShiftI: 248
  0, // URShiftL: 249
  0, // XorI: 250
  0, // XorL: 251
  0, // Vector: 252
  0, // AddVB: 253
  0, // AddVS: 254
  0, // AddVI: 255
  0, // AddVL: 256
  0, // AddVF: 257
  0, // AddVD: 258
  0, // SubVB: 259
  0, // SubVS: 260
  0, // SubVI: 261
  0, // SubVL: 262
  0, // SubVF: 263
  0, // SubVD: 264
  0, // MulVS: 265
  0, // MulVI: 266
  0, // MulVF: 267
  0, // MulVD: 268
  0, // DivVF: 269
  0, // DivVD: 270
  0, // LShiftCntV: 271
  0, // RShiftCntV: 272
  0, // LShiftVB: 273
  0, // LShiftVS: 274
  0, // LShiftVI: 275
  0, // LShiftVL: 276
  0, // RShiftVB: 277
  0, // RShiftVS: 278
  0, // RShiftVI: 279
  0, // RShiftVL: 280
  0, // URShiftVB: 281
  0, // URShiftVS: 282
  0, // URShiftVI: 283
  0, // URShiftVL: 284
  0, // AndV: 285
  0, // OrV: 286
  0, // XorV: 287
  0, // LoadVector: 288
  0, // StoreVector: 289
  0, // Pack: 290
  0, // PackB: 291
  0, // PackS: 292
  0, // PackI: 293
  0, // PackL: 294
  0, // PackF: 295
  0, // PackD: 296
  0, // Pack2L: 297
  0, // Pack2D: 298
  0, // ReplicateB: 299
  0, // ReplicateS: 300
  0, // ReplicateI: 301
  0, // ReplicateL: 302
  0, // ReplicateF: 303
  0, // ReplicateD: 304
  0, // Extract: 305
  0, // ExtractB: 306
  0, // ExtractUB: 307
  0, // ExtractC: 308
  0, // ExtractS: 309
  0, // ExtractI: 310
  0, // ExtractL: 311
  0, // ExtractF: 312
  0 // no trailing comma // ExtractD: 313
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R12",
  "R12_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R18",
  "R18_H",
  "R0",
  "R0_H",
  "R1",
  "R1_H",
  "R2",
  "R2_H",
  "R3",
  "R3_H",
  "R4",
  "R4_H",
  "R5",
  "R5_H",
  "R6",
  "R6_H",
  "R7",
  "R7_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R23",
  "R23_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R27",
  "R27_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "V16",
  "V16_H",
  "V16_J",
  "V16_K",
  "V17",
  "V17_H",
  "V17_J",
  "V17_K",
  "V18",
  "V18_H",
  "V18_J",
  "V18_K",
  "V19",
  "V19_H",
  "V19_J",
  "V19_K",
  "V20",
  "V20_H",
  "V20_J",
  "V20_K",
  "V21",
  "V21_H",
  "V21_J",
  "V21_K",
  "V22",
  "V22_H",
  "V22_J",
  "V22_K",
  "V23",
  "V23_H",
  "V23_J",
  "V23_K",
  "V24",
  "V24_H",
  "V24_J",
  "V24_K",
  "V25",
  "V25_H",
  "V25_J",
  "V25_K",
  "V26",
  "V26_H",
  "V26_J",
  "V26_K",
  "V27",
  "V27_H",
  "V27_J",
  "V27_K",
  "V28",
  "V28_H",
  "V28_J",
  "V28_K",
  "V29",
  "V29_H",
  "V29_J",
  "V29_K",
  "V30",
  "V30_H",
  "V30_J",
  "V30_K",
  "V31",
  "V31_H",
  "V31_J",
  "V31_K",
  "V0",
  "V0_H",
  "V0_J",
  "V0_K",
  "V1",
  "V1_H",
  "V1_J",
  "V1_K",
  "V2",
  "V2_H",
  "V2_J",
  "V2_K",
  "V3",
  "V3_H",
  "V3_J",
  "V3_K",
  "V4",
  "V4_H",
  "V4_J",
  "V4_K",
  "V5",
  "V5_H",
  "V5_J",
  "V5_K",
  "V6",
  "V6_H",
  "V6_J",
  "V6_K",
  "V7",
  "V7_H",
  "V7_J",
  "V7_K",
  "V8",
  "V8_H",
  "V8_J",
  "V8_K",
  "V9",
  "V9_H",
  "V9_J",
  "V9_K",
  "V10",
  "V10_H",
  "V10_J",
  "V10_K",
  "V11",
  "V11_H",
  "V11_J",
  "V11_K",
  "V12",
  "V12_H",
  "V12_J",
  "V12_K",
  "V13",
  "V13_H",
  "V13_J",
  "V13_K",
  "V14",
  "V14_H",
  "V14_J",
  "V14_K",
  "V15",
  "V15_H",
  "V15_J",
  "V15_K",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	r10->as_VMReg()        ,
	r10->as_VMReg()->next(),
	r11->as_VMReg()        ,
	r11->as_VMReg()->next(),
	r12->as_VMReg()        ,
	r12->as_VMReg()->next(),
	r13->as_VMReg()        ,
	r13->as_VMReg()->next(),
	r14->as_VMReg()        ,
	r14->as_VMReg()->next(),
	r15->as_VMReg()        ,
	r15->as_VMReg()->next(),
	r16->as_VMReg()        ,
	r16->as_VMReg()->next(),
	r17->as_VMReg()        ,
	r17->as_VMReg()->next(),
	r18->as_VMReg()        ,
	r18->as_VMReg()->next(),
	r0->as_VMReg()         ,
	r0->as_VMReg()->next() ,
	r1->as_VMReg()         ,
	r1->as_VMReg()->next() ,
	r2->as_VMReg()         ,
	r2->as_VMReg()->next() ,
	r3->as_VMReg()         ,
	r3->as_VMReg()->next() ,
	r4->as_VMReg()         ,
	r4->as_VMReg()->next() ,
	r5->as_VMReg()         ,
	r5->as_VMReg()->next() ,
	r6->as_VMReg()         ,
	r6->as_VMReg()->next() ,
	r7->as_VMReg()         ,
	r7->as_VMReg()->next() ,
	r19->as_VMReg()        ,
	r19->as_VMReg()->next(),
	r20->as_VMReg()        ,
	r20->as_VMReg()->next(),
	r21->as_VMReg()        ,
	r21->as_VMReg()->next(),
	r22->as_VMReg()        ,
	r22->as_VMReg()->next(),
	r23->as_VMReg()        ,
	r23->as_VMReg()->next(),
	r24->as_VMReg()        ,
	r24->as_VMReg()->next(),
	r25->as_VMReg()        ,
	r25->as_VMReg()->next(),
	r26->as_VMReg()        ,
	r26->as_VMReg()->next(),
	r27->as_VMReg()        ,
	r27->as_VMReg()->next(),
	r28->as_VMReg()        ,
	r28->as_VMReg()->next(),
	r29->as_VMReg()        ,
	r29->as_VMReg()->next(),
	r30->as_VMReg()        ,
	r30->as_VMReg()->next(),
	r31_sp->as_VMReg()     ,
	r31_sp->as_VMReg()->next(),
	v16->as_VMReg()         ,
	v16->as_VMReg()->next() ,
	v16->as_VMReg()->next(2),
	v16->as_VMReg()->next(3),
	v17->as_VMReg()         ,
	v17->as_VMReg()->next() ,
	v17->as_VMReg()->next(2),
	v17->as_VMReg()->next(3),
	v18->as_VMReg()         ,
	v18->as_VMReg()->next() ,
	v18->as_VMReg()->next(2),
	v18->as_VMReg()->next(3),
	v19->as_VMReg()         ,
	v19->as_VMReg()->next() ,
	v19->as_VMReg()->next(2),
	v19->as_VMReg()->next(3),
	v20->as_VMReg()         ,
	v20->as_VMReg()->next() ,
	v20->as_VMReg()->next(2),
	v20->as_VMReg()->next(3),
	v21->as_VMReg()         ,
	v21->as_VMReg()->next() ,
	v21->as_VMReg()->next(2),
	v21->as_VMReg()->next(3),
	v22->as_VMReg()         ,
	v22->as_VMReg()->next() ,
	v22->as_VMReg()->next(2),
	v22->as_VMReg()->next(3),
	v23->as_VMReg()         ,
	v23->as_VMReg()->next() ,
	v23->as_VMReg()->next(2),
	v23->as_VMReg()->next(3),
	v24->as_VMReg()         ,
	v24->as_VMReg()->next() ,
	v24->as_VMReg()->next(2),
	v24->as_VMReg()->next(3),
	v25->as_VMReg()         ,
	v25->as_VMReg()->next() ,
	v25->as_VMReg()->next(2),
	v25->as_VMReg()->next(3),
	v26->as_VMReg()         ,
	v26->as_VMReg()->next() ,
	v26->as_VMReg()->next(2),
	v26->as_VMReg()->next(3),
	v27->as_VMReg()         ,
	v27->as_VMReg()->next() ,
	v27->as_VMReg()->next(2),
	v27->as_VMReg()->next(3),
	v28->as_VMReg()         ,
	v28->as_VMReg()->next() ,
	v28->as_VMReg()->next(2),
	v28->as_VMReg()->next(3),
	v29->as_VMReg()         ,
	v29->as_VMReg()->next() ,
	v29->as_VMReg()->next(2),
	v29->as_VMReg()->next(3),
	v30->as_VMReg()         ,
	v30->as_VMReg()->next() ,
	v30->as_VMReg()->next(2),
	v30->as_VMReg()->next(3),
	v31->as_VMReg()         ,
	v31->as_VMReg()->next() ,
	v31->as_VMReg()->next(2),
	v31->as_VMReg()->next(3),
	v0->as_VMReg()          ,
	v0->as_VMReg()->next()  ,
	v0->as_VMReg()->next(2) ,
	v0->as_VMReg()->next(3) ,
	v1->as_VMReg()          ,
	v1->as_VMReg()->next()  ,
	v1->as_VMReg()->next(2) ,
	v1->as_VMReg()->next(3) ,
	v2->as_VMReg()          ,
	v2->as_VMReg()->next()  ,
	v2->as_VMReg()->next(2) ,
	v2->as_VMReg()->next(3) ,
	v3->as_VMReg()          ,
	v3->as_VMReg()->next()  ,
	v3->as_VMReg()->next(2) ,
	v3->as_VMReg()->next(3) ,
	v4->as_VMReg()          ,
	v4->as_VMReg()->next()  ,
	v4->as_VMReg()->next(2) ,
	v4->as_VMReg()->next(3) ,
	v5->as_VMReg()          ,
	v5->as_VMReg()->next()  ,
	v5->as_VMReg()->next(2) ,
	v5->as_VMReg()->next(3) ,
	v6->as_VMReg()          ,
	v6->as_VMReg()->next()  ,
	v6->as_VMReg()->next(2) ,
	v6->as_VMReg()->next(3) ,
	v7->as_VMReg()          ,
	v7->as_VMReg()->next()  ,
	v7->as_VMReg()->next(2) ,
	v7->as_VMReg()->next(3) ,
	v8->as_VMReg()          ,
	v8->as_VMReg()->next()  ,
	v8->as_VMReg()->next(2) ,
	v8->as_VMReg()->next(3) ,
	v9->as_VMReg()          ,
	v9->as_VMReg()->next()  ,
	v9->as_VMReg()->next(2) ,
	v9->as_VMReg()->next(3) ,
	v10->as_VMReg()         ,
	v10->as_VMReg()->next() ,
	v10->as_VMReg()->next(2),
	v10->as_VMReg()->next(3),
	v11->as_VMReg()         ,
	v11->as_VMReg()->next() ,
	v11->as_VMReg()->next(2),
	v11->as_VMReg()->next(3),
	v12->as_VMReg()         ,
	v12->as_VMReg()->next() ,
	v12->as_VMReg()->next(2),
	v12->as_VMReg()->next(3),
	v13->as_VMReg()         ,
	v13->as_VMReg()->next() ,
	v13->as_VMReg()->next(2),
	v13->as_VMReg()->next(3),
	v14->as_VMReg()         ,
	v14->as_VMReg()->next() ,
	v14->as_VMReg()->next(2),
	v14->as_VMReg()->next(3),
	v15->as_VMReg()         ,
	v15->as_VMReg()->next() ,
	v15->as_VMReg()->next(2),
	v15->as_VMReg()->next(3),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x1',  // R1
  (unsigned char)'\x1',  // R1_H
  (unsigned char)'\x2',  // R2
  (unsigned char)'\x2',  // R2_H
  (unsigned char)'\x3',  // R3
  (unsigned char)'\x3',  // R3_H
  (unsigned char)'\x4',  // R4
  (unsigned char)'\x4',  // R4_H
  (unsigned char)'\x5',  // R5
  (unsigned char)'\x5',  // R5_H
  (unsigned char)'\x6',  // R6
  (unsigned char)'\x6',  // R6_H
  (unsigned char)'\x7',  // R7
  (unsigned char)'\x7',  // R7_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\x10',  // V16
  (unsigned char)'\x10',  // V16_H
  (unsigned char)'\x10',  // V16_J
  (unsigned char)'\x10',  // V16_K
  (unsigned char)'\x11',  // V17
  (unsigned char)'\x11',  // V17_H
  (unsigned char)'\x11',  // V17_J
  (unsigned char)'\x11',  // V17_K
  (unsigned char)'\x12',  // V18
  (unsigned char)'\x12',  // V18_H
  (unsigned char)'\x12',  // V18_J
  (unsigned char)'\x12',  // V18_K
  (unsigned char)'\x13',  // V19
  (unsigned char)'\x13',  // V19_H
  (unsigned char)'\x13',  // V19_J
  (unsigned char)'\x13',  // V19_K
  (unsigned char)'\x14',  // V20
  (unsigned char)'\x14',  // V20_H
  (unsigned char)'\x14',  // V20_J
  (unsigned char)'\x14',  // V20_K
  (unsigned char)'\x15',  // V21
  (unsigned char)'\x15',  // V21_H
  (unsigned char)'\x15',  // V21_J
  (unsigned char)'\x15',  // V21_K
  (unsigned char)'\x16',  // V22
  (unsigned char)'\x16',  // V22_H
  (unsigned char)'\x16',  // V22_J
  (unsigned char)'\x16',  // V22_K
  (unsigned char)'\x17',  // V23
  (unsigned char)'\x17',  // V23_H
  (unsigned char)'\x17',  // V23_J
  (unsigned char)'\x17',  // V23_K
  (unsigned char)'\x18',  // V24
  (unsigned char)'\x18',  // V24_H
  (unsigned char)'\x18',  // V24_J
  (unsigned char)'\x18',  // V24_K
  (unsigned char)'\x19',  // V25
  (unsigned char)'\x19',  // V25_H
  (unsigned char)'\x19',  // V25_J
  (unsigned char)'\x19',  // V25_K
  (unsigned char)'\x1A',  // V26
  (unsigned char)'\x1A',  // V26_H
  (unsigned char)'\x1A',  // V26_J
  (unsigned char)'\x1A',  // V26_K
  (unsigned char)'\x1B',  // V27
  (unsigned char)'\x1B',  // V27_H
  (unsigned char)'\x1B',  // V27_J
  (unsigned char)'\x1B',  // V27_K
  (unsigned char)'\x1C',  // V28
  (unsigned char)'\x1C',  // V28_H
  (unsigned char)'\x1C',  // V28_J
  (unsigned char)'\x1C',  // V28_K
  (unsigned char)'\x1D',  // V29
  (unsigned char)'\x1D',  // V29_H
  (unsigned char)'\x1D',  // V29_J
  (unsigned char)'\x1D',  // V29_K
  (unsigned char)'\x1E',  // V30
  (unsigned char)'\x1E',  // V30_H
  (unsigned char)'\x1E',  // V30_J
  (unsigned char)'\x1E',  // V30_K
  (unsigned char)'\x1F',  // V31
  (unsigned char)'\x1F',  // V31_H
  (unsigned char)'\x1F',  // V31_J
  (unsigned char)'\x1F',  // V31_K
  (unsigned char)'\x0',  // V0
  (unsigned char)'\x0',  // V0_H
  (unsigned char)'\x0',  // V0_J
  (unsigned char)'\x0',  // V0_K
  (unsigned char)'\x1',  // V1
  (unsigned char)'\x1',  // V1_H
  (unsigned char)'\x1',  // V1_J
  (unsigned char)'\x1',  // V1_K
  (unsigned char)'\x2',  // V2
  (unsigned char)'\x2',  // V2_H
  (unsigned char)'\x2',  // V2_J
  (unsigned char)'\x2',  // V2_K
  (unsigned char)'\x3',  // V3
  (unsigned char)'\x3',  // V3_H
  (unsigned char)'\x3',  // V3_J
  (unsigned char)'\x3',  // V3_K
  (unsigned char)'\x4',  // V4
  (unsigned char)'\x4',  // V4_H
  (unsigned char)'\x4',  // V4_J
  (unsigned char)'\x4',  // V4_K
  (unsigned char)'\x5',  // V5
  (unsigned char)'\x5',  // V5_H
  (unsigned char)'\x5',  // V5_J
  (unsigned char)'\x5',  // V5_K
  (unsigned char)'\x6',  // V6
  (unsigned char)'\x6',  // V6_H
  (unsigned char)'\x6',  // V6_J
  (unsigned char)'\x6',  // V6_K
  (unsigned char)'\x7',  // V7
  (unsigned char)'\x7',  // V7_H
  (unsigned char)'\x7',  // V7_J
  (unsigned char)'\x7',  // V7_K
  (unsigned char)'\x8',  // V8
  (unsigned char)'\x8',  // V8_H
  (unsigned char)'\x8',  // V8_J
  (unsigned char)'\x8',  // V8_K
  (unsigned char)'\x9',  // V9
  (unsigned char)'\x9',  // V9_H
  (unsigned char)'\x9',  // V9_J
  (unsigned char)'\x9',  // V9_K
  (unsigned char)'\xA',  // V10
  (unsigned char)'\xA',  // V10_H
  (unsigned char)'\xA',  // V10_J
  (unsigned char)'\xA',  // V10_K
  (unsigned char)'\xB',  // V11
  (unsigned char)'\xB',  // V11_H
  (unsigned char)'\xB',  // V11_J
  (unsigned char)'\xB',  // V11_K
  (unsigned char)'\xC',  // V12
  (unsigned char)'\xC',  // V12_H
  (unsigned char)'\xC',  // V12_J
  (unsigned char)'\xC',  // V12_K
  (unsigned char)'\xD',  // V13
  (unsigned char)'\xD',  // V13_H
  (unsigned char)'\xD',  // V13_J
  (unsigned char)'\xD',  // V13_K
  (unsigned char)'\xE',  // V14
  (unsigned char)'\xE',  // V14_H
  (unsigned char)'\xE',  // V14_J
  (unsigned char)'\xE',  // V14_K
  (unsigned char)'\xF',  // V15
  (unsigned char)'\xF',  // V15_H
  (unsigned char)'\xF',  // V15_J
  (unsigned char)'\xF',  // V15_K
  (unsigned char)'\x20' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone(Compile* C) const {
  return  new (C) labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone(Compile* C) const {
  return  new (C) methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegINoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *iRegLNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *iRegPNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_PTR_REG_mask();
}

const RegMask *iRegP_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegP_R1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R1_REG_mask();
}

const RegMask *iRegP_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegP_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegP_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R4_REG_mask();
}

const RegMask *iRegP_R5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R5_REG_mask();
}

const RegMask *iRegP_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *iRegL_R11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R11_REG_mask();
}

const RegMask *iRegP_FPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_REG_mask();
}

const RegMask *iRegI_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R0_REG_mask();
}

const RegMask *iRegI_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R2_REG_mask();
}

const RegMask *iRegI_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R3_REG_mask();
}

const RegMask *iRegI_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R4_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegNNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegIHeapbaseOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &HEAPBASE_REG_mask();
}

const RegMask *vRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *vRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *vecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORD_REG_mask();
}

const RegMask *vecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_mask();
}

const RegMask *vRegD_V0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_REG_mask();
}

const RegMask *vRegD_V1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_REG_mask();
}

const RegMask *vRegD_V2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V2_REG_mask();
}

const RegMask *vRegD_V3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V3_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *inline_cache_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *interpreter_method_oop_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *thread_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &THREAD_REG_mask();
}

const RegMask *lr_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LR_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indIndexScaledOffsetIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOffsetI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indOffIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indirectNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledOffsetINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOffsetI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledOffsetI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indOffINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *thread_anchor_pcOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *iRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

//------------------Define members for classes derived from MachNode----------

// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode( MachNode* node, Compile* C) const {
  // This architecture does not have cisc or short branch instructions
  ShouldNotCallThis();
}

void overflowMulI_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulI_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void overflowMulL_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulL_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaDirectHandleNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP1Node::reloc() const {
  return 1;
}

int loadConPollPageNode::reloc() const {
  return 1;
}

int loadByteMapBaseNode::reloc() const {
  return 1;
}

int loadConF_packedNode::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_packedNode::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeimmCM0Node::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 3;
}

int storeimmB0Node::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 3;
}

int storeimmC0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeimmI0Node::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeimmL0Node::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeimmP0Node::reloc() const {
  return 3;
}

int storeNNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int prefetchrNode::reloc() const {
  return 1;
}

int prefetchwNode::reloc() const {
  return 1;
}

int prefetchntaNode::reloc() const {
  return 1;
}

int bytes_reverse_intNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_shortNode::reloc() const {
  return 1;
}

int bytes_reverse_shortNode::reloc() const {
  return 1;
}

int countLeadingZerosINode::reloc() const {
  return 1;
}

int countTrailingZerosINode::reloc() const {
  return 1;
}

int popCountINode::reloc() const {
  return 1;
}

int popCountI_memNode::reloc() const {
  return 1;
}

int popCountL_memNode::reloc() const {
  return 1;
}

int storePConditionalNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int cmovI_reg_regNode::reloc() const {
  return 2;
}

int cmovUI_reg_regNode::reloc() const {
  return 2;
}

int cmovI_zero_regNode::reloc() const {
  return 1;
}

int cmovUI_zero_regNode::reloc() const {
  return 1;
}

int cmovI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_zero_regNode::reloc() const {
  return 1;
}

int cmovUP_zero_regNode::reloc() const {
  return 1;
}

int addI_reg_regNode::reloc() const {
  return 2;
}

int addI_reg_immNode::reloc() const {
  return 1;
}

int addP_reg_reg_extNode::reloc() const {
  return 1;
}

int addP_reg_reg_ext_shiftNode::reloc() const {
  return 1;
}

int lshift_extNode::reloc() const {
  return 1;
}

int subI_reg_regNode::reloc() const {
  return 2;
}

int subI_reg_immNode::reloc() const {
  return 1;
}

int negI_regNode::reloc() const {
  return 1;
}

int negL_regNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 2;
}

int smulINode::reloc() const {
  return 2;
}

int smulI_0Node::reloc() const {
  return 2;
}

int maddINode::reloc() const {
  return 3;
}

int maddI_0Node::reloc() const {
  return 3;
}

int msubINode::reloc() const {
  return 3;
}

int divINode::reloc() const {
  return 2;
}

int signExtractNode::reloc() const {
  return 1;
}

int div2RoundNode::reloc() const {
  return 2;
}

int div2Round_0Node::reloc() const {
  return 2;
}

int modINode::reloc() const {
  return 2;
}

int lShiftI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_immNode::reloc() const {
  return 1;
}

int urShiftI_reg_regNode::reloc() const {
  return 2;
}

int urShiftI_reg_immNode::reloc() const {
  return 1;
}

int rShiftI_reg_regNode::reloc() const {
  return 2;
}

int rShiftI_reg_immNode::reloc() const {
  return 1;
}

int lShiftL_reg_regNode::reloc() const {
  return 1;
}

int urShiftL_reg_regNode::reloc() const {
  return 1;
}

int rShiftL_reg_regNode::reloc() const {
  return 1;
}

int regI_not_regNode::reloc() const {
  return 1;
}

int AndI_reg_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_2Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int SubI_reg_URShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_RShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_LShift_regNode::reloc() const {
  return 2;
}

int sbfmwINode::reloc() const {
  return 1;
}

int ubfmwINode::reloc() const {
  return 1;
}

int ubfxwINode::reloc() const {
  return 1;
}

int ubfxIConvI2LNode::reloc() const {
  return 1;
}

int extrOrINode::reloc() const {
  return 2;
}

int extrOrI_0Node::reloc() const {
  return 2;
}

int extrAddINode::reloc() const {
  return 2;
}

int extrAddI_0Node::reloc() const {
  return 2;
}

int AddExtINode::reloc() const {
  return 1;
}

int AddExtI_0Node::reloc() const {
  return 1;
}

int SubExtINode::reloc() const {
  return 1;
}

int AddExtI_sxthNode::reloc() const {
  return 2;
}

int AddExtI_sxth_0Node::reloc() const {
  return 2;
}

int AddExtI_sxtbNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtbNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtb_andNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_and_0Node::reloc() const {
  return 2;
}

int AddExtI_uxth_andNode::reloc() const {
  return 2;
}

int AddExtI_uxth_and_0Node::reloc() const {
  return 2;
}

int SubExtI_uxtb_andNode::reloc() const {
  return 2;
}

int SubExtI_uxth_andNode::reloc() const {
  return 2;
}

int andI_reg_regNode::reloc() const {
  return 2;
}

int andI_reg_immNode::reloc() const {
  return 1;
}

int orI_reg_regNode::reloc() const {
  return 2;
}

int orI_reg_immNode::reloc() const {
  return 1;
}

int xorI_reg_regNode::reloc() const {
  return 2;
}

int xorI_reg_immNode::reloc() const {
  return 1;
}

int convI2L_reg_regNode::reloc() const {
  return 1;
}

int convUI2L_reg_regNode::reloc() const {
  return 1;
}

int convI2BNode::reloc() const {
  return 1;
}

int convI2F_reg_regNode::reloc() const {
  return 1;
}

int convI2D_reg_regNode::reloc() const {
  return 1;
}

int overflowAddI_reg_regNode::reloc() const {
  return 2;
}

int overflowAddI_reg_immNode::reloc() const {
  return 1;
}

int overflowSubI_reg_regNode::reloc() const {
  return 2;
}

int overflowSubI_reg_immNode::reloc() const {
  return 1;
}

int overflowNegI_regNode::reloc() const {
  return 1;
}

int overflowMulI_regNode::reloc() const {
  return 2;
}

int overflowMulI_reg_branchNode::reloc() const {
  return 2;
}

int testP_regNode::reloc() const {
  return 1;
}

int compF_reg_zeroNode::reloc() const {
  return 1;
}

int compD_reg_zeroNode::reloc() const {
  return 1;
}

int compF3_reg_immF0Node::reloc() const {
  return 1;
}

int compD3_reg_immD0Node::reloc() const {
  return 1;
}

int cmpLTMask_reg_regNode::reloc() const {
  return 2;
}

int cmpLTMask_reg_zeroNode::reloc() const {
  return 1;
}

int cmpI_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int safePointNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectHandleNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int TailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int partialSubtypeCheckVsZeroNode::reloc() const {
  return 1;
}

int loadV4Node::reloc() const {
  return 1;
}

int loadV8Node::reloc() const {
  return 1;
}

int loadV16Node::reloc() const {
  return 1;
}

int storeV4Node::reloc() const {
  return 2;
}

int storeV8Node::reloc() const {
  return 2;
}

int storeV16Node::reloc() const {
  return 2;
}

int replicate8BNode::reloc() const {
  return 1;
}

int replicate16BNode::reloc() const {
  return 1;
}

int replicate4SNode::reloc() const {
  return 1;
}

int replicate8SNode::reloc() const {
  return 1;
}

int replicate2INode::reloc() const {
  return 1;
}

int replicate4INode::reloc() const {
  return 1;
}

int vshiftcntLNode::reloc() const {
  return 1;
}

int vshiftcntRNode::reloc() const {
  return 1;
}


void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsbw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8282 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1953 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8299 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1965 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8316 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1965 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8333 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1971 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrshw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8350 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1977 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8367 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1989 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8384 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1989 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8401 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2001 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8418 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2007 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8435 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 2001 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8453 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2013 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8470 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2001 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8487 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2013 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8504 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2001 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8521 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2013 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8538 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2001 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8555 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2019 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrs, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8572 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2025 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrd, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8589 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2596 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    u_int32_t con = (u_int32_t)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (con == 0) {
      __ movw(dst_reg, zr);
    } else {
      __ movw(dst_reg, con);
    }
  
#line 8611 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2607 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    u_int64_t con = (u_int64_t)opnd_array(1)->constantL();
    if (con == 0) {
      __ mov(dst_reg, zr);
    } else {
      __ mov(dst_reg, con);
    }
  
#line 8633 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL || con == (address)1) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      if (rtype == relocInfo::oop_type) {
        __ movoop(dst_reg, (jobject)con, /*immediate*/true);
      } else if (rtype == relocInfo::metadata_type) {
        __ mov_metadata(dst_reg, (Metadata*)con);
      } else {
        assert(rtype == relocInfo::none, "unexpected reloc type");
	if (con < (address)(uintptr_t)os::vm_page_size()) {
	  __ mov(dst_reg, con);
	} else {
	  unsigned long offset;
	  __ adrp(dst_reg, con, offset);
	  __ add(dst_reg, dst_reg, offset);
	}
      }
    }
  
#line 8669 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 8686 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConP1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2649 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, (u_int64_t)1);
  
#line 8703 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConPollPageNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2655 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address page = (address)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    unsigned long off;
    __ adrp(dst_reg, Address(page, relocInfo::poll_type), off);
    assert(off == 0, "assumed offset == 0");
  
#line 8723 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadByteMapBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2664 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address page = (address)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    unsigned long off;
    __ adrp(dst_reg, ExternalAddress(page), off);
    assert(off == 0, "assumed offset == 0");
  
#line 8743 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2673 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::oop_type, "unexpected reloc type");
      __ set_narrow_oop(dst_reg, (jobject)con);
    }
  
#line 8767 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2686 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 8784 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2692 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::metadata_type, "unexpected reloc type");
      __ set_narrow_klass(dst_reg, (Klass *)con);
    }
  
#line 8808 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConF_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5799 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), (double)opnd_array(1)->constantF());
  
#line 8824 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 8840 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 5818 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 8849 "../generated/adfiles/ad_aarch64.cpp"
  }
}
void loadConD_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5830 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constantD());
  
#line 8864 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 8880 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 5848 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 8889 "../generated/adfiles/ad_aarch64.cpp"
  }
}
void storeimmCM0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2055 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8906 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2049 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strb, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8924 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmB0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2055 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8942 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2061 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strh, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8960 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmC0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strh, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8978 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8996 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2079 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9014 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9040 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2099 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9058 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9084 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2099 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9102 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9120 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeImmN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(R27_enc);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9138 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strs, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9156 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2111 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strd, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9174 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 9192 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2486 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PLDL1KEEP);
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PLDL1KEEP);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PLDL1KEEP);
      }
    }
  
#line 9222 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2505 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1KEEP);
      __ nop();
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1KEEP);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1KEEP);
      }
    }
  
#line 9253 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchntaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2525 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1STRM);
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1STRM);
        __ nop();
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1STRM);
      }
    }
  
#line 9284 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6131 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ revw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 9300 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6144 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 9316 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6157 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 9332 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6171 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), 0U, 15U);
  
#line 9349 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 9365 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6199 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 9381 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6212 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rbitw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 9398 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6226 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rbit(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 9415 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void popCountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 6248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); // ensure top 32 bits 0
    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T1D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T1D, 0);
  
#line 9436 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void popCountI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 6269 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister tmp_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrs, tmp_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T1D, 0);
  
#line 9458 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void popCountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 6292 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T1D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T1D, 0);
  
#line 9478 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void popCountL_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 6312 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister tmp_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrd, tmp_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T1D, 0);
  
#line 9500 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 9516 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6345 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 9532 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6359 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 9548 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6372 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 9564 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 9580 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 9596 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6408 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 9612 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6421 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::StoreLoad);
    
#line 9628 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6437 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 9646 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6452 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 9664 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convP2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6467 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 9680 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convN2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6483 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 9696 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6498 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ encode_heap_oop(d, s);
  
#line 9714 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 9730 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6523 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop(d, s);
  
#line 9748 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6537 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop_not_null(d, s);
  
#line 9766 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6555 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ encode_klass_not_null(dst_reg, src_reg);
  
#line 9784 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6570 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (dst_reg != src_reg) {
      __ decode_klass_not_null(dst_reg, src_reg);
    } else {
      __ decode_klass_not_null(dst_reg);
    }
  
#line 9806 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch1, Address(base, disp));
        __ ldaxr(dst_reg, rscratch1);
      } else {
        // TODO
        // should we ever get anything other than this case?
        __ ldaxr(dst_reg, base);
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch1, Address(base, index_reg, Address::lsl(scale)));
        __ ldaxr(dst_reg, rscratch1);
      } else {
        __ lea(rscratch1, Address(base, disp));
        __ lea(rscratch1, Address(rscratch1, index_reg, Address::lsl(scale)));
	__ ldaxr(dst_reg, rscratch1);
      }
    }
  
#line 9885 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// heap_top_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2369 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register src_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        __ stlxr(rscratch1, src_reg, rscratch2);
      } else {
        // TODO
        // should we ever get anything other than this case?
        __ stlxr(rscratch1, src_reg, base);
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        __ stlxr(rscratch1, src_reg, rscratch2);
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
	__ stlxr(rscratch1, src_reg, rscratch2);
      }
    }
    __ cmpw(rscratch1, zr);
  
#line 9928 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2399 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9980 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 10032 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 10084 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 10094 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2399 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 10146 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 10156 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2399 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 10208 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 10218 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 10270 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 10280 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10297 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10314 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6807 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10331 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6816 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10348 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6827 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10365 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6838 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10382 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6848 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10399 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6859 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10416 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10433 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10450 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addIiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6890 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10467 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6901 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 10484 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6926 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10506 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6942 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10528 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10550 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6983 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10572 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6999 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10594 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7015 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10616 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7036 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     zr,
	     zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10641 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7055 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     zr,
	     zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10666 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7074 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10688 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7090 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10710 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7108 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10732 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7124 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10754 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7140 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10776 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7156 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10798 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7172 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10820 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7188 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10842 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7206 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10864 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7222 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10886 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7238 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10908 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7254 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10930 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7270 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10952 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7286 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10974 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7304 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10996 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7320 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 11018 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7336 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 11040 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7352 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 11062 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7369 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 11085 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7387 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 11108 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 11131 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7423 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 11154 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7452 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11173 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 11199 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_imm_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 11225 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7496 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11244 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
  
#line 11263 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_lslNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7526 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
		   Address::lsl(opnd_array(3)->constant())));
  
#line 11283 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_ext_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
		   Address::sxtw(opnd_array(3)->constant())));
  
#line 11303 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lshift_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7556 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sbfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
          opnd_array(2)->constant()& 63, MIN(32, (-opnd_array(2)->constant()) & 63));
  
#line 11322 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2721 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 11348 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7590 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11367 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2721 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 11393 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11412 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 11438 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7653 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11457 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2721 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 11483 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7685 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 11501 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 11519 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7717 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11538 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void smulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11557 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void smulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
	     as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 11576 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7749 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mul(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11595 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7765 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11614 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7782 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 11635 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 7782 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 11656 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void msubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ msubw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 11677 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7816 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 11698 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 7816 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 11719 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void msubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7832 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ msub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 11740 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2735 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 11760 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void signExtractNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7858 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 31);
  
#line 11778 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 31);
  
#line 11799 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2Round_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 31);
  
#line 11820 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2743 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 11840 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void signExtractLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7894 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 63);
  
#line 11858 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7905 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 63);
  
#line 11879 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7905 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 63);
  
#line 11900 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void modINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2751 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 11920 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void modLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2759 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 11940 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7949 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11959 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7965 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 11978 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7981 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11997 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 12016 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8013 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12035 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8029 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 12054 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8050 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12073 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8066 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x3f);
  
#line 12092 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8082 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12111 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8098 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 12130 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8114 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 12149 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8130 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12168 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8146 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 12187 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void regL_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8164 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 12207 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void regI_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8180 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 12227 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8197 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 12248 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8197 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 12269 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8214 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 12290 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8214 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 12311 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8231 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 12332 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8231 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 12353 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 12374 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8248 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 12395 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8265 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 12416 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8265 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 12437 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8282 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 12458 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8282 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 12479 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8299 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12502 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8299 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12525 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12548 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12571 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8335 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12594 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8335 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12617 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12640 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12663 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8371 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12686 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8371 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12709 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8389 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12732 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8389 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12755 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8407 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12778 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8407 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12801 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8407 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 12824 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8407 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12847 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8425 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12870 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8425 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12893 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8425 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 12916 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8425 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12939 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8443 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12962 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8443 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12985 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8443 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 13008 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8443 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13031 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13054 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13077 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 13100 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13123 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13146 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13169 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 13192 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13215 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13238 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13261 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 13284 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8497 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13307 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8515 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13330 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8515 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13353 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8533 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13376 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8533 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13399 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13422 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13445 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8569 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13468 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8569 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13491 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8587 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13514 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8587 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13537 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13560 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13583 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8624 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13605 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8624 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13627 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13649 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8643 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13671 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8662 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13693 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8662 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13715 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13737 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13759 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8700 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13781 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8700 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13803 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8719 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13825 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8719 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13847 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8738 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13869 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8738 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13891 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8757 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13913 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8757 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13935 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13957 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13979 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14001 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14023 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8814 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14045 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8814 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 14067 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8833 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14089 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8833 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 14111 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8852 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14133 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8852 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14155 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8871 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14177 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8871 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14199 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8890 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14221 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8890 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14243 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8909 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14265 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8909 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14287 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14309 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 14331 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14353 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 14375 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14397 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8966 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14419 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8985 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14441 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8985 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14463 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14485 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14507 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9023 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14529 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9023 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 14551 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9042 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14573 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9042 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 14595 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9061 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14617 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9061 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 14639 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9080 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14661 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9099 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14683 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9118 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14705 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 14727 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9156 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14749 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9175 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 14771 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sbfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9199 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ sbfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 14794 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sbfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9222 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 14817 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ ubfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 14840 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9268 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ ubfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 14863 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9287 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfxw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 14885 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9302 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constantL();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 14907 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9320 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 14929 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 14949 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 14969 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9355 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 14989 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9355 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 15009 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9370 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 15029 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9370 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 15049 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9385 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 15069 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9385 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 15089 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rolL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9401 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    rscratch1);
    
#line 15108 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rolI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9417 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    rscratch1);
    
#line 15127 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rorL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9469 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    
#line 15145 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rorI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9484 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    
#line 15163 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9535 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 15181 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9535 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 15199 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9548 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 15217 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9562 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 15237 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9562 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 15257 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9575 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 15277 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9575 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 15297 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9588 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 15317 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9588 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 15337 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9601 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 15357 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9601 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 15377 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9614 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 15397 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9614 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 15417 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9627 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 15437 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9627 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 15457 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9640 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 15477 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9640 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 15497 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 15516 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9654 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 15535 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 15554 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 15573 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9680 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 15592 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9680 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 15611 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 15630 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 15649 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9706 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 15668 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9706 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw);
   
#line 15687 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9719 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 15706 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 15725 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9745 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 15744 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9758 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 15763 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9771 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 15782 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15801 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9804 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ faddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15820 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9819 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15839 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9834 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15858 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9849 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmuls(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15877 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9864 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmuld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15896 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdivs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15915 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10027 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdivd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15934 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10042 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fnegs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15951 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10056 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fnegd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15968 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10069 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fabss(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15985 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10082 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fabsd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16002 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10095 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsqrtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16019 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10108 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsqrts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16036 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10130 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16055 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10145 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    (unsigned long)(opnd_array(2)->constant()));
  
#line 16074 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10162 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16093 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10177 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constant()));
  
#line 16112 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10194 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16131 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10209 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constant()));
  
#line 16150 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10227 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16169 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10242 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constantL()));
  
#line 16188 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10259 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16207 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10274 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (unsigned long)(opnd_array(2)->constantL()));
  
#line 16226 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16245 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10306 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (unsigned long)(opnd_array(2)->constantL()));
  
#line 16264 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10321 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sbfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 16280 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convUI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 10334 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ubfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 16297 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10347 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16313 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10364 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cset(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::NE);
  
#line 16330 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convP2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10382 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cset(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::NE);
  
#line 16347 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16363 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10409 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16379 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10422 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzsw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16395 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10435 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzs(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16411 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10448 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfws(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16427 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10461 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16443 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzdw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16459 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10487 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16475 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfwd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16491 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10513 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16507 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10532 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrw(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 16523 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10550 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 16539 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10568 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldr(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 16555 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10586 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 16571 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10604 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strs(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 16587 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10622 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 16603 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10640 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 16619 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10658 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ str(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 16635 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10676 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16651 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16667 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16683 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10730 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16699 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void clearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {

#line 2545 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register cnt_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */);
    Register base_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* base */);
    // base is word aligned
    // cnt is count of words

    Label loop;
    Label entry;

//  Algorithm:
//
//    scratch1 = cnt & 7;
//    cnt -= scratch1;
//    p += scratch1;
//    switch (scratch1) {
//      do {
//        cnt -= 8;
//          p[-8] = 0;
//        case 7:
//          p[-7] = 0;
//        case 6:
//          p[-6] = 0;
//          // ...
//        case 1:
//          p[-1] = 0;
//        case 0:
//          p += 8;
//      } while (cnt);
//    }

    const int unroll = 8; // Number of str(zr) instructions we'll unroll

    __ andr(rscratch1, cnt_reg, unroll - 1);  // tmp1 = cnt % unroll
    __ sub(cnt_reg, cnt_reg, rscratch1);      // cnt -= unroll
    // base_reg always points to the end of the region we're about to zero
    __ add(base_reg, base_reg, rscratch1, Assembler::LSL, exact_log2(wordSize));
    __ adr(rscratch2, entry);
    __ sub(rscratch2, rscratch2, rscratch1, Assembler::LSL, 2);
    __ br(rscratch2);
    __ bind(loop);
    __ sub(cnt_reg, cnt_reg, unroll);
    for (int i = -unroll; i < 0; i++)
      __ str(zr, Address(base_reg, i * wordSize));
    __ bind(entry);
    __ add(base_reg, base_reg, unroll * wordSize);
    __ cbnz(cnt_reg, loop);
  
#line 16760 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10763 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 16777 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 16794 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmn(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 16811 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10802 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmn(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 16828 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10815 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 16845 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10828 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 16862 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10841 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 16879 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10854 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 16896 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowNegI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    MacroAssembler _masm(&cbuf);

#line 10867 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 16913 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowNegL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    MacroAssembler _masm(&cbuf);

#line 10880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 16930 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10897 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 16951 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulI_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 10919 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ smull(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 16974 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10941 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mul(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 31);    // Top is pure sign ext
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 16996 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulL_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 10965 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ mul(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 31);    // Top is pure sign ext
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 17020 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2769 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 17039 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 17062 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 17085 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2787 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int32_t val = (u_int32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 17105 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2769 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 17124 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 17147 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 17170 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2787 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int32_t val = (u_int32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 17190 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 17209 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2802 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (u_int64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 17236 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2802 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (u_int64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 17263 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int64_t val = (u_int64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 17283 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2825 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 17302 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2832 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 17321 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2839 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmp(reg, zr);
  
#line 17339 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void testN_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2845 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmpw(reg, zr);
  
#line 17357 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11220 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17374 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11234 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0D);
  
#line 17391 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11249 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17408 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11263 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0D);
  
#line 17425 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11281 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 17451 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11309 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 17477 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF3_reg_immF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11336 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, 0.0D);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 17502 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD3_reg_immD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11363 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, 0.0D);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 17527 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11392 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 17546 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 11413 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* p */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* q */));
    __ csetw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::LT);
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 17565 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11431 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 31);
  
#line 17582 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void minI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11454 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             Assembler::LT);
  
#line 17604 "../generated/adfiles/ad_aarch64.cpp"
  }
}

uint minI_rRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void maxI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11480 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             Assembler::GT);
  
#line 17631 "../generated/adfiles/ad_aarch64.cpp"
  }
}

uint maxI_rRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(1)->label();
    __ b(*L);
  
#line 17653 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2857 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 17672 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2863 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 17691 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 17715 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11583 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 17739 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11602 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 17763 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2857 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 17782 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchLoopEndUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2863 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 17801 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 3004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register oop = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* object */);
    Register box = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* box */);
    Register disp_hdr = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    Register tmp = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* tmp2 */);
    Label cont;
    Label object_has_monitor;
    Label cas_failed;

    assert_different_registers(oop, box, tmp, disp_hdr);

    // Load markOop from object into displaced_header.
    __ ldr(disp_hdr, Address(oop, oopDesc::mark_offset_in_bytes()));

    // Always do locking in runtime.
    if (EmitSync & 0x01) {
      __ cmp(oop, zr);
      return;
    }
    
    if (UseBiasedLocking) {
      __ biased_locking_enter(disp_hdr, oop, box, tmp, true, cont);
    }

    // Handle existing monitor
    if (EmitSync & 0x02) {
      // we can use AArch64's bit test and branch here but
      // markoopDesc does not define a bit index just the bit value
      // so assert in case the bit pos changes
#     define __monitor_value_log2 1
      assert(markOopDesc::monitor_value == (1 << __monitor_value_log2), "incorrect bit position");
      __ tbnz(disp_hdr, __monitor_value_log2, object_has_monitor);
#     undef __monitor_value_log2
    }

    // Set displaced_header to be (markOop of object | UNLOCK_VALUE).
    __ orr(disp_hdr, disp_hdr, markOopDesc::unlocked_value);

    // Load Compare Value application register.

    // Initialize the box. (Must happen before we update the object mark!)
    __ str(disp_hdr, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // Compare object markOop with mark and if equal exchange scratch1
    // with object markOop.
    // Note that this is simply a CAS: it does not generate any
    // barriers.  These are separately generated by
    // membar_acquire_lock().
    {
      Label retry_load;
      __ bind(retry_load);
      __ ldxr(tmp, oop);
      __ cmp(tmp, disp_hdr);
      __ br(Assembler::NE, cas_failed);
      // use stlxr to ensure update is immediately visible
      __ stlxr(tmp, box, oop);
      __ cbzw(tmp, cont);
      __ b(retry_load);
    }

    // Formerly:
    // __ cmpxchgptr(/*oldv=*/disp_hdr,
    //               /*newv=*/box,
    //               /*addr=*/oop,
    //               /*tmp=*/tmp,
    //               cont,
    //               /*fail*/NULL);

    assert(oopDesc::mark_offset_in_bytes() == 0, "offset of _mark is not 0");

    // If the compare-and-exchange succeeded, then we found an unlocked
    // object, will have now locked it will continue at label cont

    __ bind(cas_failed);
    // We did not see an unlocked object so try the fast recursive case.

    // Check if the owner is self by comparing the value in the
    // markOop of object (disp_hdr) with the stack pointer.
    __ mov(rscratch1, sp);
    __ sub(disp_hdr, disp_hdr, rscratch1);
    __ mov(tmp, (address) (~(os::vm_page_size()-1) | markOopDesc::lock_mask_in_place));
    // If condition is true we are cont and hence we can store 0 as the
    // displaced header in the box, which indicates that it is a recursive lock.
    __ ands(tmp/*==0?*/, disp_hdr, tmp);
    __ str(tmp/*==0, perhaps*/, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ b(cont);

      __ bind(object_has_monitor);
      // The object's monitor m is unlocked iff m->owner == NULL,
      // otherwise m->owner may contain a thread or a stack address.
      //
      // Try to CAS m->owner from NULL to current thread.
      __ add(tmp, disp_hdr, (ObjectMonitor::owner_offset_in_bytes()-markOopDesc::monitor_value));
      __ mov(disp_hdr, zr);

      {
	Label retry_load, fail;
	__ bind(retry_load);
	__ ldxr(rscratch1, tmp);
	__ cmp(disp_hdr, rscratch1);
	__ br(Assembler::NE, fail);
        // use stlxr to ensure update is immediately visible
	__ stlxr(rscratch1, rthread, tmp);
	__ cbnzw(rscratch1, retry_load);
	__ bind(fail);
      }

      // Label next;
      // __ cmpxchgptr(/*oldv=*/disp_hdr,
      //               /*newv=*/rthread,
      //               /*addr=*/tmp,
      //               /*tmp=*/rscratch1,
      //               /*succeed*/next,
      //               /*fail*/NULL);
      // __ bind(next);

      // store a non-null value into the box.
      __ str(box, Address(box, BasicLock::displaced_header_offset_in_bytes()));

      // PPC port checks the following invariants
      // #ifdef ASSERT
      // bne(flag, cont);
      // We have acquired the monitor, check some invariants.
      // addw(/*monitor=*/tmp, tmp, -ObjectMonitor::owner_offset_in_bytes());
      // Invariant 1: _recursions should be 0.
      // assert(ObjectMonitor::recursions_size_in_bytes() == 8, "unexpected size");
      // assert_mem8_is_zero(ObjectMonitor::recursions_offset_in_bytes(), tmp,
      //                        "monitor->_recursions should be 0", -1);
      // Invariant 2: OwnerIsThread shouldn't be 0.
      // assert(ObjectMonitor::OwnerIsThread_size_in_bytes() == 4, "unexpected size");
      //assert_mem4_isnot_zero(ObjectMonitor::OwnerIsThread_offset_in_bytes(), tmp,
      //                           "monitor->OwnerIsThread shouldn't be 0", -1);
      // #endif
    }

    __ bind(cont);
    // flag == EQ indicates success
    // flag == NE indicates failure

  
#line 17960 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 3152 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register oop = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* object */);
    Register box = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* box */);
    Register disp_hdr = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    Register tmp = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* tmp2 */);
    Label cont;
    Label object_has_monitor;
    Label cas_failed;

    assert_different_registers(oop, box, tmp, disp_hdr);

    // Always do locking in runtime.
    if (EmitSync & 0x01) {
      __ cmp(oop, zr); // Oop can't be 0 here => always false.
      return;
    }

    if (UseBiasedLocking) {
      __ biased_locking_exit(oop, tmp, cont);
    }

    // Find the lock address and load the displaced header from the stack.
    __ ldr(disp_hdr, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // If the displaced header is 0, we have a recursive unlock.
    __ cmp(disp_hdr, zr);
    __ br(Assembler::EQ, cont);


    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ ldr(tmp, Address(oop, oopDesc::mark_offset_in_bytes()));
      __ tbnz(disp_hdr, exact_log2(markOopDesc::monitor_value), object_has_monitor);
    }

    // Check if it is still a light weight lock, this is is true if we
    // see the stack address of the basicLock in the markOop of the
    // object.

      {
	Label retry_load;
	__ bind(retry_load);
	__ ldxr(tmp, oop);
	__ cmp(box, tmp);
	__ br(Assembler::NE, cas_failed);
        // use stlxr to ensure update is immediately visible
	__ stlxr(tmp, disp_hdr, oop);
	__ cbzw(tmp, cont);
	__ b(retry_load);
      }

    // __ cmpxchgptr(/*compare_value=*/box,
    //               /*exchange_value=*/disp_hdr,
    //               /*where=*/oop,
    //               /*result=*/tmp,
    //               cont,
    //               /*cas_failed*/NULL);
    assert(oopDesc::mark_offset_in_bytes() == 0, "offset of _mark is not 0");

    __ bind(cas_failed);

    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ b(cont);

      __ bind(object_has_monitor);
      __ add(tmp, tmp, -markOopDesc::monitor_value); // monitor
      __ ldr(rscratch1, Address(tmp, ObjectMonitor::owner_offset_in_bytes()));
      __ ldr(disp_hdr, Address(tmp, ObjectMonitor::recursions_offset_in_bytes()));
      __ eor(rscratch1, rscratch1, rthread); // Will be 0 if we are the owner.
      __ orr(rscratch1, rscratch1, disp_hdr); // Will be 0 if there are 0 recursions
      __ cmp(rscratch1, zr);
      __ br(Assembler::NE, cont);

      __ ldr(rscratch1, Address(tmp, ObjectMonitor::EntryList_offset_in_bytes()));
      __ ldr(disp_hdr, Address(tmp, ObjectMonitor::cxq_offset_in_bytes()));
      __ orr(rscratch1, rscratch1, disp_hdr); // Will be 0 if both are 0.
      __ cmp(rscratch1, zr);
      __ br(Assembler::NE, cont);
      // need a release store here
      __ lea(tmp, Address(tmp, ObjectMonitor::owner_offset_in_bytes()));
      __ stlr(rscratch1, tmp);
    }

    __ bind(cont);
    // flag == EQ indicates success
    // flag == NE indicates failure
  
#line 18064 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void safePointNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11700 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ read_polling_page(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* poll */), relocInfo::poll_type);
  
#line 18080 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2887 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    address mark = __ pc();
    address addr = (address)opnd_array(1)->method();
    if (!_method) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      __ bl(Address(addr, relocInfo::runtime_call_type));
    } else if (_optimized_virtual) {
      __ bl(Address(addr, relocInfo::opt_virtual_call_type));
    } else {
      __ bl(Address(addr, relocInfo::static_call_type));
    }

    if (_method) {
      // Emit stub for static call
      CompiledStaticCall::emit_to_interp_stub(cbuf, mark);
    }
  
#line 18111 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 18123 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectHandleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// reg_mh_save
  {

#line 2907 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    relocInfo::relocType reloc;

    // TODO fixme
    // this is supposed to preserve and restore SP around the call
    // need to check it works
    __ mov(rfp, sp);

    address mark = __ pc();
    address addr = (address)opnd_array(1)->method();
    if (!_method) {
      // TODO check this
      // think we are calling generated Java here not x86
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      __ bl(Address(addr, relocInfo::runtime_call_type));
    } else if (_optimized_virtual) {
      __ bl(Address(addr, relocInfo::opt_virtual_call_type));
    } else {
      __ bl(Address(addr, relocInfo::static_call_type));
    }

    if (_method) {
      // Emit stub for static call
      CompiledStaticCall::emit_to_interp_stub(cbuf, mark);
    }

    // now restore sp
    __ mov(sp, rfp);
  
#line 18165 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 18177 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2938 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ ic_call((address)opnd_array(1)->method());
  
#line 18193 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 18205 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2951 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaThread::pd_last_frame().
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
      __ bind(retaddr);
      __ add(sp, sp, 2 * wordSize);
    }
  
#line 18243 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2951 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaThread::pd_last_frame().
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
      __ bind(retaddr);
      __ add(sp, sp, 2 * wordSize);
    }
  
#line 18281 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2951 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaThread::pd_last_frame().
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
      __ bind(retaddr);
      __ add(sp, sp, 2 * wordSize);
    }
  
#line 18319 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2988 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    __ br(target_reg);
  
#line 18337 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void TailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2994 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    // exception oop should be in r0
    // ret addr has been popped into lr
    // callee expects it in r3
    __ mov(r3, lr);
    __ br(target_reg);
  
#line 18359 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2978 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ b(RuntimeAddress(OptoRuntime::rethrow_stub()));
  
#line 18388 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2983 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ ret(lr);
  
#line 18404 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO
    // implement proper trap call here
    __ brk(999);
  
#line 18422 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 2870 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(opnd_array(0)->reg(ra_,this)/* result */);

     Label miss;
     MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x1 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 18451 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void partialSubtypeCheckVsZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 2870 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(R5_enc);

     Label miss;
     MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x0 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 18481 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_compareNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    MacroAssembler _masm(&cbuf);

#line 11956 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc));
  
#line 18502 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_indexofNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 11972 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 18529 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_indexof_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 11991 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 18557 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 12009 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
		      opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc));
  
#line 18577 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void array_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  {
    MacroAssembler _masm(&cbuf);

#line 12024 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ char_arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                          opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc));
  
#line 18595 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  {
    MacroAssembler _masm(&cbuf);

#line 12042 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
         opnd_array(0)->as_Register(ra_,this)/* result */, as_FloatRegister(V0_enc),  as_FloatRegister(V1_enc),
         as_FloatRegister(V2_enc),  as_FloatRegister(V3_enc));
  
#line 18615 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void loadV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2031 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::S,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 18645 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2037 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::D,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 18662 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2043 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::Q,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 18679 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2117 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::S,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 18697 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2123 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::D,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 18715 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2129 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::Q,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 18733 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12144 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18749 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12156 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18765 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate8B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12169 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B, opnd_array(1)->constant()& 0xff);
  
#line 18781 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12181 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B, opnd_array(1)->constant()& 0xff);
  
#line 18797 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12194 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18813 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12206 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18829 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12219 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H, opnd_array(1)->constant()& 0xffff);
  
#line 18845 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12231 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H, opnd_array(1)->constant()& 0xffff);
  
#line 18861 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12243 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18877 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12255 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18893 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12267 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S, opnd_array(1)->constant());
  
#line 18909 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12279 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mov(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S, opnd_array(1)->constant());
  
#line 18925 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18941 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate2L_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 12303 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
           as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
           as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 18959 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18976 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12330 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 18993 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void replicate2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12343 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 19010 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12361 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19029 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19048 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12390 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19067 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12404 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19086 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12418 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19105 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12432 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19124 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12446 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19143 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12460 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fadd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19162 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fadd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19181 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vadd2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12487 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fadd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19200 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12504 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19219 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12518 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19238 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12533 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19257 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12547 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19276 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12561 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19295 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12575 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19314 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12589 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19333 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12603 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsub(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19352 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12617 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsub(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19371 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsub2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12631 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsub(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19390 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12648 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19409 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12662 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19428 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12676 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19447 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12690 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19466 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12704 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmul(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19485 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12718 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmul(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19504 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vmul2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmul(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19523 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vdiv2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12748 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdiv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19542 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vdiv4FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12762 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdiv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19561 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vdiv2DNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdiv(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19580 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vand8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12793 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19599 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vand16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12807 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19618 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vor8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12824 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19637 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vor16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12838 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19656 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vxor8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12855 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19675 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vxor16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19694 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vshiftcntLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 12882 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */));
  
#line 19710 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vshiftcntRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 12892 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ dup(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */));
    __ negr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B, as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 19727 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12906 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 19746 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll8B_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12906 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 19765 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12920 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 19784 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll16B_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12920 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 19803 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12934 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 19822 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl16BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 19841 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll8B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12961 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 8) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
    }
  
#line 19866 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 12980 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 8) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
    }
  
#line 19891 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra8B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13000 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 8) sh = 7;
    sh = -sh & 7;
    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
  
#line 19912 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13015 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 8) sh = 7;
    sh = -sh & 7;
    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
  
#line 19933 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl8B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13031 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 8) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), -sh & 7);
    }
  
#line 19958 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl16B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13050 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 8) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), -sh & 7);
    }
  
#line 19983 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13071 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20002 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll4S_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13071 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20021 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20040 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll8S_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13085 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20059 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13099 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20078 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl8SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13112 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20097 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13126 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 16) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
    }
  
#line 20122 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13145 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 16) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
    }
  
#line 20147 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13165 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 16) sh = 15;
    sh = -sh & 15;
    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
  
#line 20168 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13180 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 16) sh = 15;
    sh = -sh & 15;
    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), sh);
  
#line 20189 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13196 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 16) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4H,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), -sh & 15);
    }
  
#line 20214 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl8S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13215 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int sh = (int)opnd_array(2)->constant()& 31;
    if (sh >= 16) {
      __ eor(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T16B,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    } else {
      __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T8H,
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), -sh & 15);
    }
  
#line 20239 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20258 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll2I_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20277 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13249 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20296 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll4I_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13249 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20315 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13262 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20334 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl4INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13275 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20353 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13288 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
           (int)opnd_array(2)->constant()& 31);
  
#line 20372 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13301 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
           (int)opnd_array(2)->constant()& 31);
  
#line 20391 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13314 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            -(int)opnd_array(2)->constant()& 31);
  
#line 20410 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13327 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            -(int)opnd_array(2)->constant()& 31);
  
#line 20429 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            -(int)opnd_array(2)->constant()& 31);
  
#line 20448 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl4I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T4S,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            -(int)opnd_array(2)->constant()& 31);
  
#line 20467 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20486 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20505 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13380 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20524 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsll2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13393 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ shl(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
           as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
           (int)opnd_array(2)->constant()& 63);
  
#line 20543 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsra2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13406 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sshr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            -(int)opnd_array(2)->constant()& 63);
  
#line 20562 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void vsrl2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 13419 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ushr(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), __ T2D,
            as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            -(int)opnd_array(2)->constant()& 63);
  
#line 20581 "../generated/adfiles/ad_aarch64.cpp"
  }
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchntaNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const TypePtr *load_fenceNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* load_fenceNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *store_fenceNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* store_fenceNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_releaseNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_releaseNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_storestoreNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_storestoreNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_lockNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV16Node::memory_operand() const { return _opnds[1]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // RegFlags
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    false,  // AbsI
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // CProj
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastII
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // CosD
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    false,  // ExpD
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // Goto
    true ,  // Halt
    true ,  // If
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // LogD
    false,  // Log10D
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachProj
    true ,  // MaxI
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // Opaque1
    false,  // Opaque2
    false,  // Opaque3
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    true ,  // OverflowMulI
    true ,  // OverflowAddL
    true ,  // OverflowSubL
    true ,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    false,  // PowD
    true ,  // PrefetchAllocation
    true ,  // PrefetchRead
    true ,  // PrefetchWrite
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    false,  // RoundDouble
    false,  // RoundFloat
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SCMemProj
    false,  // SinD
    true ,  // SqrtD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // TanD
    true ,  // ThreadLocal
    false,  // Unlock
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddVL
    true ,  // AddVF
    true ,  // AddVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVS
    true ,  // MulVI
    true ,  // MulVF
    true ,  // MulVD
    true ,  // DivVF
    true ,  // DivVD
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    true ,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    true ,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    true ,  // RShiftVL
    true ,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // OrV
    true ,  // XorV
    true ,  // LoadVector
    true ,  // StoreVector
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // ReplicateB
    true ,  // ReplicateS
    true ,  // ReplicateI
    true ,  // ReplicateL
    true ,  // ReplicateF
    true ,  // ReplicateD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false   // ExtractD
};


bool Matcher::stack_direction() const { return false; }

int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              round_to((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::in_preserve_stack_slots() { return 4; }

uint Compile::out_preserve_stack_slots() { return SharedRuntime::out_preserve_stack_slots(); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes/BytesPerInt; }

void Matcher::calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length, bool is_outgoing) {

#line 3362 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // No difference between ingoing/outgoing just pass false
    SharedRuntime::java_calling_convention(sig_bt, regs, length, false);
  
#line 21014 "../generated/adfiles/ad_aarch64.cpp"

}

void Matcher::c_calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length) {

#line 3368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // This is obviously always outgoing
    (void) SharedRuntime::c_calling_convention(sig_bt, regs, NULL, length);
  
#line 21025 "../generated/adfiles/ad_aarch64.cpp"

}

OptoRegPair Matcher::return_value(int ideal_reg, bool is_outgoing) {

#line 3375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };
  
    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                       // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 21061 "../generated/adfiles/ad_aarch64.cpp"

}

OptoRegPair Matcher::c_return_value(int ideal_reg, bool is_outgoing) {

#line 3375 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.65-2.b17.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };
  
    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                       // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 21097 "../generated/adfiles/ad_aarch64.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(R12_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_method_oop_reg() { return OptoReg::Name(R12_num); }

int Matcher::interpreter_method_oop_reg_encode() { return _regEncode[interpreter_method_oop_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(R29_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(R31_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
